
#ifndef _GenMatUtil_BasisSimple
#define _GenMatUtil_BasisSimple


	Vector<int> BasisSimple(const Matrix<double> &A);
	Vector<int> BasisSimple(const Matrix<double> &A, double Tol);	
	
	Matrix<double> RowDependencies(const Matrix<double> &A, const Vector<int> &Piv);
	void PrintRowDependencies(const Matrix<double> &A);
	void PrintRowDependencies(const SymmetricMatrix<double> &A);
	void PrintRowDependencies(const Matrix<double> &A, const Vector<string> &Labels);
	void PrintRowDependencies(const SymmetricMatrix<double> &A, const Vector<string> &Labels);
	void PrintRowDependencies(const Matrix<double>          &A, const Vector<string> &Labels, double Tol);
	void PrintRowDependencies(const SymmetricMatrix<double> &A, const Vector<string> &Labels, double Tol);
	void PrintRowDependencies(const SymmetricMatrix<double> &A, const Matrix<double> &Z, const Vector<string> &Labels);
	void PrintRowDependencies(const SymmetricMatrix<double> &A, const Matrix<double> &Z, const Vector<string> &Labels, double Tol);
	
double BasisSimpleTol = 0.000000000001;

Vector<int> BasisSimple(const Matrix<double> &A)
{
	Print("Calling BasisSimple");

	/* [rows,cols] = size (A); */
	    
	int m = A.Rows();
    int n = A.Cols();
    int r = Rank(A);
    
    Print("m",m);
    Print("n",n);
    Print("r",r);
    
	//Matrix<double> ACopy = A.Copy();

	/*
	int i = 0;
	int j = 0;
	
	Vector<int> Piv(m,0);
	
	while(i < m  && j < n)
	{
		/* Find pivot in column j, starting in row i: */
	/*	double max_val = ACopy(i,j);
		int max_ind = i;
		for(int k=i+1; k<m; k++)
		{
			double val = ACopy(k,j);
			if(abs(val) > abs(max_val))
			{
				max_val = val;
				max_ind = k;
			}
		}
		
		if(abs(max_val) >= BasisSimpleTol)
		{
		
			Piv[max_ind] = 1;
		
			// switch rows i and max_ind
			
			if(i != max_ind)
			{
				for(int l=0; l<n; l++)
				{
					double Temp = ACopy(i,l);
					ACopy(i,l) = ACopy(max_ind,l);
					ACopy(max_ind,l) = Temp;
				}
			}
			
			// divide row i by max_val
			
			for(int l=0; l<n; l++) ACopy(max_ind,l) /= max_val;
			
			for(int u=0; u<m; u++)
			{
				
				double Temp = ACopy(u,j);
			
				if(u != i)
				{
					//subtract A[u,j] * row i from row u
					
					for(int l=0; l<n; l++) ACopy(u,l) -= Temp * ACopy(i,l);
					
				}
			}
						
			i++;
		}
		j++;
	}
	*/
	
	/* Do Things the BRute Force Way */
	
	Vector<int> Piv(m,0);
	Piv.Name = "BasisSimple::Piv";
		
	int CurrRow  = 0;
	int CurrRank = 0;
	
	Print("Bef While");
				
	while(CurrRank < r && CurrRow < m)
	{
		Print("CurrRank",CurrRank);
	
		Matrix<double> M(CurrRank+1,n);
		M.Name = "BasisSimple::M";
							
		int Curr = 0;
		
		Print("Part A");
		
		for(int i=0; i<CurrRow; i++)
		{
			if(Piv(i) == 1)
			{
				for(int j=0; j<n; j++) M(Curr,j) = A(i,j);
				Curr++;
			}
		}
		
		Print("Part B");
		
		for(int j=0; j<n; j++) M(Curr,j) = A(CurrRow,j);
		
		if(Rank(M) > CurrRank)
		{
			Piv(CurrRow) = 1;
			CurrRank++;
		}
		else
		{
			Piv(CurrRow) = 0;
		}
		
		CurrRow++;
	}
	
	Print("After While");
	
	return Piv;
}

Vector<int> BasisSimple(const Matrix<double> &A, double Tol)
{
	int m = A.Rows();
    int n = A.Cols();
    int r = Rank(A,Tol);
    
    Print("BasisSimple(Matrix<double> A, double Tol)::Tol",Tol);
    Print("BasisSimple(Matrix<double> A, double Tol)::r",r);
    
	Vector<int> Piv(m,0);
	Piv.Name = "BasisSimple::Piv";
		
	int CurrRow  = 0;
	int CurrRank = 0;
	
	while(CurrRank < r && CurrRow < m)
	{
		Matrix<double> M(CurrRank+1,n);
		M.Name = "BasisSimple::M";
							
		int Curr = 0;
		for(int i=0; i<CurrRow; i++)
		{
			if(Piv(i) == 1)
			{
				for(int j=0; j<n; j++) M(Curr,j) = A(i,j);
				Curr++;
			}
		}
		
		for(int j=0; j<n; j++) M(Curr,j) = A(CurrRow,j);
		
		if(Rank(M,Tol) > CurrRank)
		{
			Piv(CurrRow) = 1;
			CurrRank++;
		}
		else
		{
			Piv(CurrRow) = 0;
		}
		
		CurrRow++;
	}
	
	Print("BasisSimple::Piv",Piv);
	
	return Piv;
}


Matrix<double> RowDependencies(const Matrix<double> &A, const Vector<int> &Piv)
{
	Print("Calling RowDependencies");

	int k = Sum(Piv);
	int m = A.Rows();
	int n = A.Cols();
	
	Matrix<double> R(k,n);		R.Name = "R";
	Matrix<double> S(m-k,n);	S.Name = "S";
	
	int CurrR = 0;
	int CurrS = 0;
	
	for(int i=0; i<m; i++)
	{
		if(Piv[i])
		{
			for(int j=0; j<n; j++) R(CurrR,j) = A(i,j);
			CurrR++;
		}
		else
		{
			for(int j=0; j<n; j++) S(CurrS,j) = A(i,j);
			CurrS++;
		}
	}
	
	Matrix<double> C = Transpose(Inverse(R * Transpose(R)) * R * Transpose(S));
	C.Name = "C";
	
	Vector<int> Idx1(k);	Idx1.Name = "RowDependencies::Idx1";
	Vector<int> Idx2(m-k);	Idx2.Name = "RowDependencies::Idx2";
	CurrR = 0;
	CurrS = 0;
	for(int i=0; i<m; i++)
	{
		if(Piv[i]) Idx1[CurrR++] = i;
		else       Idx2[CurrS++] = i;
	}
	
	Print("Idx1",Idx1);
	Print("Idx2",Idx2);
	
	Matrix<double> C2(m-k,n,Zero);	C2.Name = "C2";
	
	for(int i=0; i<m-k; i++)
	{
		int Curr2 = 0;
		for(int j=0; j<n; j++)
		{
			if(Piv[j] == 1)
			{
				C2(i,Idx1[Curr2]) = C(i,Curr2);
				Curr2++;
			}
		}
		C2(i,Idx2[i]) = -1.0;
	}

	return C2;
}

void PrintRowDependencies(const Matrix<double> &A)
{
	Vector<int> Piv = BasisSimple(A);
	int n = A.Cols();
	Vector<string> Labels(n);
	Labels.Name = "PrintRowDependencies(Matrix)::Labels";
	for(int i=0; i<n; i++) Labels[i] = "Row" + ToString(i);
	Matrix<double> C = RowDependencies(A,Piv);
	Vector<double> b(C.Rows(),0.0);
	b.Name = "PrintRowDependencies(Matrix)::b";
	PrintLinearEquation(C,b,Labels);
}

void PrintRowDependencies(const SymmetricMatrix<double> &A)
{
	int n = A.Dim();
	Matrix<double> A1(n,n);
	Copy(A1,A);
	Vector<int> Piv = BasisSimple(A1);
	Vector<string> Labels(n);
	Labels.Name = "PrintRowDependencies(SymmetricMatrix)::Labels";
	for(int i=0; i<n; i++) Labels[i] = "Row" + ToString(i);
	Matrix<double> C = RowDependencies(A1,Piv);
	Vector<double> b(C.Rows(),0.0);
	b.Name = "PrintRowDependencies(Matrix)::b";
	PrintLinearEquation(C,b,Labels);
}

void PrintRowDependencies(const Matrix<double> &A, const Vector<string> &Labels)
{
	Vector<int> Piv = BasisSimple(A);
	Matrix<double> C = RowDependencies(A,Piv);
	C.Name = "PrintRowDependencies(Matrix,Vector)::C";
	Vector<double> b(C.Rows(),0.0);
	b.Name = "PrintRowDependencies(Matrix,Vector)::b";
	PrintLinearEquation(C,b,Labels);
}

void PrintRowDependencies(const SymmetricMatrix<double> &A, const Vector<string> &Labels)
{
	int n = A.Dim();
	
	if(Labels.Size() != n)
	{
		Print("Error in PrintRowDependencies(SymmetricMatrix,Vector)");
		Print("Incompadible Dimensions");
		Print("A.Name",A.Name);
		Print("Labels.Name",Labels.Name);
		Print("A.Size()",A.Size());
		Print("Labels.Size()",Labels.Size());
		HaltExecution();
	}
	
	Matrix<double> A1(n,n);
	Copy(A1,A);
	Vector<int> Piv = BasisSimple(A1);
	Matrix<double> C = RowDependencies(A1,Piv);
	C.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::C";
	Vector<double> b(C.Rows(),0.0);
	b.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::b";
	PrintLinearEquation(C,b,Labels);
}

void PrintRowDependencies(const Matrix<double> &A, const Vector<string> &Labels, double Tol)
{

	/* Check for Incompadible Dimensions */
	int n = A.Cols();
	if(Labels.Size() != n)
	{
		Print("Error in PrintRowDependencies(Matrix,Vector,Tol)");
		Print("Incompadible Dimensions");
		Print("A.Name",A.Name);
		Print("Labels.Name",Labels.Name);
		Print("A.Size()",A.Size());
		Print("Labels.Size()",Labels.Size());
		HaltExecution();
	}
	
	/* Main Code */
	Vector<int> Piv = BasisSimple(A,Tol);
	Matrix<double> C = RowDependencies(A,Piv);
	C.Name = "PrintRowDependencies(Matrix,Vector,Tol)::C";
	Vector<double> b(C.Rows(),Zero);
	b.Name = "PrintRowDependencies(Matrix,Vector,Tol)::b";
	PrintLinearEquation(C,b,Labels,Tol);
}

void PrintRowDependencies(const SymmetricMatrix<double> &A, const Vector<string> &Labels, double Tol)
{
	int n = A.Dim();
	
	if(Labels.Size() != n)
	{
		Print("Error in PrintRowDependencies(SymmetricMatrix,Vector)");
		Print("Incompadible Dimensions");
		Print("A.Name",A.Name);
		Print("Labels.Name",Labels.Name);
		Print("A.Size()",A.Size());
		Print("Labels.Size()",Labels.Size());
		HaltExecution();
	}
	
	Matrix<double> A1(n,n);
	Copy(A1,A);
	Vector<int> Piv = BasisSimple(A1,Tol);
	Matrix<double> C = RowDependencies(A1,Piv);
	C.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::C";
	Vector<double> b(C.Rows(),0.0);
	b.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::b";
	PrintLinearEquation(C,b,Labels,0.00000001);
}

void PrintRowDependencies(const SymmetricMatrix<double> &A, const Matrix<double> &Z, const Vector<string> &Labels)
{
	Print("Calling PrintRowDependencies");
	int n = A.Dim();
	
	/* Check for Incompadible Dimensions */
	if(Z.Cols() != n || Labels.Size() != n)
	{
		Print("Error in PrintRowDependencies(SymmetricMatrix<double> A, Matrix<double> Z, Vector<string> Labels)");
		Print("Incompadible Dimensions");
		Print("A.Name",A.Name);
		Print("Z.Name",Z.Name);
		Print("Labels.Name",Labels.Name);
		Print("A.Size()",A.Size());
		Print("Z.Size()",Z.Size());
		Print("Labels.Size()",Labels.Size());
		HaltExecution();
	}
	
	Matrix<double> A1(n,n);
	A1.Name = "PrintRowDependencies::A1";
	Copy(A1,A);
	Vector<int> Piv = BasisSimple(A1);
	Matrix<double> C = RowDependencies(A1,Piv);
	C.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::C";
	Matrix<double> CZ = C * Transpose(Z);
	CZ.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::CZ";
	Vector<double> b(C.Rows(),0.0);
	b.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::b";
	PrintLinearEquation(CZ,b,Labels);
}

void PrintRowDependencies(const SymmetricMatrix<double> &A, const Matrix<double> &Z, const Vector<string> &Labels, double Tol)
{
	Print("Calling PrintRowDependencies");
	int n = A.Dim();
	
	/* Check for Incompadible Dimensions */
	//if(Z.Cols() != n || Labels.Size() != n)
	if(Z.Cols() != n || Labels.Size() != Z.Rows())
	{
		Print("Error in PrintRowDependencies(SymmetricMatrix<double> A, Matrix<double> Z, Vector<string> Labels, double Tol)");
		Print("Incompadible Dimensions");
		Print("A.Name",A.Name);
		Print("Z.Name",Z.Name);
		Print("Labels.Name",Labels.Name);
		Print("A.Size()",A.Size());
		Print("Z.Size()",Z.Size());
		Print("Labels.Size()",Labels.Size());
		HaltExecution();
	}
	
	Matrix<double> A1(n,n);
	A1.Name = "PrintRowDependencies::A1";
	Copy(A1,A);
	Vector<int> Piv = BasisSimple(A1,Tol);
	Matrix<double> C = RowDependencies(A1,Piv);
	C.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::C";
	Matrix<double> CZ = C * Transpose(Z);
	CZ.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::CZ";
	Vector<double> b(C.Rows(),0.0);
	b.Name = "PrintRowDependencies(SymmetricMatrix,Vector)::b";
	PrintLinearEquation(CZ,b,Labels,Tol);
}


#endif