
#ifndef _BlasIdaMax
#define _BlasIdaMax

	
	/* Finds the index of the element having the maximum
	absolute value */
	int BlasIdaMax(int n, double *x, int incx);

/*

Finds the index of the element having maximum absolute
value.

Adapted from the Blas routine,

	INTEGER IDAMAX( N , DX, INCX)
	
	jack dongarra, linpack, 3/11/78.
	modified 3/93 to return if incx .le. 0.
	modified 12/3/93, array(1) declarations changed to array(*)

*/

int BlasIdaMax(int n, double *x, int incx)
{
	/* Check input parametes */
	if(n < 1)
	{
		Print("Error in BlasIdaMax");
		Print("n < 1");
		Print("n",n);
		HaltExecution();
	}
	else if(incx <= 0)
	{
		Print("Error in BlasIdaMax");
		Print("incx <= 0");
		Print("incx",incx);
		HaltExecution();
	}
	
	/* Quick return if possible */
	if(n == 1) return 0;
	
	if(incx == 1)
	{
		/* code for increment equal to 1 */
   		int iMax = 0;
   		double dMax = Abs(x[0]);
   		for(int i=1; i<n; i++)
   		{
   			if(Abs(x[i]) > dMax)
   			{
   				iMax = i;
   				dMax = Abs(x[i]);
   			}
		}
		return iMax;
	}
	else
	{
		/* code for increment not equal to 1 */
		int iMax = 0;
		int ix = incx;
    	double dMax = Abs(x[0]);
    	for(int i=1; i<n; i++)
   		{
    		if(Abs(x[ix]) > dMax)
    		{
    			iMax = i;
				dMax = Abs(x[ix]);
			}
			ix += incx;
		}
		return iMax;
	}
}

#endif
