
#ifndef _BlasScal
#define _BlasScal

/*
	
Fortran Subroutine DSCAL(n,da,dx,incx)

Scales a Vector by a Constant.
	
Note: The BLAS verison of this routine uses unrolled loops.
This gave no efficient gain on my machine
Note: The above is wrong! I should change this part to make
it more efficient.

*/

	/* Scales a Vector by a Constant */
	template <class T>
	void BlasScal(int n, const T &a, T* x, int incx);

/* Scales a Vector by a Constant */
template <class T>
void BlasScal(int n, const T &a, T* x, int incx)
{
	
	if(n < 0)
	{
		Print("Error in BlasScal");
		Print("n < 0");
		Print("n",n);
		HaltExecution();
	}
	else if(incx == 0)
	{
		Print("Error in BlasScal");
		Print("incx == 0");
		Print("incx");
		HaltExecution();
	}
	
	/* Quick return is possible. */
	if(n == 0) return;
	
	if(incx == 1)
	{
		/* Increment is equal to 1 */
    	
    	/* clean-up loop */
		int m = n % 5;
		if(m != 0) for(int i=0; i<m; i++) x[i] *= a;
    
    	if(n < 5) return;
    
		int mp1 = m;
    	for(int i=mp1; i<n; i+=5)
    	{
    		x[i  ] *= a;
    		x[i+1] *= a;
    		x[i+2] *= a;
    		x[i+3] *= a;
    		x[i+4] *= a;
		}	
	}
	else
	{
		/* Increment is not equal to 1 */
		
		int ix = 0;
		if(incx < 0) ix = (-n + 1) * incx;
				
		for(int i=0; i<n; i++)
		{
			x[ix] *= a;
			ix += incx;
		}
	}
}

#endif
