
#ifndef _BlasSet
#define _BlasSet


/*

Set a Vector equal to a constant,

	x = a	

*/

	/* Scales a Vector by a Constant */
	template <class T>
	void BlasSet(int n, const T &a, T *x, int incx);

/* Scales a Vector by a Constant */
template <class T>
void BlasSet(int n, const T &a, T *x, int incx)
{

	if(n < 0)
	{
		Print("Error in BlasSet");
		Print("n < 0");
		Print("n",n);
		HaltExecution();
	}
	else if(incx == 0)
	{
		Print("Error in BlasSet");
		Print("incx == 0");
		Print("incx",incx);
		HaltExecution();
	}

	/* Quick return if possible */
	if(n == 0) return;
	
	if(incx == 1)
	{
		/* Increment is equal to 1 */
    	
    	/* Clean-up loop */
		int m = n % 5;
		if(m != 0)
		{
			for(int i=0; i<m; i++) x[i] = a;
			if(n < 5) return;
		}
    
       	for(int i=m; i<n; i+=5)
    	{
    		x[i  ] = a;
    		x[i+1] = a;
    		x[i+2] = a;
    		x[i+3] = a;
    		x[i+4] = a;
		}
	}
	else
	{
		/* Increment is not equal to 1 */
		
		int ix;
		if(incx < 0) ix = -(n - 1) * incx;
		else         ix = 0;
		
		for(int i=0; i<n; i++)
		{
			x[ix] = a;
			ix += incx;
		}
	}
}

#endif
