
#ifndef _BlasSum
#define _BlasSum



	double BlasSum(int n, double *x, int incx);

/*

double precision function dasum(n,dx,incx)

	takes the sum of the absolute values.
	jack dongarra, linpack, 3/11/78.
	modified 3/93 to return if incx .le. 0.
	modified 12/3/93, array(1) declarations changed to array(*)
	
*/

double BlasSum(int n, double *x, int incx)
{

	if(n == 0) return Zero;
	
	if(n < 0)
	{
		Print("Error in BlasSum");
		Print("n < 0");
		Print("n",n);
		HaltExecution();
	}
	else if(incx == 0)
	{
		Print("Error in BlasSum");
		Print("incx == 0");
		Print("incx",incx);
		HaltExecution();
	}
	
	if(incx == 1)
	{
		/* code for increment equal to 1 */
		
		/* clean-up loop */
	
		int m = n % 6;
		double Temp = Zero;
				
		if(m > 0) for(int i=0; i<m; i++) Temp += x[i];
		
		if(n >= 6) for(int i=m; i<n; i+=6)
			Temp += x[i] + x[i+1] + x[i+2] + x[i+3] + x[i+4] + x[i+5];
		return Temp;
	}
	else
	{
		/* code for increment not equal to 1 */
		
		int nincx = n * incx;
		double Temp = Zero;
		for(int i=0; i<nincx; i+=incx) Temp += x[i];
		return Temp;
	}
}

#endif
