
#ifndef _BlasSwap
#define _BlasSwap

	
	inline void BlasSwap(int n, double *x, int incx, double *y, int incy);

/*

subroutine  dswap (n,dx,incx,dy,incy)

     interchanges two vectors.
     uses unrolled loops for increments equal one.
     jack dongarra, linpack, 3/11/78.
     modified 12/3/93, array(1) declarations changed to array(*)

*/

inline void BlasSwap(int n, double *x, int incx, double *y, int incy)
{
	int i;
	double Temp;
	
	/* Quick return if possible */
	if(n <= 0) return;
	
	if(incx == 1 && incy == 1)
	{
		/* code for both increments equal to 1 */
		
		/* clean-up loop */
		int m = n % 3;
		
		for(i=0; i<m; i++)
		{
			Temp = x[i];
			x[i] = y[i];
			y[i] = Temp;
		}
			
		for(i=m; i<n; i+=3)
		{
			Temp = x[i];
			x[i] = y[i];
			y[i] = Temp;
			
			Temp   = x[i+1];
			x[i+1] = y[i+1];
			y[i+1] = Temp;
			
			Temp   = x[i+2];
			x[i+2] = y[i+2];
			y[i+2] = Temp;
		}
  	}
  	else
  	{
  		/* code for unequal increments or equal increments not equal to 1 */
  		int ix = 0;
     	int iy = 0;
       	if(incx < 0) ix = (-n + 1) * incx;
      	if(incy < 0) iy = (-n + 1) * incy;
      	
      	for(i=0; i<n; i++)
      	{
      		Temp = x[ix];
      		x[ix] = y[iy];
      		y[iy] = Temp;
      		ix += incx;
      		iy += incy;
   		}
   	}
}

#endif
