

#ifndef _GenMatUtil_CholeskyDecompL
#define _GenMatUtil_CholeskyDecompL



LowerMatrix<double> CholeskyDecompL(const SymmetricMatrix<double> &A)
{
	int n = A.Dim();
	LowerMatrix<double> L(n);
	int Info = CholeskyDecomp(A,L);
	
	if(Info)
	{
		Print("Error in CholeskyDecompL(SymmetricMatrix)");
		Print("Info",Info);
		HaltExecution();
	}
	
	return L;
}

LowerMatrix<double> CholeskyDecompL(const Matrix<double> &A)
{
	int n = A.Rows();
	LowerMatrix<double> L(n);
	int Info = CholeskyDecomp(A,L);
	
	if(Info)
	{
		Print("Error in CholeskyDecompL(Matrix)");
		Print("Info",Info);
		if(n <= 12)
		{
			Print("A",A);
			Print("L",L);
		}
		HaltExecution();
	}
	
	return L;
}

#ifdef _GenMat_SymmetricToeplitzMatrix
	LowerMatrix<double> CholeskyDecompL(const SymmetricToeplitzMatrix<double> &A)
	{
		int n = A.Dim();
		LowerMatrix<double> L(n);
		int Info = CholeskyDecomp(A,L);
		
		if(Info)
		{
			Print("Error in CholeskyDecompL(SymmetricToeplitzMatrix)");
			Print("Info",Info);
			HaltExecution();
		}
		
		return L;
	}
#endif

#ifdef _GenMat_SymmetricBandToeplitzMatrix
	LowerBandMatrix<double> CholeskyDecompL(const SymmetricBandToeplitzMatrix<double> &A)
	{
		int n = A.Dim();
		int k = A.Bands();
		LowerBandMatrix<double> L(n,n,k);
		int Info = CholeskyDecomp(A,L);
		
		if(Info)
		{
			Print("Error in CholeskyDecompL(SymmetricBandToeplitzMatrix)");
			Print("Info",Info);
			HaltExecution();
		}
		
		return L;
	}
#endif

#endif
