
#ifndef _Constant
#define _Constant

/* Various Usefull Constants */

const double Pi      = 3.141592653589793;
const double SqrtPi  = sqrt(Pi);
const double Sqrt2Pi = sqrt(2.0 * Pi);
const double Sqrt2   = sqrt(2.0);
const double Sqrt5   = sqrt(5.0);
const double Inf     = 1.0e80;
const double Nan     = 0.0 / 0.0;
const double Tiny    = 1.0e-20;
const double Zero    = 0.0;
const double One     = 1.0;
const double Two     = 2.0;
const double Three   = 3.0;
const double Four    = 4.0;
const double Five    = 5.0;
const double Six     = 6.0;
const double Eight   = 8.0;
const double SevTen  = 17.0;
const double Half    = 0.5;
const double EulerMascheroniConstant = 0.5772156649015328606065;

/* Logical Constants */

const bool True  = true;
const bool False = false;

/* Machine Epsilon */

const double MachEps  = 2.22045e-16;
const double MachEps2 = pow(MachEps,1.0 / 2.0);
const double MachEps3 = pow(MachEps,1.0 / 3.0);
const double MachEps4 = pow(MachEps,1.0 / 4.0);
const double MachEps5 = pow(MachEps,1.0 / 5.0);


#endif
