
#ifndef _Data_Convert
#define _Data_Convert


	double ToDouble(const string &s);
	string ToString(char ch);

	bool Convert(int               &x, const string &s);
	bool Convert(short int         &x, const string &s);
	bool Convert(double            &x, const string &s);
	bool Convert(float             &x, const string &s);
	bool Convert(string            &x, const string &s);

	bool Convert(string &s, const int &x);
	bool Convert(string &s, char ch);
	bool Convert(int &x, char ch);
	bool Convert(short int &x, char ch);
	bool Convert(double &x, const char &ch);

	bool Convert(bool &x, const string &s);	// Convert a string to a bool


/* Convert char to string */
string ToString(char ch)
{
	return std::string(1,ch); // Is there a better way to do this?
}



/* Convert any type with << operator to string */
template <class T>
inline std::string ToString(const T &Val)
{
    std::ostringstream StreamOut;
    StreamOut << Val;
	return StreamOut.str();
}

/* Convert char to double */
double ToDouble(const char &ch)
{
	double x;
	std::istringstream i(std::string(1,ch));
	if(!(i >> x)) Throw("Error in ToDouble(char)\nUnable to Convert\nch: " + ch);
	return x;
}


/* Convert string to double */
double ToDouble(const string &s)
{
	double x;
	std::istringstream i(s);
	if(!(i >> x)) Throw("Error in ToDouble(string)\nUnable to Convert\ns: " + s);
	return x;
}

/* Convert string to double */
double ToDouble(const int &k)
{
	return (double)k;
}

/* Convert char to int */
int ToInteger(const char &ch)
{
	int x;
	std::istringstream i(std::string(1,ch));
	if(!(i >> x)) Throw("Error in ToInteger(char)\nUnable to Convert\nch: " + ch);
	return x;
}

/* Convert double to int */
int ToInteger(const double &x)
{
	if(x != floor(x)) Throw("Error in ToInteger(double)\nUnable to Convert\nx: " + ToString(x));
	return floor(x);
}


// Convert a string to type T
//template <class T> void Convert(T &x, const string &s)
//{
//	std::istringstream i(s);
//	if(!(i >> x)) Print("Error in Convert(T,str)");
//}

/* Convert ... */
bool Convert(string &s, char ch)
{
	s = ToString(ch);
	return 0;		// Return no error code
}

/* Convert a string to an integer */
bool Convert(int &x, char ch)
{
	std::istringstream i(ToString(ch));
	if(!(i >> x))
	{
		/* If conversion failed */
		x = 0;	// Set x to default value (0)
		return 1;	// Return error code
	}
	return 0;		// Return no error code
}

/* Convert a string to an integer */
bool Convert(short int &x, char ch)
{
	std::istringstream i(ToString(ch));
	if(!(i >> x))
	{
		/* If conversion failed */
		x = 0;	// Set x to default value (0)
		return 1;	// Return error code
	}
	return 0;		// Return no error code
}

/* Convert a string to an integer */
bool Convert(int &x, const string &s)
{
	std::istringstream i(s);
	if(!(i >> x))
	{
		/* If conversion failed */
		x = 0;	// Set x to default value (0)
		return 1;	// Return error code
	}
	return 0;		// Return no error code
}

/* Convert a string to an integer */
bool Convert(int &y, const bool &x)
{
	y = (int)x;
	return 0;		// Return no error code
}

/* Convert a string to an integer */
bool Convert(short int &x, const string &s)
{
	std::istringstream i(s);
	if(!(i >> x))
	{
		/* If conversion failed */
		x = 0;	// Set x to default value (0)
		return 1;	// Return error code
	}
	return 0;		// Return no error code
}

/* Convert a string to an integer */
bool Convert(string &s, const int &x)
{
	std::ostringstream StreamOut;
    StreamOut << x;
	s = StreamOut.str();
	return False;
}


/* Convert a string to a double */
bool Convert(double &x, const char &ch)
{
	std::istringstream i(ToString(ch));
	if(!(i >> x))
	{
		x = Zero;	// Set x to default value (0.0)
		return 1;	// Return error code
	}
	return 0;		// Return no error code
}

/* Convert a string to a double */
bool Convert(float &x, const char &ch)
{
	std::istringstream i(ToString(ch));
	if(!(i >> x))
	{
		x = Zero;	// Set x to default value (0.0)
		return 1;	// Return error code
	}
	return 0;		// Return no error code
}

/* Convert a string to a double */
bool Convert(double &x, const string &s)
{
	std::istringstream i(s);
	if(!(i >> x))
	{
		x = Zero;	// Set x to default value (0.0)
		return 1;	// Return error code
	}
	return 0;		// Return no error code
}

/* Convert a string to a double */
bool Convert(float &x, const string &s)
{
	std::istringstream i(s);
	if(!(i >> x))
	{
		x = Zero;	// Set x to default value (0.0)
		return 1;	// Return error code
	}
	return 0;		// Return no error code
}

/* Convert a string to a bool */
bool Convert(bool &x, const string &s)
{
	if(s == "0")
	{
		x = False;
		return 0;
	}
	else if(s == "1")
	{
		x = True;
		return 0;
	}
	else
	{
		return 1;
	}
}


/* Convert a string to a DataPoint<double> */
/*
int Convert(DataPoint<double> &x, const string &s)
{
	double y;
	std::istringstream i(s);
	if(!(i >> y))
	{
		x.Missing = True;
		return 1;	// Return error code
	}
	x = y;
	return 0;		// Return no error code
}
*/


/* Convert a string to a string */
bool Convert(string &x, const string &s)
{
	x = s;
	return 0;
}

/* Convert a string to a double */
bool Convert(char &ch, const string &s)
{
	if(s.length() != 1)
	{
		ch = '0';	// Set x to default value (0.0)
		return 1;	// Return error code
	}
	ch = s[0];
	return 0;		// Return no error code
}

/* Convert a string to a double */
bool Convert(double &y, const int &x)
{
	y = (double)x;
	return False; // Return no error code
}


/* Convert a string to a double */
bool Convert(float &y, const int &x)
{
	y = (float)x;
	return False; // Return no error code
}

/* Convert a string to a double */
bool Convert(int &y, const double &x)
{
	y = (int)x;
	if((double)y - x != Zero) return True;
	else                      return False; // Return no error code
}

// Convert a matrix double to a matrix of complex doubles
/*
void Convert(Matrix<Complex> &A, const Matrix<double> &B)
{
	int i,j;
	for(i=0; i<B.Rows(); i++) for(j=0; j<B.Cols(); j++)
	{
		A(i,j).real = B(i,j);
		A(i,j).imag = 0.0;
	}
	return;
}
*/

#endif
