
#ifndef _Data_DataFileDelim
#define _Data_DataFileDelim

/*

Note: in the future, I should call this data file.
I should also create a seperate object called data set
that is a collection of vectors of variables types,
but the same length. One can then read variables from
a data file into a data set and the manipulate the variables
in the data set.

/*

Create an array whose rows are accessed by number and
whose columns are accessed as strings

*/

class DataFileDelim
{

	public:

	LongInt N;				// Number of observations
	int K;						// Number of variables
	string FileName;			// Name of the file
	Vector<string> VarNames;	// Names of variables
	Stack<char>   Data;			// Data in character form
	Stack<char*>  EntryStack;	//
	Matrix<char*> EntryMatrix;	//
	Vector<int>   VarIndex;

	//private:

	Vector<string> VarNamesVec; // Don't allow access-- these are out of order

	//public:

	/* Constructor */
	/* THIS WAS CAUSING POINTER PROBLEMS - DO NOT PASS DataFileDelim until fixed */
	/*
	DataFileDelim()
	{
		Print("Calling DFD Null Constructor");
	}
	*/

	/* Descructor */
	/*
	~DataFileDelim()
	{
		Print("Calling DFD Dest");
	}
	*/

	/* Copy Constructor */
	/*
	DataFileDelim(DataFileDelim &d)
	{
		Print("Calling Copy Constructor!!!");
		N = d.N;
		K = d.K;
		FileName = d.FileName;
		VarNames = d.VarNames;
		Data = d.Data;
		EntryStack = d.EntryStack;
		Print("EntryMatrix3",EntryMatrix);
		EntryMatrix = d.EntryMatrix;
		Print("EntryMatrix4",EntryMatrix);
		VarIndex = d.VarIndex;
		VarNamesVec = d.VarNamesVec;
	}
	*/

	/* Constructor */
	//DataFileDelim(string FileName, char Delim, bool Quotes)
	DataFileDelim(string FileName, char Delim)
	{
		/*
		if(Quotes && Delim == '\t')
		{
			Print("Error in DataFileDelim");
			Print("Quotes",Quotes);
			Print("Delim is Tab");
			HaltExecution();
		}
		*/
		
		/* Check to make sure that the delimeter is valid */
		this->FileName = FileName;
		if(Delim != '\t' && Delim != ',' && Delim != '|')
		{
			Print("Error in DataFileDelim");
			Print("Invalid Delimeter");
			Print("FileName",FileName);
			Print("Delim",Delim);
			HaltExecution();
		}

		/* Open the file */
		char ch;
		FILE *f1;	// Pointer to the file
		f1 = fopen(FileName.c_str(),"r");
		if(f1 == NULL)
		{
			Print("Error in DataFileDelim");
			Print("Unable to Open File");
			Print("FileName",FileName);
			HaltExecution();
		}

		#ifndef _SaveMem
			/* One Pass Approach */
			N = -1;
			do
			{
				ch = getc(f1);	// Get one character from the file
				if(ch == '\n' || ch == '\r')
				{
					if(N % 10000 == 0) Print("N",N);
					N++;
				}
				Data.Push(ch);	// Push the character to a Stack
			}
			while(ch != EOF);	// repeat until EOF (end of file)
			
			/* Trim if Possible */
			try { Data.Trim(); }
			catch(int i) { }
		#else
			/* Two Pass Approach to Save Memory */
			LongInt len = 0;
			N = -1;
			do
			{
				ch = getc(f1);	// Get one character from the file
				if(ch == '\n' || ch == '\r')
				{
					if(N % 10000 == 0) Print("Pass 1, N",N);
					N++;
				}
				len++;
			}
			while(ch != EOF);	// repeat until EOF (end of file)

			Data.Reset(len);
			f1 = fopen(FileName.c_str(),"r");
			Print("Pass 2");
			do
			{
				ch = getc(f1);	// Get one character from the file
				Data.Push(ch);	// Push the character to a Stack
			}
			while(ch != EOF);	// repeat until EOF (end of file)
		#endif

		/* Close the File */
		fclose(f1);
		
		/* Convert delimiters to tab if RemoveParen is set */
		/*
		if(Quotes)
		{
			bool InQuotes = False;
			for(int k=0; k<Data.Size(); k++)
			{
				if(Data[k] == '\"')
				{
					InQuotes = !InQuotes;
				} else if(Data[k] == Delim && !InQuotes) {
					Data[k] = '\t';
				}			
			}
			Delim = '\t';		
		}
		*/
		
		/*

		The file line of the file contains the names of the variables,
		seperated by tabs. Mark the positions of each name in a Stack
		and replace the tabs using the end of string character, '\0'

		*/

		Stack<char*> Temp;
		Temp.Push(&Data[0]);
		LongInt k = 1;
		while(Data[k] != '\n' && Data[k] != '\r')
		{
			if(Data[k] == Delim)
			{
				Data[k] = '\0';
				Temp.Push(&Data[k+1]);
			}
			k++;
		}
		Data[k] = '\0';
		k++;
		K = Temp.Size();
		VarNames = Vector<string>(K);
		for(int k=0; k<K; k++) VarNames(k) = (string)(Temp(k));

		//Print("Data",Data);
		//Print("K",K);
		//Print("VarNames",VarNames);
		//PauseExecution();

		/*

		The rest of the file contains the data, each entry separated by
		tabs. Mark the positions of each entry in a Stack and replace
		the tabs and enlines with the end of string character, '\0'.
		Throughout, make sure that each row of the data matrix contains
		K entries, where K is the number of variable names in the first
		line of the data file.

		*/

		int m = 0;
		//Data.RefCount++; // BAD CODE, BUT DO NOT WANT TO LOSE STACK!!!
		EntryStack.Reset(N*K+1); // Initialize Stack
		EntryStack.Name = "EntryStack";
		EntryStack.Push(&Data[k]);
		int CurrLine = 0;
		int LineStart = k;
		bool Paren = 0;
		int Curr = 0;
		while(&Data[k] < Data.End())
		{
			if(Data[k] == '\n' || Data[k] == '\r')
			{
				Data[k] = '\0';
				m++;
				k++;
				EntryStack.Push(&Data[k]);

				/* Check column index */
				if(m != K)
				{
					Print("Error in DataFileDelim (1)");
					Print("Columns are not conformant");
					Print("Data[k] == '\\n' or '\\r'");
					Print("FileName",FileName);
					Print("CurrLine",CurrLine);
					Print("k",k);
					Print("m",m);
					Print("K",K);
					//Output("c:\\entry.dat",EntryStack);
					HaltExecution();
				}

				m = 0;	// Reset column index
				CurrLine++;
				LineStart = k+1;
			}
			else if(Data[k] == Delim)
			{
				Data[k] = '\0';
				m++;
				k++;
				EntryStack.Push(&Data[k]);

				/* Check clumn index */
				if(m == K)
				{
					Print("Error in DataFileDelim (2)");
					Print("Columns are not conformant");
					Print("Data[k] == Delim");
					Print("FileName",FileName);
					Print("k",k);
					Print("m",m);
					Print("K",K);
					Print("CurrLine",CurrLine);

					/* Print the current line */
					int kLow = k;
					
					Print("kLow",kLow);
					Print("Data[kLow]",Data[kLow]);
									
					while(Data[kLow] != '\n' && Data[kLow] != '\r')
					{
						if(kLow % 50 == 0) PauseExecution();
						Print("kLow",kLow,"Data[kLow]",Data[kLow]);
						kLow--;
					}
					Print("kLow",kLow);
					char* s1 = &Data[kLow+1];
					Print("Current line",s1);
					Print("CurrLine",CurrLine);
					string s2 = "";
					k = LineStart;
					while(Data[k] != '\n' && Data[k] != '\r')
					{
						if(Data[k] != '\0') s2 += Data[k];
						k++;
					}
					Print("Line Text",s2);
					HaltExecution();
				}
			}
			else k++;
		}
		if(K > 1) N = EntryStack.Size() / K;
		else      N = (EntryStack.Size() - 1) / K;
		
		/* Matrix of pointers allows accesing elements using the (i,j) notation */
		//EntryStack.RefCount++; // BAD CODE, BUT DO NOT WANT TO LOSE STACK!!!
		EntryMatrix = Matrix<char*>(N,K,&EntryStack[0]);
		EntryMatrix.Name = "EntryMatrix";

		//Print("EntryMatrix",EntryMatrix);
		//PauseExecution();

		/*

		Create a data structure to allow accesing variables
		using a string in O(log(K)) time

		*/

		VarNamesVec = Vector<string>(K);
		VarIndex    = Vector<int>(K);

		for(int k=0; k<K; k++)
		{
			VarNamesVec[k] = VarNames[k];
			VarIndex[k] = k;
		}

		::SortBy(VarNamesVec,VarIndex); // Now, variable names can be found using binary sort

	}
	
	/*
	DataFileDelim(string FileName, const char Delim)
	{
		DataFileDelim(FileName,Delim,False);
	}
	*/
	
	template <class T>
	inline Vector<T> Get(string VarName)
	{

		/* Find variable */
		int k = BinarySearch(VarNamesVec,VarName);

		/* Check ... */
		if(k < 0)
		{
			Throw(  string("Error in DataFileDelim::Get(string VarName)\n")
			      + "Variable not found\n"
			      + "FileName: " + FileName + "\n"
			      + "VarName: " + VarName);
		}

		int Idx = VarIndex[k];

		/* Convert data... */
		Vector<T> Ret(N);
		Ret.Name = VarName;
		for(int n=0; n<N; n++)
		{
			string s = EntryMatrix(n,Idx);
			int len = s.length();
			if(len >= 2) if(s[0] == '\"' && s[len-1] == '\"') s = s.substr(1,len-2);
			int Info = Convert(Ret[n],s);
			if(Info)
			{
				Throw(  string("Error in DataFileDelim::Get()\n")
				      + "Conversion Error\t"
				      + "Info:  " + ToString(Info) + "\n"
				      + "FileName: " + FileName + "\n"
				      + "VarName: " + VarName + "\n"
				      + "Line: " + ToString(n + 2) + "\n"
				      + "EntryMatrix(n,Idx): " + ToString(EntryMatrix(n,Idx)) + "\n"
				      + "EntryMatrix(n,Idx).length(): " + ToString(    ToString(EntryMatrix(n,Idx)).length()    ));
			}
		}
		return Ret;
	}

	/*
	template <class T>
	inline DataVector<T> GetDataVector(string VarName)
	{
		/* Find variable */
	/*	int k = BinarySearch(VarNamesVec,VarName);

		/* Check ... */
	/*	if(k < 0)
		{
			Print("Error in DataFileDelim::GetDataVector(VarName)");
			Print("Variable not found");
			Print("FileName",FileName);
			Print("VarName",VarName);
			HaltExecution();
		}

		int Idx = VarIndex[k];

		/* Convert data... */
	/*	DataVector<T> Ret(N);
		Ret.Name = VarName;
		for(int n=0; n<N; n++)
		{
			string s = EntryMatrix(n,Idx);
			if(s == "." || s == " " || s == "")
			{
				Ret.Missing[n] = True;
			}
			else
			{
				int Info = Convert(Ret.Data[n],s);
				Ret.Missing[0] = False;
				if(Info)
				{
					Print("Error in DataFileDelim::GetDataVector");
					Print("...");
					Print("VarName",VarName);
					Print("s",s);
					Ret.Missing[n] = 1;
					HaltExecution();
				}
			}
		}
		return Ret;
	}
	*/

	/*
	template <class T>
	inline Vector< DataPoint<T> > GetDataPoint(string VarName)
	{
		/* Find variable */
	/*	int k = BinarySearch(VarNamesVec,VarName);

		/* Check ... */
	/*	if(k < 0)
		{
			Print("Error in DataFileDelim::GetDataPoint(VarName)");
			Print("Variable Not Found");
			Print("FileName",FileName);
			Print("VarName",VarName);
			HaltExecution();
		}

		int Idx = VarIndex[k];

		/* Convert data... */
	/*	Vector< DataPoint<T> > Ret(N);
		Ret.Name = VarName;
		for(int n=0; n<N; n++)
		{
			string s = EntryMatrix(n,Idx);
			if(s == "." || s == " " || s == "")
			{
				Ret(n).Missing = True;
			}
			else
			{
				int Info = Convert(Ret(n).Data,s);
				Ret(n).Missing = False;
				if(Info)
				{
					Print("Error in DataFileDelim::GetDataPoint");
					Print("...");
					Print("VarName",VarName);
					Print("s",s);
					HaltExecution();
				}
			}
		}
		return Ret;
	}
	*/

	template <class T>
	inline Matrix<T> Get(const GeneralVector<string> &v)
	{

		int R = v.Size();
		Matrix<T> Ret(N,R);

		for(int r=0; r<R; r++)
		{
			/* Find variable */
			int k = BinarySearch(VarNamesVec,v[r]);

			if(k < 0)
			{
				Print("Error in DataFileDelim::Get(Vector<string>)");
				Print("Variable not found");
				Print("FileName",FileName);
				Print("VarNamesVec",VarNamesVec);
				Print("r",r);
				Print("v[r]",v[r]);
				HaltExecution();
			}

			int Idx = VarIndex[k];

			/* Convert data... */
			for(int n=0; n<N; n++)
			{
				string s = EntryMatrix(n,Idx);
				int len = s.length();
				if(len >= 2) if(s[0] == '\"' && s[len-1] == '\"') s = s.substr(1,len-2);
				int Info = Convert(Ret(n,r),s);
				if(Info)
				{
					Print("Error in DataFileDelim::Get(Vector<string>)");
					Print("Conversion Error");
					Print("FileName",FileName);
					Print("v(r)",v(r));
					Print("EntryMatrix(n,Idx)",EntryMatrix(n,Idx));
					HaltExecution();
				}
			}
		}

		return Ret;
	}

	inline Vector<string> operator()(string VarName)
	{
		/* Find variable */
		int k;
		for(k=0; k<K; k++) if(VarName == VarNames[k]) break;

		/* If varaible could not be found */
		if(k >= K)
		{
			Print("Error in DataFileDelim::(s)");
			Print("No variable by that name");
			Print("FileName",FileName);
			Print("VarName",VarName);
			HaltExecution();
		}

		/* Convert data... */
		Vector<string> Ret(N);
		Ret.Name = VarName;
		for(int n=0; n<N; n++) Convert(Ret[n],EntryMatrix(n,k));
		return Ret;
	}

	inline Vector<string> operator()(int k)
	//inline Vector<double> operator()(string s)
	{
		/* If varaible could not be found */
		if(k < 0 || k >= K)
		{
			Print("Error in DataFileDelim::(k)");
			Print("Index Out of Bounds");
			Print("FileName",FileName);
			Print("k",k);
			HaltExecution();
		}

		/* Convert data... */
		Vector<string> Ret(N);
		Ret.Name = "Var_" + ToString(k);
		for(int n=0; n<N; n++) Convert(Ret[n],EntryMatrix(n,k));
		return Ret;
	}

	inline Matrix<string> operator()(const Vector<string> &v)
	{

		int R = v.Size();
		Matrix<string> Ret(N,R);

		for(int r=0; r<R; r++)
		{
			/* Find variable */
			int k = BinarySearch(VarNamesVec,v[r]);

			if(k < 0)
			{
				Print("Error in DataFileDelim::Get(Vector<string>)");
				Print("Variable not found");
				Print("FileName",FileName);
				Print("r",r);
				Print("v[r]",v[r]);
				HaltExecution();
			}

			int Idx = VarIndex[k];
			for(int n=0; n<N; n++) Convert(Ret(n,r),EntryMatrix(n,Idx));
		}

		return Ret;
	}
	
	/*
	template <class T>
	inline void Set(string VarName, int n, const T &x)
	{

		/* Find variable */
	/*	int k = BinarySearch(VarNamesVec,VarName);

		/* Check ... */
	/*	if(k < 0)
		{
			Throw(  string("Error in DataFileDelim::Set(string VarName, int i)\n")
			      + "Variable not found\n"
			      + "FileName: " + FileName + "\n"
			      + "VarName: " + VarName + "\n"
			      + "n: " + ToString(n) + "\n"
			      + "x: " + ToString(x) + "\n");
		}

		int Idx = VarIndex[k];
		EntryMatrix(n,Idx) = ToString(x).c_str();
	}
	*/

	/*

	Note:

	It would be nice to be able to replace the get
	function with a template operator () using
	the declaration,

	template <class T>
	inline Vector<T> operator()(string s) {}

	and call this using,

	Vector<double> v = d<double>("abc");

	Unfortunately, this will not work in most compilers
	and calling this function may require,

	Vector<double> v = d.operator()<double>("abc");

	This is no longer simpler than the get function.
	Instead, we define the () to always return type
	double.

	*/

	string operator()(int n, int k)
	{
		return EntryMatrix(n,k);
	}

	/*
	inline double operator()(int n, string s)
	{
		for(int k=0; k<K; k++) if(s == VarNames[k]) return Data(n,k);

		/* If no variable has that name */
	/*	Print("Error in DataSet::(n,s)");
		Print("No variable by that name");
		HaltExecution();
		return 0.0;
	}
	*/

	/*
	inline Vector<double> operator()(string s)
	{
		int n,k;
		for(k=0; k<K; k++) if(s == VarNames[k])
		{
			Vector<double> Ret(N);
			Ret.Name = s;
			for(n=0; n<N; n++) Ret[n] = Data(n,k);
			return Ret;
		}

		Print("Error in DataSet::(s)");
		Print("No variable by that name");
		Print("s",s);
		Print("Halting Execution");
		exit(0);
		return Vector<double>();
	}
	*/

	/*
	template <class T>
	inline Vector<T> operator()(string s)
	{
		int n,k;
		for(k=0; k<K; k++) if(s == VarNames[k])
		{
			Vector<T> Ret(N);
			Ret.Name = s;
			for(n=0; n<N; n++) Ret[n] = Data(n,k);
			return Ret;
		}

		Print("Error in DataSet::(s)");
		Print("No variable by that name");
		Print("s",s);
		HaltExecution();
		return Vector<double>();
	}
	*/

	/*
	inline Matrix<double> GetMatrix(string s)
	{
		/* First, find the variables in the string */
		/*
		string s2 = Delete1(s);
		Vector<string> Vars = ParseBy(s2,",");
		int J = vs.Size();
		Matrix<double> Ret(N,J);

		/* Then, find each variables */
		/*
		for(j=0; j<J; j++)
		{
			for(k=0; k<K; k++) if(Vars[j] == VarNames[k])
			{
				for(n=0; n<N; n++) Ret(n,j) = Data(n,k);
			}
		}
		*/
		//return Ret;
		//return;
	/*}*/

	/*
	inline Matrix<double> operator()(const Vector<string> &vs)
	{
		int j,k,n;
		int J = vs.Size();
		Matrix<double> Ret(N,J);
		for(j=0; j<J; j++)
		{
			for(k=0; k<K; k++) if(vs[j] == VarNames[k])
			{
				for(n=0; n<N; n++) Ret(n,j) = Data(n,k);
			}
		}

		return Ret;
	}



	void SortBy(string s)
	{
		int n,k;
		for(k=0; k<K; k++) if(s == VarNames[k])
		{
			Vector<int> Idx(N);
			Vector<double> Vals(N);
			for(n=0; n<N; n++)
			{
				Vals[n] = Data(n,k);
				Idx[n] = n;
			}
			BySort(Vals,Idx);
			Dim1Permute(Data,Idx);
			return;
		}

		Print("Error in DataSet::SortBy(s)");
		Print("No variable by that name");
		Print("Halting Execution");
		exit(0);
		return;
	}

	/*
	void LinReg(string s1, string s2)
	{




	}

	void Run(string s)
	{



	}
	*/

	template <class T>
	void SortBy(string VarName)
	{
		try
		{
			Vector<int> Idx(N);
			Vector<T> Vals2 = Get<T>(VarName);
			for(int n=0; n<N; n++) Idx(n) = n;
			::SortBy(Vals2,Idx);
			Dim1Permute(EntryMatrix,Idx);
		}
		catch(int i)
		{
			Throw(  string("Error in DataFileDelim::SortBy(string)\n")
				  + "Error\t"
				  + "FileName: " + FileName + "\n"
				  + "VarName: " + VarName + "\n");
		}
	}
	
	template <class T>
	void ReverseSortBy(string VarName)
	{
		try
		{
			Vector<int> Idx(N);
			Vector<T> Vals2 = Get<T>(VarName);
			for(int n=0; n<N; n++) Idx(n) = n;
			::ReverseSortBy(Vals2,Idx);
			Dim1Permute(EntryMatrix,Idx);
		}
		catch(int i)
		{
			Throw(  string("Error in DataFileDelim::ReverseSortBy(string)\n")
				  + "Error\t"
				  + "FileName: " + FileName + "\n"
				  + "VarName: " + VarName + "\n");
		}
	}
	
	template <class T1, class T2>
	void SortLex(string VarName1, string VarName2)
	{
		try
		{
			Vector<int> Idx(N);
			Vector<T1> Vals1 = Get<T1>(VarName1);
			Vector<T2> Vals2 = Get<T2>(VarName2);
			for(int n=0; n<N; n++) Idx(n) = n;
			::SortLex(Vals1,Vals2,Idx);
			Dim1Permute(EntryMatrix,Idx);
		}
		catch(int i)
		{
			Throw(  string("Error in DataFileDelim::SortLex(string,string)\n")
				  + "Error\t"
				  + "FileName: " + FileName + "\n"
				  + "VarName1: " + VarName1 + "\n"
				  + "VarName2: " + VarName2 + "\n");
		}
	}


	template <class T>
	void SortBy(Vector<T> &Vals)
	{
		Vector<int> Idx(N);
		for(int n=0; n<N; n++) Idx(n) = n;
		::SortBy(Vals,Idx);
		Dim1Permute(EntryMatrix,Idx);
	}

	inline int NumObs()
	{
		return N;
	}

	inline int NumVars()
	{
		return K;
	}

	Vector<string> GetVarNames()
	{
		return VarNamesVec;
	}
	
	void Output(string OutputFileName, char Delim)
	{
		ofstream out1(OutputFileName.c_str());
		for(int k=0; k<K-1; k++) out1 << VarNames(k) << Delim;
		out1 << VarNames(K-1) << "\n";
		
		for(int n=0; n<N; n++)
		{
			for(int k=0; k<K-1; k++) out1 << EntryMatrix(n,k) << Delim;
			out1 << EntryMatrix(n,K-1) << "\n";
		}
	}
};

#endif
