
#ifndef _GenMatUtil_DivOp
#define _GenMatUtil_DivOp


/* Function Prototypes */

	template <class T> Matrix<T>          operator / (const Matrix<T>          &A, const T &c);
	template <class T> SymmetricMatrix<T> operator / (const SymmetricMatrix<T> &A, const T &c);

template <class T>
void operator /= (Vector<T> &x, const double c)
{
	int n = x.Size();
	for(int i=0; i<n; i++) x[i] /= c;
	return;
}

/*

Operators for Matrix division

*/

/*
template <class T>
void operator /= (Matrix<T> &A, const double c)
{
	int i,j;
	int m = A.Rows();
	int n = A.Cols();
	for(i=0; i<m; i++) for(j=0; j<n; j++) A(i,j) /= c;
}
*/

/* Divide a Vector by a constant */
template <class T>
inline Vector<T> operator / (const Vector<T> &x, const T &c)
{
	int n = x.Size();
	Vector<T> y(n);
	for(int i=0; i<n; i++) y[i] = x[i] / c;
	return y;
}


template <class T>
Matrix<T> operator / (const Matrix<T> &A, const T &c)
{
	int m = A.Rows();
	int n = A.Cols();
	Matrix<T> B(m,n);
	for(int i=0; i<m; i++) for(int j=0; j<n; j++) B(i,j) = A(i,j) / c;
	return B;
}

template <class T>
SymmetricMatrix<T> operator / (const SymmetricMatrix<T> &A, const T &c)
{
	int n = A.Dim();
	SymmetricMatrix<T> B(n);
	for(int i=0; i<n; i++) for(int j=0; j<=i; j++) B(i,j) = A(i,j) / c;
	return B;
}


#endif