
#ifndef _GenMatUtil_IsNan
#define _GenMatUtil_IsNan

	template <class T> bool IsNan(const Vector<T> &x);
	//bool IsNan(const Matrix<double> &A);
	//bool IsNan(const SymmetricMatrix<double> &A);
	//bool IsNan(const DiagonalMatrix<double> &A);


template <class T>
bool IsNan(const Vector<T> &x)
{
	int n = x.Size();
	for(int i=0; i<n; i++) if(IsNan(x[i])) return 1;
	return 0;
}

template <class T>
bool IsNan(const Matrix<T> &A)
{
	int m = A.Rows();
	int n = A.Cols();
	for(int i=0; i<m; i++) for(int j=0; j<n; j++) if(IsNan(A(i,j))) return 1;
	return 0;
}

template <class T>
bool IsNan(const SymmetricMatrix<T> &A)
{
	int n = A.Dim();
	for(int i=0; i<n; i++) for(int j=0; j<=i; j++) if(IsNan(A(i,j))) return 1;
	return 0;
}

/*
bool IsNan(const DiagonalMatrix<double> &A)
{
	int n = A.Dim();
	for(int i=0; i<n; i++) if(IsNan(A(i))) return 1;
	return 0;
}
*/

template <class T>
bool IsNan(const LowerMatrix<T> &A)
{
	int n = A.Dim();
	for(int i=0; i<n; i++) for(int j=0; j<=i; j++) if(IsNan(A(i,j))) return 1;
	return 0;
}

/*
template <class T>
bool IsNan(const GeneralMatrix<T> &A)
{
	int n = A.Length();
	for(int i=0; i<n; i++) if(IsNan(A[i])) return 1;
	return 0;
}
*/

#ifdef _GenMat_SparseMatrix
	template <class T>
	bool IsNan(const SparseMatrix<T> &A)
	{
		int len = A.Length();
		for(int i=0; i<len; i++) if(IsNan(A[i])) return 1;
		return 0;
	}
#endif

#ifdef _GenMat_SparseUpdatedMatrix
	template <class T>
	bool IsNan(const SparseUpdatedMatrix<T> &A)
	{
		if(IsNan(A.S)) return 1;
		if(IsNan(A.U)) return 1;
		if(IsNan(A.V)) return 1;
		return 0;
	}
#endif

/*
template <class T>
bool IsNan(const SparseSymmetricUpdatedMatrix<T> &A)
{
	int n = A.Dim();
	int k = A.UpdateRank();
	int len1 = A.Length1();
	for(int i=0; i<len1; i++) if(IsNan(A.Val(i))) return 1;
	for(int i=0; i=n; i++) for(int j=0; j<k; j++) if(IsNan(A.U(i,j))) return 1;
	return 0;
}
*/

template <class T>
bool IsNan(const Array3D<T> &X)
{
	int d1 = X.Dim1();
	int d2 = X.Dim2();
	int d3 = X.Dim3();
	for(int i1=0; i1<d1; i1++) for(int i2=0; i2<d2; i2++) for(int i3=0; i3<d3; i3++) if(IsNan(X(i1,i2,i3))) return 1;
	return 0;
}

#endif
