
#ifndef _GenMatUtil_LinSolveCholesky
#define _GenMatUtil_LinSolveCholesly


	/* Solve A * x = b, using the Cholesky decomposition */
	int LinSolveCholesky(Vector<double> &x, const SymmetricMatrix<double> &A, const Vector<double> &b);
	
	Vector<double> LinSolveCholesky(const SymmetricMatrix<double> &A, const Vector<double> &b);


/* Solve A * x = b, using the Cholesky decomposition */
int LinSolveCholesky(Vector<double> &x, const SymmetricMatrix<double> &A, const Vector<double> &b)
{

	/*
	int n = A.Dim();
	LowerMatrix<double> L(n);
	Vector<int> Piv(n);
	int Info = CholeskyDecomp(A,L);
	if(Info) return 1;
	
	for(int i=0; i<n; i++) x[i] = b[i];

	/* Solve L * y = b */
	/*
	for(int j=0; j<n; j++) 
	{
		for(int i=0; i<j; i++) x[j] -= x[i] * L(j,i);
		x[j] /= L(j,j);
	}

	/* Solve L^T * x = y */
	/*
    for(int j=n-1; j>=0; j--)
	{
    	for(int i=j+1; i<n; i++) x[j] -= x[i] * L(i,j);
		x[j] /= L(j,j);
    }

    if(IsNan(x)) return 2;
    */
    
    CholeskyDecompObj<double> cd(A);
    
    if(!cd.IsSpd()) return 1;
    
    Copy(x,cd.Solve(b));
    
    return 0;
}

/* Solve A * x = b, using the Cholesky decomposition */
Vector<double> LinSolveCholesky(const SymmetricMatrix<double> &A, const Vector<double> &b)
{

	/*
	int n = A.Dim();
	LowerMatrix<double> L(n);
	Vector<int> Piv(n);
	int Info = CholeskyDecomp(A,L);
	if(Info)
	{
		Print("Error in LinSolveCholeskyX");
		HaltExecution();
	}
	
	Vector<double> x(n);
	
	for(int i=0; i<n; i++) x[i] = b[i];

	/* Solve L * y = b */
	/*
	for(int j=0; j<n; j++) 
	{
		for(int i=0; i<j; i++) x[j] -= x[i] * L(j,i);
		x[j] /= L(j,j);
	}

	/* Solve L^T * x = y */
	/*
    for(int j=n-1; j>=0; j--)
	{
    	for(int i=j+1; i<n; i++) x[j] -= x[i] * L(i,j);
		x[j] /= L(j,j);
    }
    
    if(IsNan(x))
    {
    	Print("Error in LinSolveCholeskyX");
		Print("NaN Encountered");
		HaltExecution();
	}
	*/
	
	CholeskyDecompObj<double> cd(A);
    
	if(!cd.IsSpd())
	{
		Print("Error in LinSolveCholesky");
		HaltExecution();
	}
	
	return cd.Solve(b);
}

#endif