
#ifndef _Macro
#define _Macro

// Useful inline functions
template <class T>
inline T Sqr(const T &a)
{
	return a * a;
}

template <class T>
inline T Pow3(const T &a)
{
	return a * a * a;
}

template <class T>
inline T Max(const T &a, const T &b)
{
	if(a > b) return a; else return b;
}

template <class T>
inline T Max(const T &a, const T &b, const T &c)
{
	T temp = a;
	if(b > temp) temp = b;
	if(c > temp) temp = c;
	return temp;
}

template <class T>
inline T Max(const T &a, const T &b, const T &c, const T &d)
{
	T temp = a;
	if(b > temp) temp = b;
	if(c > temp) temp = c;
	if(d > temp) temp = d;
	return temp;
}

template <class T>
inline T Max(const T &a, const T &b, const T &c, const T &d, const T &e)
{
	T temp = a;
	if(b > temp) temp = b;
	if(c > temp) temp = c;
	if(d > temp) temp = d;
	if(e > temp) temp = e;
	return temp;
}

template <class T>
inline T Max(const T &a, const T &b, const T &c, const T &d, const T &e, const T &f)
{
	T temp = a;
	if(b > temp) temp = b;
	if(c > temp) temp = c;
	if(d > temp) temp = d;
	if(e > temp) temp = e;
	if(f > temp) temp = f;
	return temp;
}

template <class T>
inline T Max(const T &a, const T &b, const T &c, const T &d, const T &e, const T &f, const T &g)
{
	T temp = a;
	if(b > temp) temp = b;
	if(c > temp) temp = c;
	if(d > temp) temp = d;
	if(e > temp) temp = e;
	if(f > temp) temp = f;
	if(g > temp) temp = g;
	return temp;
}

template <class T>
inline T Max(const T &a, const T &b, const T &c, const T &d, const T &e, const T &f, const T &g, const T &h)
{
	T temp = a;
	if(b > temp) temp = b;
	if(c > temp) temp = c;
	if(d > temp) temp = d;
	if(e > temp) temp = e;
	if(f > temp) temp = f;
	if(g > temp) temp = g;
	if(h > temp) temp = h;
	return temp;
}


template <class T>
inline T Min(const T &a, const T &b)
{
	if(a < b) return a; else return b;
}

template <class T>
inline T Min(const T &a, const T &b, const T &c)
{
	T temp = a;
	if(b < temp) temp = b;
	if(c < temp) temp = c;
	return temp;
}

template <class T>
inline T Min(const T &a, const T &b, const T &c, const T &d)
{
	T temp = a;
	if(b < temp) temp = b;
	if(c < temp) temp = c;
	if(d < temp) temp = d;
	return temp;
}

template <class T>
inline T Min(const T &a, const T &b, const T &c, const T &d, const T &e)
{
	T temp = a;
	if(b < temp) temp = b;
	if(c < temp) temp = c;
	if(d < temp) temp = d;
	if(e < temp) temp = e;
	return temp;
}

template <class T>
inline T Min(const T &a, const T &b, const T &c, const T &d, const T &e, const T &f)
{
	T temp = a;
	if(b < temp) temp = b;
	if(c < temp) temp = c;
	if(d < temp) temp = d;
	if(e < temp) temp = e;
	if(f < temp) temp = f;
	return temp;
}

template <class T>
inline T Sign(const T &a)
{
	if(a >= 0) return 1; else return -1;
}

template <class T>
inline T Sign(const T &a, const T &b)
{
	if(b >= 0) return abs(a); else return -abs(a);
}

template <class T>
inline void Shift(T &a, T &b, T c)
{
	a = b;
	b = c;
	return;
}

template <class T>
inline void Shift(T &a, T &b, T &c, T d)
{
	a = b;
	b = c;
	c = d;
	return;
}

template <class T>
inline void Swap(T &a, T &b)
{
	T temp = a;
	a = b;
	b = temp;
}

template <class T>
inline T Trim(const T &x, const T &Low, const T &High)
{
	if(x < Low) return Low;
	else if(x > High) return High;
	else return x;
}

template <class T>
inline T Hypot(const T &a, const T &b)
{
	if(a == 0.0) return abs(b);
	else
	{
		T c = b / a;
		return a * sqrt(1.0 + c * c);
	}
}

#endif
