
#ifndef _GenMatUtil_Min
#define _GenMatUtil_Min


template <class T>
T Min(const GeneralVector<T> &x)
{
	int n = x.Size();
	if(n < 1)
	{
		Print("Error in Min");
		Print("n < 1");
		Print("n",n);
		HaltExecution();
	}
	T MinVal = x(0);
	for(int i=1; i<n; i++) if(x(i) < MinVal) MinVal = x(i);
	return MinVal;
}
/*
template <class T>
T Min(const Vector<T> &x)
{
	int n = x.Size();
	T MinVal = x[0];
	for(int i=1; i<n; i++) if(x[i] < MinVal) MinVal = x[i];
	return MinVal;
}

template <class T>
T Min(const Stack<T> &x)
{
	int n = x.Size();
	T MinVal = x[0];
	for(int i=1; i<n; i++) if(x[i] < MinVal) MinVal = x[i];
	return MinVal;
}
*/

template <class T>
T Min(const Matrix<T> &A)
{
	int i,j;
	int m = A.Rows();
	int n = A.Cols();
	T Mn = A(0,0);
	for(i=0; i<m; i++) for(j=0; j<n; j++) if(A(i,j) < Mn) Mn = A(i,j);
	return Mn;
}

template <class T>
T Min(const GeneralMatrix<T> &A)
{
	int i,j;
	int m = A.Rows();
	int n = A.Cols();
	T Mn = A(0,0);
	for(i=0; i<m; i++) for(j=0; j<n; j++) if(A(i,j) < Mn) Mn = A(i,j);
	return Mn;
}

template <class T>
Vector<double> MinBy(const Vector<double> &x, const Vector<T> &y)
{
	int N = x.Size();
	
	Vector<T> List = ListValues(y);
	int K = List.Size();
	Sort(List);
	
	if(y.Size() != N)
	{
		Print("Error in MinBy(x,y,List)");
		Print("Incompadible dimensions");
		Print("x.Name",x.Name);
		Print("y.Name",y.Name);
		Print("x.Size()",x.Size());
		Print("y.Size()",y.Size());
	}	
	
	Vector< Stack<double> > x_By_y(K);
	for(int n=0; n<N; n++)
	{
		int Curr = BinarySearch(List,y[n]);
		if(Curr < 0)
		{
			Print("Error in MinBy");
			Print("Curr < 0");
			Print("Curr",Curr);
			HaltExecution();
		}
		x_By_y[Curr].Push(x[n]);
	}
	Vector<double> Ret(K);
	for(int k=0; k<K; k++) Ret[k] = Min(x_By_y[k]);
	return Ret;
}

#endif