
#ifndef _Output
#define _Output

/*

Output to a file

*/

int OutputPrecision = 16;
string OutputDelim = "\t";

/* Function Prototypes */

	/* Print one vector */
	//template <class T1>
	//void Output(string FileName, const Vector<double> &x1);
		
	template <class T1>
	void Output(string FileName, const Vector<T1> &x1);
	
	template <class T1>
	void Output(string FileName, const Stack<T1> &x1);
	
	/* Print two vectors */
	template <class T1, class T2>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2);
	
	/* Print three vectors */
	template <class T1, class T2, class T3>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2,
								 const GeneralVector<T3> &x3);
	
	/* Print four vectors */
	template <class T1, class T2, class T3, class T4>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2,
								 const GeneralVector<T3> &x3,
								 const GeneralVector<T4> &x4);
					
	/* Print five vectors */
	template <class T1, class T2, class T3, class T4, class T5>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2,
								 const GeneralVector<T3> &x3,
								 const GeneralVector<T4> &x4,
								 const GeneralVector<T5> &x5);
					
	/* Print six vectors */
	template <class T1, class T2, class T3, class T4, class T5, class T6>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2,
								 const GeneralVector<T3> &x3,
								 const GeneralVector<T4> &x4,
								 const GeneralVector<T5> &x5,
								 const GeneralVector<T6> &x6);
	
	/* Print seven vectors */
	template <class T1, class T2, class T3, class T4, class T5, class T6, class T7>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2,
								 const GeneralVector<T3> &x3,
								 const GeneralVector<T4> &x4,
								 const GeneralVector<T5> &x5,
								 const GeneralVector<T6> &x6,
								 const GeneralVector<T7> &x7);
								 
	/* Print eight vectors */
	template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2,
								 const GeneralVector<T3> &x3,
								 const GeneralVector<T4> &x4,
								 const GeneralVector<T5> &x5,
								 const GeneralVector<T6> &x6,
								 const GeneralVector<T7> &x7,
								 const GeneralVector<T8> &x8);
	
	/* Print nine vectors */
	template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2,
								 const GeneralVector<T3> &x3,
								 const GeneralVector<T4> &x4,
								 const GeneralVector<T5> &x5,
								 const GeneralVector<T6> &x6,
								 const GeneralVector<T7> &x7,
								 const GeneralVector<T8> &x8,
								 const GeneralVector<T9> &x9);
	
	/* Print ten vectors */
	template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2,
								 const GeneralVector<T3> &x3,
								 const GeneralVector<T4> &x4,
								 const GeneralVector<T5> &x5,
								 const GeneralVector<T6> &x6,
								 const GeneralVector<T7> &x7,
								 const GeneralVector<T8> &x8,
								 const GeneralVector<T9> &x9,
								 const GeneralVector<T10> &x10);
								 
	/* Print fourteen vectors */
	template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
				class T11, class T12, class T13, class T14>
	void Output(string FileName, const GeneralVector<T1> &x1,
								 const GeneralVector<T2> &x2,
								 const GeneralVector<T3> &x3,
								 const GeneralVector<T4> &x4,
								 const GeneralVector<T5> &x5,
								 const GeneralVector<T6> &x6,
								 const GeneralVector<T7> &x7,
								 const GeneralVector<T8> &x8,
								 const GeneralVector<T9> &x9,
								 const GeneralVector<T10> &x10,
								 const GeneralVector<T11> &x11,
								 const GeneralVector<T12> &x12,
								 const GeneralVector<T13> &x13,
								 const GeneralVector<T14> &x14);
	
	template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			    class T11, class T12, class T13, class T14, class T15, class T16, class T17>
	void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12,
							 const GeneralVector<T13> &x13,
							 const GeneralVector<T14> &x14,
							 const GeneralVector<T15> &x15,
							 const GeneralVector<T16> &x16,
							 const GeneralVector<T17> &x17);

								 
	template <class Type1> 
	void Output(string FileName, Type1 T1);
	
	/* Other output commands */
	template <class T>
	void Output(string FileName, const GeneralMatrix<T> &A);
	
	template <class T1, class T2>
	void Output(string FileName, const GeneralVector<T1> &x, const Matrix<T2> &A);
	
	template <class T1, class T2>
	void Output(string FileName, const Matrix<T1> &A, const GeneralVector<T2> &x);
	
	template <class T1, class T2>
	void Output(string FileName, const Matrix<T1> &A1, const Matrix<T2> &A2);
	
	template <class T1, class T2, class T3>
	void Output(string FileName, const GeneralVector<T1> &x1, const Matrix<T2> &A, const GeneralVector<T3> &x2);

template <class T1>
void Output(string FileName, const Vector<T1> &x1)
{
	int n = x1.Size();
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << "\n";
}

template <class T1>
void OutputNoName(string FileName, const Vector<T1> &x1)
{
	int n = x1.Size();
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<n; i++) out1 << x1[i] << "\n";
}

template <class T1>
void Output(string FileName, const Stack<T1> &x1)
{
	int n = x1.Size();
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << "\n";
}

/*
template <class T1>
void Output(string FileName, const GeneralVector<T1> &x1)
{
	int n = x1.Size();
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << "\n";
}
*/

template <class T1, class T2>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2)
{
	int n = x1.Size();
	if(x2.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 2)");
		Print("Incompadible Dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		HaltExecution();
	}	
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim
		 << x2.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim
							    << x2[i] << "\n";
}

template <class T1, class T2, class T3>
void Output(string FileName, const GeneralVector<T1> &x1, const GeneralVector<T2> &x2, const GeneralVector<T3> &x3)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 3)");
		Print("x1,x2,x3");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim
	     << x2.Name << OutputDelim
	     << x3.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim
								<< x2[i] << OutputDelim
								<< x3[i] << "\n";
}

template <class T1, class T2, class T3, class T4>
void Output(string FileName,
			const GeneralVector<T1> &x1,
			const GeneralVector<T2> &x2,
			const GeneralVector<T3> &x3,
			const GeneralVector<T4> &x4)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 4)");
		Print("x1,x2,x3,x4");
		Print("Incompadible dimensions");
		Print("FileName",FileName);
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim
	     << x2.Name << OutputDelim
	     << x3.Name << OutputDelim
	     << x4.Name << "\n";
	for(int i=0; i<n; i++)
		out1 << x1[i] << OutputDelim
		     << x2[i] << OutputDelim
		     << x3[i] << OutputDelim
		     << x4[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5>
void Output(string FileName, const GeneralVector<T1> &x1, const GeneralVector<T2> &x2, const GeneralVector<T3> &x3,
			 const GeneralVector<T4> &x4, const GeneralVector<T5> &x5)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 5)");
		Print("x1,x2,x3,x4,x5");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim
		 << x2.Name << OutputDelim
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim 
		 << x5.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
								<< x4[i] << OutputDelim 
								<< x5[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 6)");
		Print("x1,x2,x3,x4,x5");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
								<< x4[i] << OutputDelim 
								<< x5[i] << OutputDelim 
								<< x6[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7>
void Output(string FileName, const GeneralVector<T1> &x1, const GeneralVector<T2> &x2, const GeneralVector<T3> &x3,
				const GeneralVector<T4> &x4, const GeneralVector<T5> &x5, const GeneralVector<T6> &x6,
				const GeneralVector<T7> &x7)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n || x7.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 7");
		Print("x1,x2,x3,x4,x5,x6,x7");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
								<< x4[i] << OutputDelim 
								<< x5[i] << OutputDelim 
								<< x6[i] << OutputDelim 
								<< x7[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8>
void Output(string FileName, const GeneralVector<T1> &x1, const GeneralVector<T2> &x2, const GeneralVector<T3> &x3,
				const GeneralVector<T4> &x4, const GeneralVector<T5> &x5, const GeneralVector<T6> &x6,
				const GeneralVector<T7> &x7, const GeneralVector<T8> &x8)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 8)");
		Print("x1,x2,x3,x4,x5,x6,x7,x8");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 9)");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 10");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10");
		Print("Incompadible Dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << "\n";
}


template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 11");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11");
		Print("Incompadible Dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << "\n";
}


template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11, class T12>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n || x12.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 12");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x12.Name",x12.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		Print("x12.Size()",x12.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << OutputDelim
		 << x12.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << OutputDelim 
		                        << x12[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11, class T12, class T13>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12,
							 const GeneralVector<T13> &x13)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n || x12.Size() != n || x13.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 13");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x12.Name",x12.Name);
		Print("x13.Name",x13.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		Print("x12.Size()",x12.Size());
		Print("x13.Size()",x13.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << OutputDelim
		 << x12.Name << OutputDelim
		 << x13.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << OutputDelim 
		                        << x12[i] << OutputDelim
                                << x13[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11, class T12, class T13, class T14>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12,
							 const GeneralVector<T13> &x13,
							 const GeneralVector<T14> &x14)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n || x12.Size() != n || x13.Size() != n || x14.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 14");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14");
		Print("Incompadible Dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x12.Name",x12.Name);
		Print("x13.Name",x13.Name);
		Print("x14.Name",x14.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		Print("x12.Size()",x12.Size());
		Print("x13.Size()",x13.Size());
		Print("x14.Size()",x14.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << OutputDelim
		 << x12.Name << OutputDelim
		 << x13.Name << OutputDelim
		 << x14.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << OutputDelim 
		                        << x12[i] << OutputDelim
		                        << x13[i] << OutputDelim
                                << x14[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11, class T12, class T13, class T14, class T15>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12,
							 const GeneralVector<T13> &x13,
							 const GeneralVector<T14> &x14,
							 const GeneralVector<T15> &x15)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n || x12.Size() != n || x13.Size() != n || x14.Size() != n
			          || x15.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 14");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15");
		Print("Incompadible Dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x12.Name",x12.Name);
		Print("x13.Name",x13.Name);
		Print("x14.Name",x14.Name);
		Print("x15.Name",x15.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		Print("x12.Size()",x12.Size());
		Print("x13.Size()",x13.Size());
		Print("x14.Size()",x14.Size());
		Print("x15.Size()",x15.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << OutputDelim
		 << x12.Name << OutputDelim
		 << x13.Name << OutputDelim
		 << x14.Name << OutputDelim
		 << x15.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << OutputDelim 
		                        << x12[i] << OutputDelim
		                        << x13[i] << OutputDelim
		                        << x14[i] << OutputDelim
                                << x15[i] << "\n";
}


template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11, class T12, class T13, class T14, class T15, class T16>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12,
							 const GeneralVector<T13> &x13,
							 const GeneralVector<T14> &x14,
							 const GeneralVector<T15> &x15,
							 const GeneralVector<T16> &x16)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n || x12.Size() != n || x13.Size() != n || x14.Size() != n
			          || x15.Size() != n || x16.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 16");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x12.Name",x12.Name);
		Print("x13.Name",x13.Name);
		Print("x14.Name",x14.Name);
		Print("x15.Name",x15.Name);
		Print("x16.Name",x16.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		Print("x12.Size()",x12.Size());
		Print("x13.Size()",x13.Size());
		Print("x14.Size()",x14.Size());
		Print("x15.Size()",x15.Size());
		Print("x16.Size()",x16.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << OutputDelim
		 << x12.Name << OutputDelim
		 << x13.Name << OutputDelim
		 << x14.Name << OutputDelim
		 << x15.Name << OutputDelim
		 << x16.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << OutputDelim 
		                        << x12[i] << OutputDelim
		                        << x13[i] << OutputDelim
		                        << x14[i] << OutputDelim
		                        << x15[i] << OutputDelim
		                        << x16[i] << "\n";
}


template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11, class T12, class T13, class T14, class T15, class T16, class T17>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12,
							 const GeneralVector<T13> &x13,
							 const GeneralVector<T14> &x14,
							 const GeneralVector<T15> &x15,
							 const GeneralVector<T16> &x16,
							 const GeneralVector<T17> &x17)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n || x12.Size() != n || x13.Size() != n || x14.Size() != n
			          || x15.Size() != n || x16.Size() != n || x17.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 17");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16,x17");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x12.Name",x12.Name);
		Print("x13.Name",x13.Name);
		Print("x14.Name",x14.Name);
		Print("x15.Name",x15.Name);
		Print("x16.Name",x16.Name);
		Print("x17.Name",x17.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		Print("x12.Size()",x12.Size());
		Print("x13.Size()",x13.Size());
		Print("x14.Size()",x14.Size());
		Print("x15.Size()",x15.Size());
		Print("x16.Size()",x16.Size());
		Print("x17.Size()",x17.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << OutputDelim
		 << x12.Name << OutputDelim
		 << x13.Name << OutputDelim
		 << x14.Name << OutputDelim
		 << x15.Name << OutputDelim
		 << x16.Name << OutputDelim
		 << x17.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << OutputDelim 
		                        << x12[i] << OutputDelim
		                        << x13[i] << OutputDelim
		                        << x14[i] << OutputDelim
		                        << x15[i] << OutputDelim
		                        << x16[i] << OutputDelim
                                << x17[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12,
							 const GeneralVector<T13> &x13,
							 const GeneralVector<T14> &x14,
							 const GeneralVector<T15> &x15,
							 const GeneralVector<T16> &x16,
							 const GeneralVector<T17> &x17,
							 const GeneralVector<T18> &x18)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n || x12.Size() != n || x13.Size() != n || x14.Size() != n
			          || x15.Size() != n || x16.Size() != n || x17.Size() != n || x18.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 18");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16,x17,x18");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x12.Name",x12.Name);
		Print("x13.Name",x13.Name);
		Print("x14.Name",x14.Name);
		Print("x15.Name",x15.Name);
		Print("x16.Name",x16.Name);
		Print("x17.Name",x17.Name);
		Print("x18.Name",x18.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		Print("x12.Size()",x12.Size());
		Print("x13.Size()",x13.Size());
		Print("x14.Size()",x14.Size());
		Print("x15.Size()",x15.Size());
		Print("x16.Size()",x16.Size());
		Print("x17.Size()",x17.Size());
		Print("x18.Size()",x18.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << OutputDelim
		 << x12.Name << OutputDelim
		 << x13.Name << OutputDelim
		 << x14.Name << OutputDelim
		 << x15.Name << OutputDelim
		 << x16.Name << OutputDelim
		 << x17.Name << OutputDelim
		 << x18.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << OutputDelim 
		                        << x12[i] << OutputDelim
		                        << x13[i] << OutputDelim
		                        << x14[i] << OutputDelim
		                        << x15[i] << OutputDelim
		                        << x16[i] << OutputDelim
                                << x17[i] << OutputDelim
                                << x18[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18, class T19>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12,
							 const GeneralVector<T13> &x13,
							 const GeneralVector<T14> &x14,
							 const GeneralVector<T15> &x15,
							 const GeneralVector<T16> &x16,
							 const GeneralVector<T17> &x17,
							 const GeneralVector<T18> &x18,
							 const GeneralVector<T19> &x19)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n || x12.Size() != n || x13.Size() != n || x14.Size() != n
			          || x15.Size() != n || x16.Size() != n || x17.Size() != n || x18.Size() != n
			          || x19.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 19");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16,x17,x18,x19");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x12.Name",x12.Name);
		Print("x13.Name",x13.Name);
		Print("x14.Name",x14.Name);
		Print("x15.Name",x15.Name);
		Print("x16.Name",x16.Name);
		Print("x17.Name",x17.Name);
		Print("x18.Name",x18.Name);
		Print("x19.Name",x19.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		Print("x12.Size()",x12.Size());
		Print("x13.Size()",x13.Size());
		Print("x14.Size()",x14.Size());
		Print("x15.Size()",x15.Size());
		Print("x16.Size()",x16.Size());
		Print("x17.Size()",x17.Size());
		Print("x18.Size()",x18.Size());
		Print("x19.Size()",x19.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << OutputDelim
		 << x12.Name << OutputDelim
		 << x13.Name << OutputDelim
		 << x14.Name << OutputDelim
		 << x15.Name << OutputDelim
		 << x16.Name << OutputDelim
		 << x17.Name << OutputDelim
		 << x18.Name << OutputDelim
		 << x19.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << OutputDelim 
		                        << x12[i] << OutputDelim
		                        << x13[i] << OutputDelim
		                        << x14[i] << OutputDelim
		                        << x15[i] << OutputDelim
		                        << x16[i] << OutputDelim
                                << x17[i] << OutputDelim
                                << x18[i] << OutputDelim
                                << x19[i] << "\n";
}

template <class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10,
			class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18, class T19,
			class T20>
void Output(string FileName, const GeneralVector<T1> &x1,
							 const GeneralVector<T2> &x2,
							 const GeneralVector<T3> &x3,
							 const GeneralVector<T4> &x4,
							 const GeneralVector<T5> &x5,
							 const GeneralVector<T6> &x6,
							 const GeneralVector<T7> &x7,
							 const GeneralVector<T8> &x8,
							 const GeneralVector<T9> &x9,
							 const GeneralVector<T10> &x10,
							 const GeneralVector<T11> &x11,
							 const GeneralVector<T12> &x12,
							 const GeneralVector<T13> &x13,
							 const GeneralVector<T14> &x14,
							 const GeneralVector<T15> &x15,
							 const GeneralVector<T16> &x16,
							 const GeneralVector<T17> &x17,
							 const GeneralVector<T18> &x18,
							 const GeneralVector<T19> &x19,
							 const GeneralVector<T20> &x20)
{
	int n = x1.Size();
	if(x2.Size() != n || x3.Size() != n || x4.Size() != n || x5.Size() != n || x6.Size() != n
			          || x7.Size() != n || x8.Size() != n || x9.Size() != n || x10.Size() != n
			          || x11.Size() != n || x12.Size() != n || x13.Size() != n || x14.Size() != n
			          || x15.Size() != n || x16.Size() != n || x17.Size() != n || x18.Size() != n
			          || x19.Size() != n || x20.Size() != n)
	{
		Print("Error in Output(s,GeneralVector x 20");
		Print("x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16,x17,x18,x19,x20");
		Print("Incompadible dimensions");
		Print("x1.Name",x1.Name);
		Print("x2.Name",x2.Name);
		Print("x3.Name",x3.Name);
		Print("x4.Name",x4.Name);
		Print("x5.Name",x5.Name);
		Print("x6.Name",x6.Name);
		Print("x7.Name",x7.Name);
		Print("x8.Name",x8.Name);
		Print("x9.Name",x9.Name);
		Print("x10.Name",x10.Name);
		Print("x11.Name",x11.Name);
		Print("x12.Name",x12.Name);
		Print("x13.Name",x13.Name);
		Print("x14.Name",x14.Name);
		Print("x15.Name",x15.Name);
		Print("x16.Name",x16.Name);
		Print("x17.Name",x17.Name);
		Print("x18.Name",x18.Name);
		Print("x19.Name",x19.Name);
		Print("x20.Name",x20.Name);
		Print("x1.Size()",x1.Size());
		Print("x2.Size()",x2.Size());
		Print("x3.Size()",x3.Size());
		Print("x4.Size()",x4.Size());
		Print("x5.Size()",x5.Size());
		Print("x6.Size()",x6.Size());
		Print("x7.Size()",x7.Size());
		Print("x8.Size()",x8.Size());
		Print("x9.Size()",x9.Size());
		Print("x10.Size()",x10.Size());
		Print("x11.Size()",x11.Size());
		Print("x12.Size()",x12.Size());
		Print("x13.Size()",x13.Size());
		Print("x14.Size()",x14.Size());
		Print("x15.Size()",x15.Size());
		Print("x16.Size()",x16.Size());
		Print("x17.Size()",x17.Size());
		Print("x18.Size()",x18.Size());
		Print("x19.Size()",x19.Size());
		Print("x20.Size()",x20.Size());
		HaltExecution();
	}
		
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << x1.Name << OutputDelim 
		 << x2.Name << OutputDelim 
		 << x3.Name << OutputDelim 
		 << x4.Name << OutputDelim
		 << x5.Name << OutputDelim 
		 << x6.Name << OutputDelim 
		 << x7.Name << OutputDelim 
		 << x8.Name << OutputDelim
		 << x9.Name << OutputDelim 
		 << x10.Name << OutputDelim 
		 << x11.Name << OutputDelim
		 << x12.Name << OutputDelim
		 << x13.Name << OutputDelim
		 << x14.Name << OutputDelim
		 << x15.Name << OutputDelim
		 << x16.Name << OutputDelim
		 << x17.Name << OutputDelim
		 << x18.Name << OutputDelim
		 << x19.Name << OutputDelim
		 << x20.Name << "\n";
	for(int i=0; i<n; i++) out1 << x1[i] << OutputDelim 
								<< x2[i] << OutputDelim 
								<< x3[i] << OutputDelim
		                        << x4[i] << OutputDelim 
		                        << x5[i] << OutputDelim 
		                        << x6[i] << OutputDelim
		                        << x7[i] << OutputDelim 
		                        << x8[i] << OutputDelim 
		                        << x9[i] << OutputDelim
		                        << x10[i] << OutputDelim 
		                        << x11[i] << OutputDelim 
		                        << x12[i] << OutputDelim
		                        << x13[i] << OutputDelim
		                        << x14[i] << OutputDelim
		                        << x15[i] << OutputDelim
		                        << x16[i] << OutputDelim
                                << x17[i] << OutputDelim
                                << x18[i] << OutputDelim
                                << x19[i] << OutputDelim
                                << x20[i] << "\n";
}


template <class T>
void Output(string FileName, const Matrix<T> &A)
{
	int m = A.Rows();
	int n = A.Cols();
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	if(n > 0)
	{
		for(int i=0; i<m; i++)
		{
			for(int j=0; j<n-1; j++) out1 << A(i,j) << OutputDelim;
			out1 << A(i,n-1) << "\n";	
		}
	}
}

template <class T>
void Output(string FileName, const LowerMatrix<T> &A)
{
	int m = A.Rows();
	int n = A.Cols();
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<m; i++)
	{
		for(int j=0; j<n-1; j++) out1 << A(i,j) << OutputDelim;
		out1 << A(i,n-1) << "\n";	
	}
}

template <class T>
void Output(string FileName, const SymmetricMatrix<T> &A)
{
	int i,j;
	int m = A.Rows();
	int n = A.Cols();
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(i=0; i<m; i++)
	{
		for(j=0; j<n-1; j++) out1 << A(i,j) << OutputDelim;
		out1 << A(i,n-1) << "\n";	
	}
}

template <class T1, class T2>
void Output(string FileName, const GeneralVector<T1> &x, const Matrix<T2> &A)
{
	int m = A.Rows();
	int n = A.Cols();
	if(x.Size() != m)
	{
		Print("Error in Output(s,Vector,Matrix)");
		Print("Incompadible Dimensions");
		Print("x.Size()",x.Size());
		Print("A.Size()",A.Size());
		HaltExecution();
	}
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<m; i++)
	{
		out1 << x[i] << OutputDelim;
		for(int j=0; j<n-1; j++) out1 << A(i,j) << OutputDelim;
		out1 << A(i,n-1) << "\n";	
	}
}

template <class T1, class T2>
void Output(string FileName, const Matrix<T1> &A, const GeneralVector<T2> &x)
{
	int m = A.Rows();
	int n = A.Cols();
	if(x.Size() != m)
	{
		Print("Error in Output(s,Matrix,Vector)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<m; i++)
	{
		for(int j=0; j<n-1; j++) out1 << A(i,j) << OutputDelim;
		out1 << A(i,n-1) << OutputDelim;	
		out1 << x[i] << "\n";
	}
}

template <class T1, class T2, class T3>
void Output(string FileName, const Matrix<T1> &A, const GeneralVector<T2> &x1, const GeneralVector<T3> &x2)
{
	int n = A.Rows();
	int m = A.Cols();
	if(x1.Size() != n || x2.Size() != n)
	{
		Print("Error in Output(s,Matrix,Vector,Vector)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<n; i++)
	{
		for(int j=0; j<m-1; j++) out1 << A(i,j) << OutputDelim;
		out1 << A(i,m-1) << OutputDelim;	
		out1 << x1[i] << OutputDelim;
		out1 << x2[i] << "\n";
	}
}

template <class T1, class T2, class T3, class T4>
void Output(string FileName, const Matrix<T1> &A, const GeneralVector<T2> &x1, const GeneralVector<T3> &x2, const GeneralVector<T4> &x3)
{
	int n = A.Rows();
	int m = A.Cols();
	if(x1.Size() != n || x2.Size() != n || x3.Size() != n)
	{
		Print("Error in Output(s,Matrix,Vector,Vector,Vector)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<n; i++)
	{
		for(int j=0; j<m-1; j++) out1 << A(i,j) << OutputDelim;
		out1 << A(i,m-1) << OutputDelim;	
		out1 << x1[i] << OutputDelim;
		out1 << x2[i] << OutputDelim;
		out1 << x3[i] << "\n";
	}
}

template <class T1, class T2, class T3, class T4, class T5>
void Output(string FileName, const Matrix<T1> &A, const GeneralVector<T2> &x1, const GeneralVector<T3> &x2, const GeneralVector<T4> &x3,
	const Vector<T5> &x4)
{
	int n = A.Rows();
	int m = A.Cols();

	if(x1.Size() != n || x2.Size() != n || x3.Size() != n || x4.Size() != n)
	{
		Print("Error in Output(s,Matrix,Vector,Vector,Vector,Vector)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<n; i++)
	{
		for(int j=0; j<m-1; j++) out1 << A(i,j) << OutputDelim;
		out1 << A(i,m-1) << OutputDelim;	
		out1 << x1[i] << OutputDelim;
		out1 << x2[i] << OutputDelim;
		out1 << x3[i] << OutputDelim;
		out1 << x4[i] << "\n";
	}
}

template <class T1, class T2>
void Output(string FileName, const Matrix<T1> &A, const Matrix<T2> &B)
{
	int m  = A.Rows();
	int nA = A.Cols();
	int nB = B.Cols();
	
	if(B.Rows() != m)
	{
		Print("Error in Output(s,Matrix,Matrix)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	
	for(int j=0; j<nA; j++) out1 << A.Name << "_Row" << ToString(j) << OutputDelim;
	for(int j=0; j<nB-1; j++) out1 << B.Name << "_Row" << ToString(j) << OutputDelim;
	out1 << B.Name << "_Row" << ToString(nB-1) << "\n";
	for(int i=0; i<m; i++)
	{
		for(int j=0; j<nA; j++) out1 << A(i,j) << OutputDelim;
		for(int j=0; j<nB-1; j++) out1 << B(i,j) << OutputDelim;
		out1 << B(i,nB-1) << "\n";	
	}
}

template <class T1, class T2, class T3>
void Output(string FileName, const Matrix<T1> &A1, const Matrix<T2> &A2, const Matrix<T3> &A3)
{
	int m  = A1.Rows();
	int n1 = A1.Cols();
	int n2 = A2.Cols();
	int n3 = A3.Cols();
	
	if(A2.Rows() != m || A3.Rows() != m)
	{
		Print("Error in Output(s,Matrix x 3)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<m; i++)
	{
		for(int j=0; j<n1-1; j++) out1 << A1(i,j) << OutputDelim;
		out1 << A1(i,n1-1) << OutputDelim;
		for(int j=0; j<n2-1; j++) out1 << A2(i,j) << OutputDelim;
		out1 << A2(i,n2-1) << OutputDelim;
		for(int j=0; j<n3-1; j++) out1 << A3(i,j) << OutputDelim;
		out1 << A3(i,n3-1) << "\n";	
	}
}

template <class T1, class T2, class T3, class T4>
void Output(string FileName, const Matrix<T1> &A1, const Matrix<T2> &A2, const Matrix<T3> &A3, const Matrix<T4> &A4)
{
	int m  = A1.Rows();
	int n1 = A1.Cols();
	int n2 = A2.Cols();
	int n3 = A3.Cols();
	int n4 = A4.Cols();
	
	if(A2.Rows() != m || A3.Rows() != m || A4.Rows() != m)
	{
		Print("Error in Output(s,Matrix x 4)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<m; i++)
	{
		for(int j=0; j<n1-1; j++) out1 << A1(i,j) << OutputDelim;
		out1 << A1(i,n1-1) << OutputDelim;
		for(int j=0; j<n2-1; j++) out1 << A2(i,j) << OutputDelim;
		out1 << A2(i,n2-1) << OutputDelim;
		for(int j=0; j<n3-1; j++) out1 << A3(i,j) << OutputDelim;
		out1 << A3(i,n3-1) << OutputDelim;
		for(int j=0; j<n4-1; j++) out1 << A4(i,j) << OutputDelim;
		out1 << A4(i,n4-1) << "\n";	
	}
}

template <class T1, class T2, class T3>
void Output(string FileName, const GeneralVector<T1> &x1, const Matrix<T2> &A, const GeneralVector<T3> &x2)
{
	int m = A.Rows();
	int n = A.Cols();
	if(x1.Size() != m || x2.Size() != m)
	{
		Print("Error in Output(s,Vector,Matrix,Vector)");
		Print("Incompadible Dimensions");
		Print("x1.Size()",x1.Size());
		Print("A.Size()",A.Size());
		Print("x2.Size()",x2.Size());
		HaltExecution();
	}
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<m; i++)
	{
		out1 << x1[i] << OutputDelim;
		for(int j=0; j<n; j++) out1 << A(i,j) << OutputDelim;
		out1 << x2[i] << "\n";	
	}
}

template <class T1, class T2, class T3>
void Output(string FileName, const GeneralVector<T1> &x1, const Array3D<T2> &X, const GeneralVector<T3> &x2)
{
	int d1 = X.Dim1();
	int d2 = X.Dim2();
	int d3 = X.Dim3();
	if(x1.Size() != d1 || x2.Size() != d1)
	{
		Print("Error in Output(s,Vector,Array3D,Vector)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i1=0; i1<d1; i1++)
	{
		out1 << x1[i1] << OutputDelim;
		for(int i2=0; i2<d2; i2++) for(int i3=0; i3<d3; i3++) out1 << X(i1,i2,i3) << OutputDelim;
		out1 << x2[i1] << "\n";
	}
}

template <class T1, class T2>
void Output(string FileName, const GeneralVector<T1> &x1, const Array3D<T2> &X)
{
	int d1 = X.Dim1();
	int d2 = X.Dim2();
	int d3 = X.Dim3();
	if(x1.Size() != d1)
	{
		Print("Error in Output(s,Vector,Array3D)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i1=0; i1<d1; i1++)
	{
		out1 << x1[i1] << OutputDelim;
		for(int i2=0; i2<d2-1; i2++) for(int i3=0; i3<d3; i3++) out1 << X(i1,i2,i3) << OutputDelim;
		for(int i3=0; i3<d3-1; i3++) out1 << X(i1,d2-1,i3) << OutputDelim;
		out1 << X(i1,d2-1,d3-1) << "\n";
	}
}

template <class T1, class T2, class T3>
void Output(string FileName, const GeneralVector<T1> &x1, const Matrix<T2> &A1, const Matrix<T3> &A2)
{
	int n  = x1.Size();
	int m1 = A1.Cols();
	int m2 = A2.Cols();
	if(A1.Rows() != n || A2.Rows() != n)
	{
		Print("Error in Output(s,Vector,Matrix,Matrix)");
		Print("Incompadible Dimensions");
		HaltExecution();
	}
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	for(int i=0; i<n; i++)
	{
		out1 << x1[i] << OutputDelim;
		for(int j=0; j<m1-1; j++) out1 << A1(i,j) << OutputDelim;
		out1 << A1(i,m1-1) << OutputDelim;
		for(int j=0; j<m2-1; j++) out1 << A2(i,j) << OutputDelim;
		out1 << A2(i,m2-1) << "\n";
	}
}

template <class Type1>
void Output(string FileName, Type1 T1)
{
	ofstream out1(FileName.c_str());
	out1.precision(OutputPrecision);
	out1 << T1;
}

#endif
