
#ifndef _Data_ParseUtil
#define _Data_ParseUtil

/*

Utilities for parsing a string

*/

	string Delete1(string s);
	
	Stack<string> ParseBy(const string &s, const char &ch);
	Stack<string> ParseBy(const string &s, char ch1, char ch2);
	Stack<string> ParseBy(const string &s, const string &t);
	
	string VisibleSpaces(string s);
	
	string ToLowerCase(const string &s);
	string ToUpperCase(const string &s);	
	

/*

Create a new string from s without the space, '\n' chracters and '\t' characters


*/

string Delete1(string s)
{
	string snew = "";
	for(int i=0; i<s.length(); i++)
	{
		if(s[i] != ' ' && s[i] != '\t' && s[i] != '\n') snew += s[i];
	}	
	return snew;
}

// Parse a string by ch
/*
void ParseBy(BoundedStack<string> &b, const string &s, const char &ch)
{
	int i = 0;
	string temp;
	b.Clear();
	while(i < s.length())
	{
		temp = "";
		while(s[i] != ch && i < s.length())
		{
			temp += s[i];
			i++;
		}
		b.Push(temp);
		i++;
		if(s[s.length()-1] == ch)
		{
			temp = "";
			b.Push(temp);
		}
	}
	return;
}
*/

Stack<string> ParseBy(const string &s, const char &ch)
{
	int i = 0;
	string temp;
	Stack<string> v;
	if(s.length() == 0)
	{
		return v;
	}
	while(i < s.length())
	{
		temp = "";
		while(s[i] != ch && i < s.length())
		{
			temp += s[i];
			i++;
		}
		v.Push(temp);
		i++;
	}
	if(s[s.length()-1] == ch)
	{
		temp = "";
		v.Push(temp);
	}
	return v;
}

Stack<string> ParseBy(const string &s, char ch1, char ch2)
{
	int i = 0;
	Stack<string> v;
	if(s.length() == 0) return v;
	while(i < s.length())
	{
		string temp = "";
		while(s[i] != ch1 && s[i] != ch2 && i < s.length())
		{
			temp += s[i];
			i++;
		}
		v.Push(temp);
		i++;
	}
	if(s[s.length()-1] == ch1 || s[s.length()-1] == ch2)
	{
		string temp = "";
		v.Push(temp);
	}
	return v;
}


Stack<string> ParseBy(const string &s, const string &t)
{
	int i = 0;
	int m = t.length();
	string temp;
	Stack<string> v;
	if(s.length() == 0) return v;
	
	if(s.length() < t.length())
	{
		v.Push(s);
		return v;
	}
	
	while(i < s.length())
	{
		temp = "";
		while(s.substr(i,m) != t && i < s.length())
		{
			temp += s[i];
			i++;
		}
		v.Push(temp);
		i += m;
		if(s.substr(s.length()-m,m) == t)
		{
			temp = "";
			v.Push(temp);
		}
	}
	return v;
}

string VisibleSpaces(string s)
{
	string t = "";
	for(int i=0; i<s.length(); i++)
	{
		     if(s[i] == '\t') t += "\\t";
		else if(s[i] == '\n') t += "\\n";
		else if(s[i] == ' ' ) t += "\\s";
		else                  t += s[i];
	}
	return t;
}

string ToLowerCase(const string &s)
{
	string t;
	for(int i=0; i<s.length(); i++)  t += tolower(s[i]);
	return t;
}

string ToUpperCase(const string &s)
{
	string t;
	for(int i=0; i<s.length(); i++)  t += toupper(s[i]);
	return t;
}

#endif
