
#ifndef _GenMatUtil_PrintOp
#define _GenMatUtil_PrintOp


	// Overload the cout operator for matrices
	//template <class T> ostream & operator << (ostream &os, const Matrix<T>          &A);
	//template <class T> ostream & operator << (ostream &os, const DiagonalMatrix<T>  &A);
	//template <class T> ostream & operator << (ostream &os, const SymmetricMatrix<T> &A);
	//template <class T> ostream & operator << (ostream &os, const BandMatrix<T>		&A);
	//template <class T> ostream & operator << (ostream &os, const SparseMatrix<T>    &A);
	//template <class T> ostream & operator << (ostream &os, const SparseMatrixRcv<T> &A);
	
/* Overload the cout operator for Matrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const Matrix<T> &A)
{
	int i,j;
	int m = A.Rows();
	int n = A.Cols();
	if(m > 0 && n > 0)
	{
		os << "\n";
		for(i = 0; i < m - 1; i++)
		{
			os << "[ ";
			for(j = 0; j < n - 1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j = 0; j < n - 1; j++) os << A(m-1,j) << "\t";
		os << A(m-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/

/* Overload the cout operator for DiagonalMatrix objects */
#ifdef _GenMat_DiagonalMatrix
	template <class T>
	ostream & operator << (ostream &os, const DiagonalMatrix<T> &A)
	{
		int n = A.Dim();
		if(n > 0)
		{
			os << "\n[ ";
			for(int i = 0; i < n - 1; i++) os << A(i) << ", ";
			os << A(n-1) << " ]";
		}
		else os << "[]";
		return os;	
	}
#endif

/* Overload the cout operator for SymmetricMatrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const SymmetricMatrix<T> &A)
{
	int i,j;
	int n = A.Dim();
	if(n > 0)
	{
		os << "\n";
		for(i=0; i<n-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/

/* Overload the cout operator for SymmetricMatrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const SymmetricMatrixUP<T> &A)
{
	int i,j;
	int n = A.Dim();
	if(n > 0)
	{
		os << "\n";
		for(i=0; i<n-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/


/* Overload the cout operator for LowerMatrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const LowerMatrix<T> &A)
{
	int i,j;
	int n = A.Dim();
	if(n > 0)
	{
		os << "\n";
		for(i=0; i<n-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/

/* Overload the cout operator for UpperMatrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const UpperMatrix<T> &A)
{
	int i,j;
	int n = A.Dim();
	if(n > 0)
	{
		os << "\n";
		for(i=0; i<n-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/

/* Overload the cout operator for BlockMatrix objects */
#ifdef _GenMat_BlockMatrix
	template <class T>
	ostream & operator << (ostream &os, const BlockMatrix<T> &A)
	{
		int i,j,k,b,n;
		
		b = A.Blocks();
		for(i=0; i<b; i++)
		{
			n = A.Block(i);
			os << "\n" << "Block: " << i << "\n";
			for(j=0; j<n-1; j++)
			{
				os << "[ ";
				for(k=0; k<n-1; k++) os << A(i,j,k) << "\t";
				os << A(i,j,n-1) << "]\n";
			}
			os << "[ ";
			for(k=0; k<n-1; k++) os << A(i,n-1,k) << "\t";
			os << A(i,n-1,n-1) << "]";
		}
		return os;	
	}
#endif

/* Overload the cout operator for BandMatrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const BandMatrix<T> &A)
{
	int i,j;
	int n = A.Dim();
	if(n > 0)
	{
		os << "\n";
		for(i=0; i<n-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/

// Overload the << operator for SparseMatrix objects
/*
template <class T>
ostream & operator << (ostream &os, const SparseMatrix<T> &A)
{
	int i,j;
	os << "\n";
	os << "Row\tColumn\tValue\n";
	os << "---\t------\t-----\n";
	for(i=0; i<NumRows; i++) for(j=RowVec[i]; j<RowVec[i+1]; j++)
	os << i << "\t" << ColVec[j] << "\t" << ValVec[j] << "\n";
	return;
	return os;	
}
*/

/* Overload the cout operator for SparseMatrix objects */
#ifdef _GenMat_SparseMatrix
	template <class T>
	ostream & operator << (ostream &os, const SparseMatrix<T> &A)
	{
		int m   = A.Rows();
		int len = A.Length();

		if(SparseMatrixPrintOpt == 0)
		{
			/* 	Print the SparseMatrix in short form. */
			os << "\n";
			
			if(len > 0)
			{
				os << "Row: " << "[";
				for(int i=0; i<m; i++) for(int j=A.RowLoc(i); j<A.RowLoc(i+1); j++) os << i << "\t";
				os << "]\n";
				
				os << "Col: " << "[";
				for(int i=0; i<len-1; i++) os << A.Col(i) << "\t";
				os << A.Col(len-1) << "]\n";
				
				os << "Val: " << "[";
				for(int i=0; i<len-1; i++) os << A.Val(i) << "\t";
				os << A.Val(len-1) << "]\n";
			}
			else
			{
				os << "[]";
			}
			
			os << "\n";
		}
		else
		{	
			/*
			
			Print the matrix in long form.
			This utility assumes that the matrix indices
			are properly ordered
			
			*/
			
			/* This may not be the most efficient way to do this */
			
			int m = A.Rows();
			int n = A.Cols();
			Matrix<double> B(m,n,Zero);
			for(int i=0; i<m; i++) for(int j=A.r[i]; j<A.r[i+1]; j++) B(i,A.Col(j)) = A.Val(j);
			os << B;
		}
			
		return os;
	}
#endif

/* Overload the cout operator for SparseMatrix objects */
#ifdef _GenMat_SparseMatrixCC
	template <class T>
	ostream & operator << (ostream &os, const SparseMatrixCC<T> &A)
	{

		int n   = A.Cols();
		int len = A.Length();

		if(SparseMatrixPrintOpt == 0)
		{
			/* 	Print the SparseMatrix in short form. */
			
			os << "\n";
			
			if(len > 0)
			{
				os << "Row: " << "[";
				for(int i=0; i<len-1; i++) os << A.Row(i) << "\t";
				os << A.Row(len-1) << "]\n";
				
				os << "Col: " << "[";
				for(int i=0; i<n; i++) for(int j=A.ColLoc(i); j<A.ColLoc(i+1); j++) os << i << "\t";
				os << "]\n";			
				
				os << "Val: " << "[";
				for(int i=0; i<len-1; i++) os << A.Val(i) << "\t";
				os << A.Val(len-1) << "]\n";
			}
			else
			{
				os << "[]";
			}
			
			os << "\n";
		}
		else
		{	
			/*
			
			Print the matrix in long form.
			This utility assumes that the matrix indices
			are properly ordered
			
			*/
			
			/* This may not be the most efficient way to do this */
			
			int m = A.Rows();
			int n = A.Cols();
			Matrix<double> B(m,n,Zero);
			for(int j=0; j<n; j++) for(int i=A.c[j]; i<A.c[j+1]; i++) B(A.r[i],j) = A.v[i];		
			os << B;
		}
			
		return os;
	}
#endif

/* Overload the cout operator for SparseMatrixRcv objects */
#ifdef _GenMat_SparseMatrixRcv
	template <class T>
	ostream & operator << (ostream &os, const SparseMatrixRcv<T> &A)
	{
		int len = A.Length();
		if(SparseMatrixPrintOpt == 0)
		{
			/* Print the SparseMatrixRcv in short form. */

			os << "\n";
			
			os << "Row: " << "[";
			for(int i=0; i<len-1; i++) os << A.Row(i) << "\t";
			os << A.Row(len-1) << "]\n";
			
			os << "Col: " << "[";
			for(int i=0; i<len-1; i++) os << A.Col(i) << "\t";
			os << A.Col(len-1) << "]\n";
			
			os << "Val: " << "[";
			for(int i=0; i<len-1; i++) os << A.Val(i) << "\t";
			os << A.Val(len-1) << "]\n";
			
			os << "\n";
		}
		else
		{
			/*
			
			Print the matrix in long form.
			This utility assumes that the matrix indices
			are properly ordered.
			
			*/
			
			/* This may not be the most efficient way to do this */
			int m = A.Rows();
			int n = A.Cols();
			Matrix<double> B(m,n,0.0);
			for(int k=0; k<A.Length(); k++) B(A.Row(k),A.Col(k)) = A.Val(k);
			os << B;
		}
		
		return os;	
	}
#endif

/* Overload the cout operator for LowerMatrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const LowerMatrixUN<T> &A)
{
	int i,j;
	int n = A.Dim();
	if(n > 0)
	{
		os << "\n";
		for(i=0; i<n-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/


/* Overload the cout operator for LowerMatrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const LowerMatrixUU<T> &A)
{
	int i,j;
	int n = A.Dim();
	if(n > 0)
	{
		os << "\n";
		for(i=0; i<n-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/

/* Overload the cout operator for LowerMatrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const UpperMatrixUN<T> &A)
{
	int i,j;
	int n = A.Dim();
	if(n > 0)
	{
		os << "\n";
		for(i=0; i<n-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/

/* Overload the cout operator for LowerMatrix objects */
/*
template <class T>
ostream & operator << (ostream &os, const UpperMatrixUU<T> &A)
{
	int i,j;
	int n = A.Dim();
	if(n > 0)
	{
		os << "\n";
		for(i=0; i<n-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/

/* Overload the cout operator for LowerMatrix objects */
template <class T>
ostream & operator << (ostream &os, const GeneralMatrix<T> &A)
{
	int m = A.Rows();
	int n = A.Cols();
	if(m > 0 && n > 0)
	{
		os << "\n";
		for(int i=0; i<m-1; i++)
		{
			os << "[ ";
			for(int j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(int j=0; j<n-1; j++) os << A(m-1,j) << "\t";
		os << A(m-1,n-1) << "]";
	}
	else
	{
		os << "[]";
	}
	
	return os;	
}

/*
template <class T>
ostream & operator << (ostream &os, const GeneralMatrixView<T> &A)
{
	int i,j;
	int m = A.Rows();
	int n = A.Cols();
	if(m > 0 && n > 0)
	{
		os << "\n";
		for(i=0; i<m-1; i++)
		{
			os << "[ ";
			for(j=0; j<n-1; j++) os << A(i,j) << "\t";
			os << A(i,n-1) << "]\n";
		}
		os << "[ ";
		for(j=0; j<n-1; j++) os << A(n-1,j) << "\t";
		os << A(n-1,n-1) << "]";
	}
	else os << "[]";
	return os;	
}
*/

/* Overload the cout operator for Array3D objects */
template <class T>
ostream & operator << (ostream &os, const Array3D<T> &A)
{
	int n1 = A.Dim1();
	int n2 = A.Dim2();
	int n3 = A.Dim3();
	
	if(n1 > 0 && n2 > 0 && n3 > 0)
	{
		os << "[";
		for(int i1=0; i1<n1-1; i1++) for(int i2=0; i2<n2; i2++) for(int i3=0; i3<n3; i3++)
			os << A(i1,i2,i3) << ",";
		for(int i2=0; i2<n2-1; i2++) for(int i3=0; i3<n3; i3++)
			os << A(n1-1,i2,i3) << ",";
		for(int i3=0; i3<n3-1; i3++)
			os << A(n1-1,n2-1,i3) << ",";
		os << A(n1-1,n2-1,n3-1) << "]";
	}
	else os << "[]";
	return os;	
}

// Overload the cout operator for vectors
template <class T>
ostream & operator << (ostream &os, const Vector<T> &v)
{
  	int n = v.Size();
   	
   	#ifndef _VectorTabDelim
   		if(n > 0)
		{
			/* Print Vector as comma-delimited */
			os << "[";
			for(int i=0; i<n-1; i++) os << v[i] << ",";
			os << v[n-1] << "]";
		}
		else os << "[]";
	#else
		if(n > 0)
		{
			/* Print Vector as tab-delimited */
			os << "[";
			for(int i=0; i<n-1; i++) os << v[i] << "\t";
			os << v[n-1] << "]";
		}
		else os << "[]";
	#endif
	
   	return os;
}

/* Overload the cout operator for RowVector objects */
template <class T>
ostream & operator << (ostream &os, const RowVector<T> &v)
{
  	int n = v.Size();
   	if(n > 0)
	{
		os << "\n[\n";
		for(int i=0; i<n; i++) os << v[i] << "\n";
		os << "]";
	}
	else os << "[]";
	
   	return os;
}


/* Overload the cout operator for vectors */
#ifdef _GenMat_BlasVector
	template <class T>
	ostream & operator << (ostream &os, const BlasVector<T> &v)
	{
	  	int n   = v.Size();
	  	int inc = v.Increment(); 
	   	
	   	#ifndef _VectorTabDelim
	   		if(n > 0)
			{
				/* Print Vector as comma-delimited */
				os << "[";
				for(int i=0; i<n-1; i++) os << v(i) << ",";
				os << v(n-1) << "]";
			}
			else os << "[]";
		#else
			if(n > 0)
			{
				/* Print Vector as tab-delimited */
				os << "[";
				for(int i=0; i<n-1; i++) os << v(i) << "\t";
				os << v(n-1) << "]";
			}
			else os << "[]";
		#endif
		
	   	return os;
	}
#endif

// Overload the cout operator for vectors
/*
template <class T>
ostream & operator << (ostream &os, const VectorIncremented<T> &v)
{
  	int n   = v.Size();
  	int inc = v.Increment(); 
   	
   	#ifndef _VectorTabDelim
   		if(n > 0)
		{
			/* Print Vector as comma-delimited */
/*			os << "[";
			for(int i=0; i<n-1; i++) os << v(i) << ",";
			os << v(n-1) << "]";
		}
		else os << "[]";
	#else
		if(n > 0)
		{
			/* Print Vector as tab-delimited */
/*			os << "[";
			for(int i=0; i<n-1; i++) os << v(i) << "\t";
			os << v(n-1) << "]";
		}
		else os << "[]";
	#endif
	
   	return os;
}
*/

/* Overload the cout operator for SparseMatrix objects */
#ifdef _GenMat_SparseMatrixView
	ostream & operator << (ostream &os, const SparseMatrixView &A)
	{

		int m   = A.Rows();
		int len = A.Length();

		if(SparseMatrixPrintOpt == 0)
		{
			/* 	Print the SparseMatrix in short form. */
			os << "\n";
			if(len > 0)
			{
				os << "Row: " << "[";
				for(int i=0; i<m; i++) for(int j=A.RowLoc(i); j<A.RowLoc(i+1); j++) os << i << "\t";
				os << "]\n";
				
				os << "Col: " << "[";
				for(int i=0; i<len-1; i++) os << A.Col(i) << "\t";
				os << A.Col(len-1) << "]\n";
				
				os << "Val: " << "[";
				for(int i=0; i<len-1; i++) os << "*\t";
				os << "*]\n";
			}
			else
			{
				os << "[]";
			}
			os << "\n";
		}
		else
		{	
			/*
			
			Print the matrix in long form.
			This utility assumes that the matrix indices
			are properly ordered
			
			*/
			
			/* This may not be the most efficient way to do this */
			
			int m = A.Rows();
			int n = A.Cols();
			Matrix<char> B(m,n,' ');
			for(int i=0; i<m; i++) for(int j=A.r[i]; j<A.r[i+1]; j++) B(i,A.Col(j)) = '*';
			os << B;
		}
			
		return os;
	}
#endif

/* Overload the cout operator for SparseMatrixRcv objects */
#ifdef _GenMat_SparseMatrixRcvView
	ostream & operator << (ostream &os, const SparseMatrixRcvView &A)
	{
		int len = A.Length();
		if(SparseMatrixPrintOpt == 0)
		{
			/* Print the SparseMatrixRcv in short form. */

			os << "\n";
			
			os << "Row: " << "[";
			for(int i=0; i<len-1; i++) os << A.Row(i) << "\t";
			os << A.Row(len-1) << "]\n";
			
			os << "Col: " << "[";
			for(int i=0; i<len-1; i++) os << A.Col(i) << "\t";
			os << A.Col(len-1) << "]\n";
			
			os << "Val: " << "[";
			for(int i=0; i<len-1; i++) os << "*\t";
			os << "*]\n";
			
			os << "\n";
		}
		else
		{
			/*
			
			Print the matrix in long form.
			This utility assumes that the matrix indices
			are properly ordered.
			
			*/
			
			/* This may not be the most efficient way to do this */
			int m = A.Rows();
			int n = A.Cols();
			Matrix<char> B(m,n,' ');
			for(int k=0; k<A.Length(); k++) B(A.Row(k),A.Col(k)) = '*';
			os << B;
		}
		
		return os;	
	}
#endif

/* Overload the cout operator for SparseMatrix objects */
#ifdef _GenMat_SparseMatrixCCView
	ostream & operator << (ostream &os, const SparseMatrixCCView &A)
	{

		int n   = A.Cols();
		int len = A.Length();

		if(SparseMatrixPrintOpt == 0)
		{
			/* 	Print the SparseMatrix in short form. */
			
			os << "\n";
			
			if(len > 0)
			{
				os << "Row: " << "[";
				for(int i=0; i<len-1; i++) os << A.Row(i) << "\t";
				os << A.Row(len-1) << "]\n";
				os << "]\n";
				
				os << "Col: " << "[";
				for(int j=0; j<n; j++) for(int i=A.ColLoc(j); i<A.ColLoc(j+1); i++) os << j << "\t";
				os << A.Col(len-1) << "]\n";
				
				os << "Val: " << "[";
				for(int i=0; i<len-1; i++) os << "*\t";
				os << "*]\n";
			}
			else
			{
				os << "[]";
			}
			
			os << "\n";
		}
		else
		{	
			/*
			
			Print the matrix in long form.
			This utility assumes that the matrix indices
			are properly ordered
			
			*/
			
			/* This may not be the most efficient way to do this */
			
			int m = A.Rows();
			int n = A.Cols();
			Matrix<char> B(m,n,' ');
			for(int j=0; j<n; j++) for(int i=A.c[j]; i<A.c[j+1]; i++) B(A.Row(i),j) = '*';
			os << B;
		}
			
		return os;
	}
#endif

/* Overload the cout operator for DiagonalMatrix objects */
template <class T1, class T2>
ostream & operator << (ostream &os, const pair<T1,T2> &p)
{
	os << "(" << p.first << "," << p.second << ")";
	return os;	
}

// Overload the cout operator for vectors
template <class T>
ostream & operator << (ostream &os, const vector<T> &v)
{
  	int n = v.size();
   	
   	#ifndef _VectorTabDelim
   		if(n > 0)
		{
			/* Print Vector as comma-delimited */
			os << "[";
			for(int i=0; i<n-1; i++) os << v[i] << ",";
			os << v[n-1] << "]";
		}
		else os << "[]";
	#else
		if(n > 0)
		{
			/* Print Vector as tab-delimited */
			os << "[";
			for(int i=0; i<n-1; i++) os << v[i] << "\t";
			os << v[n-1] << "]";
		}
		else os << "[]";
	#endif
	
   	return os;
}

// Overload the cout operator for vectors
template <class T>
ostream & operator << (ostream &os, const set<T> &s)
{
	set<T>::const_iterator it;
	os << "{";
  	for(it = s.begin(); it != s.end(); it++)
    {
        os << *it << ",";
    }
    os << "}";
    return os;
}

#endif
