
#ifndef _GenMatUtil_Set
#define _GenMatUtil_Set



/* Function Prototypes */

	template <class T> void Set(Vector<T>          &v, const T &c);
	template <class T> void Set(Matrix<T>          &A, const T &c);
	template <class T> void Set(SymmetricMatrix<T> &A, const T &c);
	template <class T> void Set(LowerMatrix<T>     &A, const T &c);
	template <class T> void Set(GeneralMatrix<T>   &A, const T &c);



template <class T>
void Set(Vector<T> &v, const T &c)
{
	int n = v.Size();
	BlasSet(n,c,v.Begin(),1);
}

template <class T>
void Set(Matrix<T> &A, const T &c)
{
	int len = A.Length();
	BlasSet(len,c,A.Begin(),1);
}

template <class T>
void Set(SymmetricMatrix<T> &A, const T &c)
{
	int len = A.Length();
	BlasSet(len,c,A.Begin(),1);
}

#ifdef _GenMat_SymmetricMatrixUP
	template <class T>
	void Set(SymmetricMatrixUP<T> &A, const T &c)
	{
		int len = A.Length();
		BlasSet(len,c,A.Begin(),1);
	}
#endif

template <class T>
void Set(LowerMatrix<T> &A, const T &c)
{
	int len = A.Length();
	BlasSet(len,c,A.Begin(),1);
}

#ifdef _GenMat_LowerBandMatrix
	template <class T>
	void Set(LowerBandMatrix<T> &A, const T &c)
	{
		int len = A.Length();
		BlasSet(len,c,A.Begin(),1);
	}
#endif

template <class T>
void Set(GeneralAssignableMatrix<T> &A, const T &c)
{
	int m = A.Rows();
	int n = A.Cols();
	for(int i=0; i<m; i++) for(int j=0; j<n; j++) A(i,j) = c;
}

template <class T>
void Set(Array3D<T> &A, const T &c)
{
	int d1 = A.Dim1();
	int d2 = A.Dim2();
	int d3 = A.Dim3();
	for(int i1=0; i1<d1; i1++) for(int i2=0; i2<d2; i2++) for(int i3=0; i3<d3; i3++) A(i1,i2,i3) = c;
}

#endif
