
#ifndef _GenMat_SetObj
#define _GenMat_SetObj


template <class T>
class SetObj
{

	public:

	Stack<T> s;
	
	SetObj() {}
	
	~SetObj() {}
	
	SetObj(const GeneralVector<T> &v)
	{	
		//for(int i=0; i<v.Size(); i++)
		//{
		//	this->Insert(v(i));
		//}
		this->Insert(v);
	}
	
	SetObj(const SetObj<T> &A)
	{	
		s = A.s;
	}
	
	bool Insert(const T &a)
	{
		int Info = BinarySearch(s,a);
		if(Info < 0)
		{
			s.Push(a);
			Sort(s);
			return True;
		}
		return False;		
	}
	
	bool Insert(const GeneralVector<T> &v) // NOT EFFICIENT
	{
		/* Check for duplicates in v */
		int n = v.Size();
		Vector<T> v2(n);
		Copy(v2,v);
		Sort(v2);
		Vector<bool> i2(n,True);
		for(int i=1; i<n; i++) if(v2(i) == v2(i-1)) i2(i) = False;
		bool Info2 = False;
		Stack<T> Temp;
		for(int i=0; i<v2.Size(); i++)
		{
			if(i2(i))
			{
				int Info = BinarySearch(s,v2(i));
				if(Info < 0)
				{
					Temp.Push(v2(i));
					Info2 = True;
				}
			}
		}		
		for(int i=0; i<Temp.Size(); i++) s.Push(Temp(i));
		Sort(s);	
		return Info2;
	}
	
	bool Remove(const T &a)
	{
		int Info = BinarySearch(s,a);
		if(Info < 0)
		{
			return False;
		}
		else
		{
			/* Probably Not Efficient */
			int k = s.Size();
			Stack<T> Temp;
			for(int i=k-1; i>Info; i--) Temp.Push(s.Pop());
			s.Pop();
			for(int i=Info+1; i<k; i++) s.Push(Temp.Pop());
			return True;
		}
	}
	
	const bool Contains(const T &a) const
	{
		int Info = BinarySearch(s,a);
		return (Info >= 0);
	}
	
	T Min()
	{
		return s(0);
	}
	
	T Max()
	{
		return s(s.Size()-1);
	}
	
	int Size()
	{
		return s.Size();
	}
	
	/* B = A is shorthand notation for B.Ref(A) */
	/*
	template <class T>
	SetObj<T> & operator=(const SetObj<T> &A)
	{
		return A;
	}
	*/
	
	Vector<T> ToVector()
	{
		int n = s.Size();
		Vector<T> v(n);
		for(int i=0; i<n; i++) v(i) = s(i);
		return v;	
	}
	
	inline void operator += (const T &a)
	{
		this->Insert(a);
	}

	inline void operator -= (const T &a)
	{
		this->Remove(a);
	}

};

/* Overload the cout operator for DiagonalMatrix objects */
template <class T>
ostream & operator << (ostream &os, const SetObj<T> &s)
{
	os << s.s;
	return os;	
}

template <class T>
SetObj<T> operator - (const SetObj<T> &A, const T &x)
{
	/* Note: This Code is Probabily Not Efficient */
	SetObj<T> C;
	for(int i=0; i<A.s.Size(); i++) if(A.s(i) != x) C.Insert(A.s(i));
	return C;
}

template <class T>
SetObj<T> operator - (const SetObj<T> &A, const SetObj<T> &B)
{
	/* Note: This Code is Probabily Not Efficient */
	SetObj<T> C;
	for(int i=0; i<A.s.Size(); i++) if(!B.Contains(A.s(i))) C.Insert(A.s(i));
	return C;
}

/*
template <class T>
void operator += (const T &a)
{
	this->Insert(a);
}
*/
/*
template <class T>
void operator -= (const T &a)
{
	this->Remove(a);
}
*/

template <class T>
SetObj<T> Union(const SetObj<T> &A, const SetObj<T> &B)
{
	/* Note: This Code is Probabily Not Efficient */
	SetObj<T> C;
	for(int i=0; i<A.s.Size(); i++) C.Insert(A.s(i));
	for(int i=0; i<B.s.Size(); i++) C.Insert(B.s(i));
	return C;
}

#endif