
#ifndef _Sort
#define _Sort



	template <class T> void Sort(Vector<T> &v);
	template <class T> void Sort(Stack<T> &v);
	template <class T> bool IsSorted(const GeneralVector<T> &v);
	template <class T> Vector<T> SortCopy(const GeneralVector<T> &v);
	//template <class T> void Sort(Vector<T> &v, bool (*LessThan)(const T &, const T &));


template <class T>
void Sort(Vector<T> &v)
{
	sort(v.Begin(),v.End());
}

template <class T>
void Sort(Stack<T> &v)
{
	sort(v.Begin(),v.End());
}

template <class T>
bool IsSorted(const GeneralVector<T> &v)
{
	Vector<T> w(v.Size());
	Copy(w,v);
	Sort(w);
	return (w == v);
}

template <class T>
Vector<T> SortCopy(const GeneralVector<T> &v)
{
	int n = v.Size();
	Vector<T> w(n);
	for(int i=0; i<n; i++) w(i) = v(i);
	Sort(w);
	return w;
}

template <class T>
void Sort(Vector<T> &v, bool (*LessThan)(const T &, const T &))
{
	sort(v.Begin(),v.End(),LessThan);
}

#endif
