
#ifndef _Timer
#define _Timer

/* Utility for timing in c++ */

class Timer
{

	public:

	int PrintLevel;
	clock_t StartTime;
	clock_t StopTime;
	double CpuTimeUsed;
	string Name;

	/* Constructor 1 */
	Timer()
	{
		PrintLevel = 1;
		CpuTimeUsed = Zero;
		Name = "NoName";
	}

	/* Constructor 2 */
	Timer(int PrintLevel) : PrintLevel(PrintLevel)
	{
		CpuTimeUsed = Zero;
		Name = "NoName";
	}

	/* Set the Start Time */
	void Start()
	{
		if(PrintLevel) Print("Start Timer " + Name);
		StartTime = clock();
	}
	
	void Pause()
	{
		if(PrintLevel) Print("Pause Timer " + Name);
		StopTime = clock();
		CpuTimeUsed += ((double)(StopTime - StartTime)) / CLOCKS_PER_SEC;
	}
	
	/* Set the End Time */
	double Stop()
	{
		StopTime = clock();
		CpuTimeUsed += ((double)(StopTime - StartTime)) / CLOCKS_PER_SEC;
		if(PrintLevel) Print("End Timer " + Name + ". CPU Time Used: " + ToString(CpuTimeUsed) + "s (" + ToString(CpuTimeUsed/60.0) + "m)");
		double Temp = CpuTimeUsed;
		CpuTimeUsed = Zero;
		return Temp;		
	}
	
	/* Set the End Time */
	double Report()
	{
		double CurrTime = clock();
		double Temp = ((double)(CurrTime - StartTime)) / CLOCKS_PER_SEC;
		if(PrintLevel) Print("Curr Timer " + Name + ". CPU Time Used: " + ToString(Temp) + "s (" + ToString(Temp/60.0) + "m)");	
		return Temp;		
	}

};

#endif
