
/* Include Subroutimes */
//#define _KNITRO (commented out commercial optimizer to allow replication)
#define _SaveMem
#define _CheckBounds
#define _CheckBoundsBracket
#define _IncludeDenseMatrix
#define LongInt int

#define OPT_EVAL_F 0 // Evaluate function
#define OPT_EVAL_DF 1 // Evaluate derivative
#define OPT_EVAL_HV 2 // Evaluate hessian-vector product
#define OPT_EVAL_H 3 // Evaluate hessian
#define OPT_EVAL_OTH 99 // Evaluate, special code

#include <iostream>
#include <cmath>
#include <sstream>
#include <string>
#include <fstream>
#include <utility>
#include <set>
#include <vector>
using namespace std;

#include "Constant.cpp"
#include "Macro.cpp"
#include "FloatUtil.cpp"
#include "Print.cpp"
#include "Exception.cpp"
#include "Options.cpp"
#include "PauseExecution.cpp"
#include "HaltExecution.cpp"
#include "Convert.cpp"
#include "Timer.cpp"
#include "Log.cpp"
#include "Abs.cpp"
#include "BlasCopy.cpp"
#include "BlasDot.cpp"
#include "BlasIdaMax.cpp"
#include "BlasSwap.cpp"
#include "BlasScal.cpp"
#include "BlasSet.cpp"
#include "BlasNrm2.cpp"
#include "BlasSum.cpp"
#include "BlasAxpy.cpp"
#include "BlasTrsm.cpp"
#include "BlasGemv.cpp"
#include "BlasSyrk.cpp"
#include "BlasSpr.cpp"
#include "BlasGemm.cpp"
#include "BlasTpsv.cpp"
#include "BlasTpmv.cpp"
#include "BlasTrmv.cpp"
#include "BlasTrmm.cpp"
#include "GeneralVector.cpp"
#include "Vector.cpp"
#include "RowVector.cpp"
#include "Stack.cpp"
#include "SetObj.cpp"
#include "GeneralMatrix.cpp"
#include "GeneralDenseMatrix.cpp"
#include "GeneralAssignableMatrix.cpp"
#include "Matrix.cpp"
#include "SymmetricMatrix.cpp"
#include "SymmetricMatrixLU.cpp"
#include "LowerMatrix.cpp"
#include "LowerMatrixUN.cpp"
#include "UpperMatrix.cpp"
#include "DiagonalMatrix.cpp"
#include "Array3D.cpp"
#include "LapackLaswp.cpp"
#include "LapackGetf2.cpp"
#include "LapackGetrf.cpp"
#include "LapackGetrs.cpp"
#include "LapackTrti2.cpp"
#include "LapackTptri.cpp"
#include "LapackTrtri.cpp"
#include "LapackGetri.cpp"
#include "LapackPotf2.cpp"
#include "LapackPotrf.cpp"
#include "LapackPotrs.cpp"
#include "LapackPptri.cpp"
#include "LapackPptrf.cpp"
#include "ListValues.cpp"
#include "Set.cpp"
#include "IsNan.cpp"
#include "AddOp.cpp"
#include "Subtract.cpp"
#include "SubtractOp.cpp"
#include "Min.cpp"
#include "Max.cpp"
#include "MaxAbs.cpp"
#include "Copy.cpp"
#include "Sum.cpp"
#include "IsSymmetric.cpp"
#include "PrintOp.cpp"
#include "ProdAX.cpp"
#include "ProdCXOp.cpp"
#include "ProdAtX.cpp"
#include "ProdAXOp.cpp"
#include "ProdABOp.cpp"
#include "ProdABA.cpp"
#include "ProdAAt.cpp"
#include "ProdAtBA.cpp"
#include "ProdABt.cpp"
#include "ProdABAt.cpp"
#include "ProdXtAX.cpp"
#include "ProdXtY.cpp"
#include "ProdAB.cpp"
#include "ProdCAOp.cpp"
#include "SumProdAtX.cpp"
#include "MiscUtil.cpp"
#include "NotOp.cpp"
#include "SVDecompObj.cpp"
#include "Transpose.cpp"
#include "ComponentDiv.cpp"
#include "ToVector.cpp"
#include "ToSymmetricMatrix.cpp"
#include "Load.cpp"
#include "Diag.cpp"
#include "LUDecompObj.cpp"
#include "CholeskyDecompObj.cpp"
#include "LinSolve.cpp"
#include "LinSolveCholesky.cpp"
#include "InverseLU.cpp"
#include "Inverse.cpp"
#include "InverseCholesky.cpp"
#include "CholeskyDecomp.cpp"
#include "CholeskyDecompL.cpp"
#include "LDLUtil.cpp"
#include "PrintLinearEquation.cpp"
#include "BasisSimple.cpp"
#include "Complex.cpp"
#include "EigenvaluesObj.cpp"
#include "DivOp.cpp"
#include "Norm.cpp"
#include "Sort.cpp"
#include "SortBy.cpp"
#include "Search.cpp"
#include "BinarySearch.cpp"
#include "Grid.cpp"
#include "DataPoint.cpp"
#include "Output.cpp"
#include "Input.cpp"
#include "ParseUtil.cpp"
#include "Round.cpp"
#include "Trim.cpp"
#include "Delete.cpp"
#include "Replace.cpp"
#include "ToInteger.cpp"
#include "Date.cpp"
#include "DataFileDelim.cpp"
#include "Permute.cpp"
#include "DistUtil.cpp"
#include "Random.cpp"
#include "DistUniform.cpp"
#include "nmath.h"
#include "dpq.h"
#include "rmath.h"
#include "fmax2.c"
#include "arithmetic.c"
#include "i1mach.c"
#include "d1mach.c"
#include "toms708.c"
#include "pbeta.c"
#include "pbinom.c"
#include "qnorm.c"
#include "qbinom.c"
#include "rbinom.c"
#include "DistNormal.cpp"
#include "DistExponential.cpp"
#include "Gamma.cpp"
#include "DistGamma.cpp"
#include "DistBeta.cpp"
#include "DistChiSquare.cpp"
#include "DistStudent.cpp"
#include "DistBernoulli.cpp"
#include "DistBinomial.cpp"
#include "Deriv1D.cpp"
#include "Solve1D.cpp"
#include "ComputeDerivStep.cpp"
#include "Jacobian3.cpp"
#include "Gradient3.cpp"
#include "Hessian3.cpp"
#include "GradientCheck.cpp"
#include "SolveNewton.cpp"
#include "Projection.cpp"
#include "MinNewtonLin.cpp"
#include "Count.cpp"
#include "Missing.cpp"
#include "MinMax.cpp"
#include "Subset.cpp"
#include "Mean.cpp"
#include "Var.cpp"
#include "StanDev.cpp"
#include "Survey.cpp"
#include "LinRegObj.cpp"
#include "OutputStatTable.cpp"
#include "MEst.cpp"

/* Random Seed */
long RandomSeed = -87987345; // Random Seed

/* Options */
const int    R                 = 5;     // Number of Replication for Imputation
const bool   UseSavedStartVals = False; // Used saved starts vals?
const bool   UseSavedSes       = False; // Used saved standard errors?
const int    Check             = 0;     // 0 = Baselines, 1 = Rho_t/Rho_v spec., 2 = log spec.
const double LogConst          = 0.1;   // Constant to use with log(a + x) specification
const double TolX              = 0.000000000001; // Tolerance for 1D Solvers

/* Global Variables */
const int K1 = 38;  // Number of Moments for MDE
      int L;	    // Number of Values xTilde Takes
      int K;		// Number of Regressors
      int J1;		// Number of CD/DMA Units
      int J2;		// Number of DMA Units
      int P = 611;	// Number of Programs
      int Nep;		// Number of Observations in Election Panel
      int NrcsTot;	// Number of Observations in RCS
Vector<double> qTilde;			// Probabilities in Annenberg Data
Matrix<int>    xTilde;  	  	// Values that x takes in Annenberg Data
Vector<double> EmpMom(K1,Zero); // Empirical Moments
Vector<int> Nrcs;					// Number of Observations in RCS by CD/DMA Unit
Vector<int> Yep;					// Dependent Variable in Election Panel
Matrix<double> Xep;					// Covariates in Election Panel
Vector< Matrix<double> > Xrcs;		// Covariates in RCS by CD/DMA Unit
Matrix<double> eTot_ep;				// Total Ad Exposure in Election Panel
Matrix<double> eDem_ep;				// Democratic Ad Exposure in Election Panel
Matrix<double> eRep_ep;				// Republican Ad Exposure in Election Panel
Vector< Matrix<double> > eTot_rcs;	// Total Ad Exposure in RCS by CD/DMA Unit
Vector< Matrix<double> > eDem_rcs;	// Democratic Ad Exposure in RCS by CD/DMA Unit
Vector< Matrix<double> > eRep_rcs;	// Republican Ad Exposure in RCS by CD/DMA Unit
Vector<double> s_t_Emp;				// Actual Turnout in CD/DMA Unit
Vector<double> s_v_Emp;				// Actual Republican Vote Share in CD/DMA Unit
Vector<int> CurrJ;					// CD/DMA Unit of Observation n in Election Panel
Vector< Matrix<bool> > Watch;		// Did Individual n Watch Show p, by CD/DMA Unit
int Glob_j;							// Current CD/DMA Unit
int Glob_r;							// Current Replication
int Opt; 							// Using Fixed Effects?
Matrix<float> Fac;					// Show Watching Probabilities
Vector< Matrix<float> > Fac_m;		// Show Watching Probabilities, by CD/DMA

/* Estimates */
Vector<double> Psi_t;	// Turnout CD/DMA Unit Fixed Effects
Vector<double> Psi_v;	// Cand. Choice CD/DMA Unit Fixed Effects
Vector<double> Beta_t;	// Turnout Demographic Effects
double         Alpha_t;	// Turnout Ad Effect
double         Rho_t;	// Turnout Ad Power
Vector<double> Beta_v;	// Cand. Choice Demographic Effects
double         Alpha_v;	// Cand. Choice Ad Effect
double         Rho_v;	// Cand. Choice Ad Power

/* Used For Transforming Cable Watching Probabilities */
double ProbFunc1(double x1, double x2, int k)
{
	if(x1 == x2) return x1;
	double d = One - x2 / x1; // Using the cubic formula here
	double d2 = (7.0 - 27.0 * d) / 54.0;
	double d3 = sqrt(Sqr(d2) + Pow3(2.0 / 9.0));
	double d4;
	if(d2 - d3 >= Zero) d4 = pow(d2 - d3,1.0 / 3.0);
	else                d4 = -pow(-(d2 - d3),1.0 / 3.0);
	double r =    pow(d2 + d3,1.0 / 3.0) + d4 - 1.0 / 3.0;
	double p;
	if(r >= 0.0) p = One - pow(r,One / k);
	else         p = One + pow(-r,One / k); // C++ doesn't like to take a 5th root of a negative number
	double q = x1 / (One - r);
	if(IsNan(p * q))
	{
		Print("Error w/ p * q");
		Print("x1",x1);
		Print("x2",x2);
		Print("k",k);
		Print("d",d);
		Print("d2",d2);
		Print("d3",d3);
		Print("d4",d4);
		Print("r",r);
		Print("p",p);
		Print("q",q);
		PauseExecution();
	}
	return p * q; // Assume split population model

}

/* Used For Transforming Sports Watching Probabilities */
DataPoint<double> ProbFunc2(double x1, double x2, double x0, int k)
{
	if(x1 == Zero || x2 == Zero) return DataPoint<double>(); // This happens for one show with few viewers, so set to missing to avoid NaN
	double q = x2 / ((k - One) * x1 / Two + x2);
	double p = (x0 - One) / (pow(One - q,k) - One);
	return p * q; // Assume split population model
}

/* Used For Transforming Sports Watching Probabilities */
DataPoint<double> ProbFunc3(const Vector<double> &Vec, const Vector<int> &InfoVec, int Times)
{
	int Info1 = InfoVec(0);
	int Info2 = InfoVec(1);
	int Info3 = InfoVec(2);
	int Info4 = InfoVec(3);
	double x0 = One - Vec(Info1) - Vec(Info2) - Vec(Info3) - Vec(Info4);
	DataPoint<double> Temp = ProbFunc2(Vec(Info1),Vec(Info2),x0,Times);
	return Temp;
}

/* Moment Function to Solve */
int MomentsFunc(const Vector<double> &Theta, Vector<double> &Mom)
{
	/* Predicted Moments */
	Vector<double> PredMom(K1,Zero);	PredMom.Name = "PredMom";
	Vector<double> NumMom(K1,Zero);	NumMom.Name  = "NumMom";
	for(int l=0; l<L; l++)
	{
		// Constant
		double Temp = Theta(0);

		// Female
		if(xTilde(l,0) == 1) Temp += Theta(1);

		// Black
		if(xTilde(l,1) == 1) Temp += Theta(2);

		// Hispanic
		if(xTilde(l,2) == 1) Temp += Theta(3);

		// Age (Baseline = 3)
	    	 if(xTilde(l,3) == 1) Temp += Theta(4);
		else if(xTilde(l,3) == 2) Temp += Theta(5);
		else if(xTilde(l,3) == 4) Temp += Theta(6);
		else if(xTilde(l,3) == 5) Temp += Theta(7);
		else if(xTilde(l,3) == 6) Temp += Theta(8);

		// Education (Baseline = 4)
		     if(xTilde(l,4) == 1) Temp += Theta(9);
		else if(xTilde(l,4) == 2) Temp += Theta(10);
		else if(xTilde(l,4) == 3) Temp += Theta(11);
		else if(xTilde(l,4) == 5) Temp += Theta(12);
		else if(xTilde(l,4) == 6) Temp += Theta(13);
		else if(xTilde(l,4) == 7) Temp += Theta(14);

		// Married?
		if(xTilde(l,5) == 1) Temp += Theta(15);

		// Employment Status (Baseline is Working full time, Part time, Homemaker, Student, or Other)
		     if(xTilde(l,6) == 1) Temp += Theta(16);
		else if(xTilde(l,6) == 2) Temp += Theta(17);
		else if(xTilde(l,6) == 3) Temp += Theta(18);

		// Income (Baseline = 5)
		     if(xTilde(l,7) == 1) Temp += Theta(19);
		else if(xTilde(l,7) == 2) Temp += Theta(20);
		else if(xTilde(l,7) == 3) Temp += Theta(21);
		else if(xTilde(l,7) == 4) Temp += Theta(22);
		else if(xTilde(l,7) == 6) Temp += Theta(23);
		else if(xTilde(l,7) == 7) Temp += Theta(24);
		else if(xTilde(l,7) == 8) Temp += Theta(25);
		else if(xTilde(l,7) == 9) Temp += Theta(26);

		// Army
		if(xTilde(l,8) == 1) Temp += Theta(27);

		// Region (Baseline is Northeast)
		     if(xTilde(l,9) == 2) Temp += Theta(28);
		else if(xTilde(l,9) == 3) Temp += Theta(29);
		else if(xTilde(l,9) == 4) Temp += Theta(30);

		// Registered
		if(xTilde(l,10) == 1) Temp += Theta(31);

		// Party
		     if(xTilde(l,11) == 1) Temp += Theta(32);
		else if(xTilde(l,11) == 2) Temp += Theta(33);

		// Ideology (Baseline = 3)
		     if(xTilde(l,12) == 1) Temp += Theta(34);
		else if(xTilde(l,12) == 2) Temp += Theta(35);
		else if(xTilde(l,12) == 4) Temp += Theta(36);
		else if(xTilde(l,12) == 5) Temp += Theta(37);

		/* Form Logistic */
		double Temp2 = exp(Temp); // Sample Exp
		if(IsNan(Temp2) || IsInf(Temp2) || IsNegInf(Temp2)) return -2; // Compute error
		double Temp3 = Temp2 / (One + Temp2); // Logit Weight
		if(IsNan(Temp3) || IsInf(Temp3) || IsNegInf(Temp3)) return -3; // Compute error

		// Moment 1 = All
		PredMom(0) += qTilde(l) * Temp3;
		NumMom(0) += qTilde(l);

		// Female
		if(xTilde(l,0) == 1)
		{
			PredMom(1) += qTilde(l) * Temp3;
			NumMom(1) += qTilde(l);
		}

		// Black
		if(xTilde(l,1) == 1)
		{
			PredMom(2) += qTilde(l) * Temp3;
			NumMom(2) += qTilde(l);
		}

		// Hispanic
		if(xTilde(l,2) == 1)
		{
			PredMom(3) += qTilde(l) * Temp3;
			NumMom(3) += qTilde(l);
		}

		// Age
		if(xTilde(l,3) == 1)
		{
			PredMom(4) += qTilde(l) * Temp3;
			NumMom(4) += qTilde(l);
		}
		else if(xTilde(l,3) == 2)
		{
			PredMom(5) += qTilde(l) * Temp3;
			NumMom(5) += qTilde(l);
		}
		else if(xTilde(l,3) == 4)
		{
			PredMom(6) += qTilde(l) * Temp3;
			NumMom(6) += qTilde(l);
		}
		else if(xTilde(l,3) == 5)
		{
			PredMom(7) += qTilde(l) * Temp3;
			NumMom(7) += qTilde(l);
		}
		else if(xTilde(l,3) == 6)
		{
			PredMom(8) += qTilde(l) * Temp3;
			NumMom(8) += qTilde(l);
		}

		// Education
		if(xTilde(l,4) == 1)
		{
			PredMom(9) += qTilde(l) * Temp3;
			NumMom(9) += qTilde(l);
		}
		else if(xTilde(l,4) == 2)
		{
			PredMom(10) += qTilde(l) * Temp3;
			NumMom(10) += qTilde(l);
		}
		else if(xTilde(l,4) == 3)
		{
			PredMom(11) += qTilde(l) * Temp3;
			NumMom(11) += qTilde(l);
		}
		else if(xTilde(l,4) == 5)
		{
			PredMom(12) += qTilde(l) * Temp3;
			NumMom(12) += qTilde(l);
		}
		else if(xTilde(l,4) == 6)
		{
			PredMom(13) += qTilde(l) * Temp3;
			NumMom(13) += qTilde(l);
		}
		else if(xTilde(l,4) == 7)
		{
			PredMom(14) += qTilde(l) * Temp3;
			NumMom(14) += qTilde(l);
		}

		// Married?
		if(xTilde(l,5) == 1)
		{
			PredMom(15) += qTilde(l) * Temp3;
			NumMom(15) += qTilde(l);
		}

		// Employment Status
		if(xTilde(l,6) == 1)
		{
			PredMom(16) += qTilde(l) * Temp3;
			NumMom(16) += qTilde(l);
		}
		else if(xTilde(l,6) == 2)
		{
			PredMom(17) += qTilde(l) * Temp3;
			NumMom(17) += qTilde(l);
		}
		else if(xTilde(l,6) == 3)
		{
			PredMom(18) += qTilde(l) * Temp3;
			NumMom(18) += qTilde(l);
		}

		// Income
		if(xTilde(l,7) == 1)
		{
			PredMom(19) += qTilde(l) * Temp3;
			NumMom(19) += qTilde(l);
		}
		else if(xTilde(l,7) == 2)
		{
			PredMom(20) += qTilde(l) * Temp3;
			NumMom(20) += qTilde(l);
		}
		else if(xTilde(l,7) == 3)
		{
			PredMom(21) += qTilde(l) * Temp3;
			NumMom(21) += qTilde(l);
		}
		else if(xTilde(l,7) == 4)
		{
			PredMom(22) += qTilde(l) * Temp3;
			NumMom(22) += qTilde(l);
		}
		else if(xTilde(l,7) == 6)
		{
			PredMom(23) += qTilde(l) * Temp3;
			NumMom(23) += qTilde(l);
		}
		else if(xTilde(l,7) == 7)
		{
			PredMom(24) += qTilde(l) * Temp3;
			NumMom(24) += qTilde(l);
		}
		else if(xTilde(l,7) == 8)
		{
			PredMom(25) += qTilde(l) * Temp3;
			NumMom(25) += qTilde(l);
		}
		else if(xTilde(l,7) == 9)
		{
			PredMom(26) += qTilde(l) * Temp3;
			NumMom(26) += qTilde(l);
		}

		// Army
		if(xTilde(l,8) == 1)
		{
			PredMom(27) += qTilde(l) * Temp3;
			NumMom(27) += qTilde(l);
		}

		// Region
		if(xTilde(l,9) == 2)
		{
			PredMom(28) += qTilde(l) * Temp3;
			NumMom(28) += qTilde(l);
		}
		else if(xTilde(l,9) == 3)
		{
			PredMom(29) += qTilde(l) * Temp3;
			NumMom(29) += qTilde(l);
		}
		else if(xTilde(l,9) == 4)
		{
			PredMom(30) += qTilde(l) * Temp3;
			NumMom(30) += qTilde(l);
		}

		// Registered
		if(xTilde(l,10) == 1)
		{
			PredMom(31) += qTilde(l) * Temp3;
			NumMom(31) += qTilde(l);
		}

		// Party
		if(xTilde(l,11) == 1)
		{
			PredMom(32) += qTilde(l) * Temp3;
			NumMom(32) += qTilde(l);
		}
		else if(xTilde(l,11) == 2)
		{
			PredMom(33) += qTilde(l) * Temp3;
			NumMom(33) += qTilde(l);
		}

		// Ideology
		if(xTilde(l,12) == 1)
		{
			PredMom(34) += qTilde(l) * Temp3;
			NumMom(34) += qTilde(l);
		}
		else if(xTilde(l,12) == 2)
		{
			PredMom(35) += qTilde(l) * Temp3;
			NumMom(35) += qTilde(l);
		}
		else if(xTilde(l,12) == 4)
		{
			PredMom(36) += qTilde(l) * Temp3;
			NumMom(36) += qTilde(l);
		}
		else if(xTilde(l,12) == 5)
		{
			PredMom(37) += qTilde(l) * Temp3;
			NumMom(37) += qTilde(l);
		}
	}
	for(int k=0; k<K1; k++) PredMom(k) = PredMom(k) / NumMom(k);

	/* Form Moment Conditions */
	for(int k=0; k<K1; k++) Mom(k) = EmpMom(k) - PredMom(k);

	return 0;
}

/* Turnout Inversion Function */
double Func1_t(double x)
{
	double F = Zero;
	if(Glob_j == -1)
	{
		/* No Fixed Effects */
		for(int j=0; j<J1; j++)
		{
			for(int n=0; n<Nrcs(j); n++)
			{
				double Temp_t = x;
				for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xrcs(j)(n,k);
				if(Check != 2) Temp_t += Alpha_t * pow(eTot_rcs(j)(n,Glob_r),Rho_t);
				else           Temp_t += Alpha_t * log(LogConst + eTot_rcs(j)(n,Glob_r));
				double Probit_t = NormalCdf(Temp_t);
				F += Probit_t / (double)NrcsTot;
			}
			F -= s_t_Emp(j) / (double)J1;
		}
	}
	else
	{
		/* Fixed Effects */
		for(int n=0; n<Nrcs(Glob_j); n++)
		{
			double Temp_t = x;
			for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xrcs(Glob_j)(n,k);
			if(Check != 2) Temp_t += Alpha_t * pow(eTot_rcs(Glob_j)(n,Glob_r),Rho_t);
			else           Temp_t += Alpha_t * log(LogConst + eTot_rcs(Glob_j)(n,Glob_r));
			double Probit_t = NormalCdf(Temp_t);
			F += Probit_t / (double)Nrcs(Glob_j);
		}
		F -= s_t_Emp(Glob_j);
	}
	return F;
}

/* Vote Share Inversion Function */
double Func1_v(double x)
{
	double F = Zero;
	if(Glob_j == -1)
	{
		/* No Fixed Effects */
		for(int j=0; j<J1; j++)
		{
			double FTemp = Zero;
			for(int n=0; n<Nrcs(j); n++)
			{
				double Temp_t = Psi_t(0);
				for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xrcs(j)(n,k);
				if(Check != 2) Temp_t += Alpha_t * pow(eTot_rcs(j)(n,Glob_r),Rho_t);
				else           Temp_t += Alpha_t * log(LogConst + eTot_rcs(j)(n,Glob_r));
				double Probit_t = NormalCdf(Temp_t);

				double Temp_v = x;
				for(int k=0; k<K; k++) Temp_v += Beta_v(k) * Xrcs(j)(n,k);
				if(Check != 2) Temp_v += Alpha_v * (pow(eRep_rcs(j)(n,Glob_r),Rho_v) - pow(eDem_rcs(j)(n,Glob_r),Rho_v));
				else           Temp_v += Alpha_v * (log(LogConst + eRep_rcs(j)(n,Glob_r)) - log(LogConst + eDem_rcs(j)(n,Glob_r)));

				double Probit_v = NormalCdf(Temp_v);
				FTemp += Probit_t * Probit_v / (double)NrcsTot;
			}
			FTemp /= s_t_Emp(j);
			F += FTemp;
			F -= s_v_Emp(j) / (double)J1;
		}
	}
	else
	{
		/* Fixed Effects */
		for(int n=0; n<Nrcs(Glob_j); n++)
		{
			double Temp_t = Psi_t(Glob_j);
			for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xrcs(Glob_j)(n,k);
			if(Check != 2) Temp_t += Alpha_t * pow(eTot_rcs(Glob_j)(n,Glob_r),Rho_t);
			else           Temp_t += Alpha_t * log(LogConst + eTot_rcs(Glob_j)(n,Glob_r));
			double Probit_t = NormalCdf(Temp_t);

			double Temp_v = x;
			for(int k=0; k<K; k++) Temp_v += Beta_v(k) * Xrcs(Glob_j)(n,k);
			if(Check != 2) Temp_v += Alpha_v * (pow(eRep_rcs(Glob_j)(n,Glob_r),Rho_v) - pow(eDem_rcs(Glob_j)(n,Glob_r),Rho_v));
			else           Temp_v += Alpha_v * (log(LogConst + eRep_rcs(Glob_j)(n,Glob_r)) - log(LogConst + eDem_rcs(Glob_j)(n,Glob_r)));

			double Probit_v = NormalCdf(Temp_v);
			F += Probit_t * Probit_v / (double)Nrcs(Glob_j);
		}
		F /= s_t_Emp(Glob_j);
		F -= s_v_Emp(Glob_j);
	}
	return F;
}

/* Likelihood w/ Market Share Inversion */
int LogProb1(const Vector<double> &Theta, Vector<double> &LP)
{
	int Curr = 0;
	for(int k=0; k<K; k++) Beta_t(k) = Theta(Curr++);
	for(int k=0; k<K; k++) Beta_v(k) = Theta(Curr++);
	Alpha_t = Theta(Curr++);
	Rho_t   = Theta(Curr++);
	Alpha_v = Theta(Curr++);
	Rho_v   = Theta(Curr++);

	/* Solve for Psi */
	if(Opt == 1)
	{
		/* No CD/DMA Unit Fixed Effects */
		Glob_j = -1;

		/* Solve for Psi_t */
		Solve1D s_t(Func1_t);
		s_t.TolX = TolX;
		s_t.Method = 4;
		int Info_t = s_t.Solve(-1000.0,1000.0);
		if(Info_t)
		{
			Print("Error-- did not converge (t)");
			Print("Info_t",Info_t);
			Print("Func1_t(-1000.0)",Func1_t(-1000.0));
			Print("Func1_t(1000.0)",Func1_t(1000.0));
			HaltExecution();
		}
		Set(Psi_t,s_t.x);

		/* Solve for Psi_v */
		Solve1D s_v(Func1_v);
		s_v.TolX = TolX;
		s_v.Method = 4;
		int Info_v = s_v.Solve(-1000.0,1000.0);
		if(Info_v)
		{
			Print("Error-- did not converge (v)");
			Print("Info_v",Info_v);
			Print("Func1_v(-1000.0)",Func1_v(-1000.0));
			Print("Func1_v(1000.0)",Func1_v(1000.0));
			HaltExecution();
		}
		Set(Psi_v,s_v.x);
	}
	else
	{
		/* Include CD/DMA Unit Fixed Effects */
		for(int j=0; j<J1; j++)
		{
			Glob_j = j;

			/* Solve for Psi_t */
			Solve1D s_t(Func1_t);
			s_t.TolX = TolX;
			s_t.Method = 4;
			int Info_t = s_t.Solve(-1000.0,1000.0);
			if(Info_t)
			{
				Print("Error-- did not converge (t)");
				Print("Info_t",Info_t);
				Print("j",j);
				Print("s_t_Emp(j)",s_t_Emp(j));
				Print("s_v_Emp(j)",s_v_Emp(j));
				Print("Func1_t(-1000.0)",Func1_t(-1000.0));
				Print("Func1_t(1000.0)",Func1_t(1000.0));
				return -1;
			}
			Psi_t(j) = s_t.x;

			/* Solve for Psi_v */
			Solve1D s_v(Func1_v);
			s_v.TolX = TolX;
			s_v.Method = 4;
			int Info_v = s_v.Solve(-1000.0,1000.0);
			if(Info_v)
			{
				Print("Error-- did not converge (v)");
				Print("Info_v",Info_v);
				Print("j",j);
				Print("s_t_Emp(j)",s_t_Emp(j));
				Print("s_v_Emp(j)",s_v_Emp(j));
				Print("Func1_v(-1000.0)",Func1_v(-1000.0));
				Print("Func1_v(1000.0)",Func1_v(1000.0));
				Print("Theta",Theta);
				Print("Alpha_t",Alpha_t);
				Print("Rho_t",Rho_t);
				Print("Alpha_v",Alpha_v);
				Print("Rho_v",Rho_v);
				return -1;
			}
			Psi_v(j) = s_v.x;
		}
	}

	if(IsNan(Psi_t) || IsNan(Psi_v)) return -1;

	for(int n=0; n<Nep; n++)
	{
		int j = CurrJ(n);

		double Temp_t = Psi_t(j);
		for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xep(n,k);
		if(Check != 2) Temp_t += Alpha_t * pow(eTot_ep(n,Glob_r),Rho_t);
		else           Temp_t += Alpha_t * log(LogConst + eTot_ep(n,Glob_r));

		double Temp_v = Psi_v(j);
		for(int k=0; k<K; k++) Temp_v += Beta_v(k) * Xep(n,k);
		if(Check != 2) Temp_v += Alpha_v * (pow(eRep_ep(n,Glob_r),Rho_v) - pow(eDem_ep(n,Glob_r),Rho_v));
		else           Temp_v += Alpha_v * (log(LogConst + eRep_ep(n,Glob_r)) - log(LogConst + eDem_ep(n,Glob_r)));

		double Probit_t = NormalCdf(Temp_t);
		double Probit_v = NormalCdf(Temp_v);

		if(Probit_t < Zero || Probit_t > One) return n + 1;
		if(Probit_v < Zero || Probit_v > One) return n + 1;

		if(Yep(n) == 0)
		{
			LP(n) = log(One - Probit_t);
		}
		else if(Yep(n) == 1)
		{
			LP(n) = log(Probit_t * (One - Probit_v));
		}
		else
		{
			LP(n) = log(Probit_t * Probit_v);
		}

		if(IsNan(LP(n)) || IsInf(LP(n)) || IsNegInf(LP(n))) return n + 1;
	}

	return 0;
}

/* Compute Turnout and Vote Shares Changing Ads */
int Func3(double aDemDelta, double aRepDelta, int p, Vector<double> &F)
{
	double p0 = Zero;
	double pD = Zero;
	double pR = Zero;
	for(int n=0; n<Nrcs(Glob_j); n++)
	{
		double eTot = eTot_rcs(Glob_j)(n,Glob_r);
		double eDem = eDem_rcs(Glob_j)(n,Glob_r);
		double eRep = eRep_rcs(Glob_j)(n,Glob_r);

		double TempD = BinomialSample2(floor(aDemDelta),Fac_m(Glob_j)(n,p),RandomSeed);
		TempD += (aDemDelta - floor(aDemDelta)) * BernoulliSample(Fac_m(Glob_j)(n,p),RandomSeed);

		double TempR = BinomialSample2(floor(aRepDelta),Fac_m(Glob_j)(n,p),RandomSeed);
		TempR += (aRepDelta - floor(aRepDelta)) * BernoulliSample(Fac_m(Glob_j)(n,p),RandomSeed);

		eDem += TempD;
		eRep += TempR;
		eTot += TempD + TempR;

		double Temp_t = Psi_t(Glob_j);
		for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xrcs(Glob_j)(n,k);
		if(Check != 2) Temp_t += Alpha_t * pow(eTot,Rho_t);
		else           Temp_t += Alpha_t * log(LogConst + eTot);

		double Temp_v = Psi_v(Glob_j);
		for(int k=0; k<K; k++) Temp_v += Beta_v(k) * Xrcs(Glob_j)(n,k);
		if(Check != 2) Temp_v += Alpha_v * pow(eRep,Rho_v);
		else           Temp_v += Alpha_v * log(LogConst + eRep);
		if(Check != 2) Temp_v -= Alpha_v * pow(eDem,Rho_v);
		else           Temp_v -= Alpha_v * log(LogConst + eDem);

		double Probit_t = NormalCdf(Temp_t);
		double Probit_v = NormalCdf(Temp_v);

		p0 += (One - Probit_t) / (double)Nrcs(Glob_j);
		pD += Probit_t * (One - Probit_v) / (double)Nrcs(Glob_j);
		pR += Probit_t * Probit_v / (double)Nrcs(Glob_j);
	}

	F(0) = p0;
	F(1) = pD;
	F(2) = pR;
	return 0;
}

void Prepare1()
{
	Print("Begin");

	/* Load Simmons Data */
	Print("Loading Simmons Data...");
	DataFileDelim d("Simmons.dat",'\t');
	int I = d.NumObs();
	d.SortBy<string>("Item");
	Vector<string> Item = d.Get<string>("Item");
	Vector<double> All1pt        =   d.Get<double>("All_PopTh"                      );
	Vector<double> Female1pt     =   d.Get<double>("Gender:Female_PopTh"            );
	Vector<double> Black1pt      =   d.Get<double>("Race:Black_PopTh"               );
	Vector<double> Hispanic1pt   =   d.Get<double>("Hispanic:Yes_PopTh"             );
	Vector<double> Age1_18_24pt  =   d.Get<double>("Age:18-24_PopTh"                );
	Vector<double> Age1_25_34pt  =   d.Get<double>("Age:25-34_PopTh"                );
	Vector<double> Age1_35_44pt  =   d.Get<double>("Age:35-44_PopTh"                );
	Vector<double> Age1_45_54pt  =   d.Get<double>("Age:45-54_PopTh"                );
	Vector<double> Age1_55_64pt  =   d.Get<double>("Age:55-64_PopTh"                );
	Vector<double> Age1_65_ppt   =   d.Get<double>("Age:65+_PopTh"                  );
	Vector<double> Educ1_1pt     =   d.Get<double>("Educ:NoFormalSchool_PopTh"      )
	                               + d.Get<double>("Educ:SomeGrade-<8_PopTh"        ); // Grade 8 or lower
	Vector<double> Educ1_2pt     =   d.Get<double>("Educ:HighSchool_9-11_PopTh"     ); // Some high school, no diploma
	Vector<double> Educ1_3pt     =   d.Get<double>("Educ:HighSchool_12_PopTh"       ); // High school diploma or equivalent
	Vector<double> Educ1_4pt     =   d.Get<double>("Educ:Col_<1_PopTh"              )
	                               + d.Get<double>("Educ:Col_1_PopTh"               )
	                               + d.Get<double>("Educ:Col_2_PopTh"               )
	                               + d.Get<double>("Educ:Col_3_PopTh"               ); // Tech/voc sch. after hs, some college but no deg., or Ass. or 2-year deg.
	Vector<double> Educ1_5pt     =   d.Get<double>("Educ:Col_4_PopTh"               ); // Four-year college degree
	Vector<double> Educ1_6pt     =   d.Get<double>("Educ:Grad_NoDegree_PopTh"       ); // Graduate or professional school, no degree
	Vector<double> Educ1_7pt     =   d.Get<double>("Educ:Grad_Degree_PopTh"         ); // Graduate or professional degree
	Vector<double> Married1pt    =   d.Get<double>("Marital:Married_PopTh"          );
	Vector<double> Retired1pt    =   d.Get<double>("Employment:Retired_PopTh"       );
	Vector<double> Unemployed1pt =   d.Get<double>("Employment:TempUnemployed_PopTh");
	Vector<double> Disabled1pt   =   d.Get<double>("Employment:Disabled_PopTh"      );
	Vector<double> Income1_1pt   =   d.Get<double>("Income:<5000_PopTh"             )
	                               + d.Get<double>("Income:5000-7499_PopTh"         )
	                               + d.Get<double>("Income:7500-9999_PopTh"         ); // Less than $10,000
	Vector<double> Income1_2pt   =   d.Get<double>("Income:10000-12499_PopTh"       )
	                               + d.Get<double>("Income:12500-14999_PopTh"       ); // $10,000 to $15,000
	Vector<double> Income1_3pt   =   d.Get<double>("Income:15000-19999_PopTh"       )
				                   + d.Get<double>("Income:20000-24999_PopTh"       ); // $15,000 to $25,000
	Vector<double> Income1_4pt   =   d.Get<double>("Income:25000-29999_PopTh"       )
	                               + d.Get<double>("Income:30000-34999_PopTh"       ); // $25,000 to $35,000
	Vector<double> Income1_5pt   =   d.Get<double>("Income:35000-39999_PopTh"       )
	                               + d.Get<double>("Income:40000-44999_PopTh"       )
	                               + d.Get<double>("Income:45000-49999_PopTh"       ); // $35,000 to $50,000
	Vector<double> Income1_6pt   =   d.Get<double>("Income:50000-59999_PopTh"       )
	                               + d.Get<double>("Income:60000-74999_PopTh"       ); // $50,000 to $75,000
	Vector<double> Income1_7pt   =   d.Get<double>("Income:75000-99999_PopTh"       ); // $75,000 to $100,000
	Vector<double> Income1_8pt   =   d.Get<double>("Income:100000-149999_PopTh"     ); // $100,000 to $150,000
	Vector<double> Income1_9pt   =   d.Get<double>("Income:150000-249999_PopTh"     )
    		  	                   + d.Get<double>("Income:>250000_PopTh"           ); // More than $150,000
    Vector<double> Army1pt       =   d.Get<double>("Army:Yes_PopTh"                 );
	Vector<double> ArmyNo1pt     =   d.Get<double>("Army:No_PopTh"                  );
	Vector<double> Northeast1pt  =   d.Get<double>("Region:Northeast_PopTh"         );
	Vector<double> Midwest1pt    =   d.Get<double>("Region:Midwest_PopTh"           );
	Vector<double> South1pt      =   d.Get<double>("Region:South_PopTh"             );
	Vector<double> West1pt       =   d.Get<double>("Region:West_PopTh"              );
	Vector<double> Registered1pt =   d.Get<double>("Registered:Yes_PopTh"           );
	Vector<double> PartyDem1pt   =   d.Get<double>("Party:Dem_PopTh"                );
	Vector<double> PartyRep1pt   =   d.Get<double>("Party:Rep_PopTh"                );
	Vector<double> PartyInd1pt   =   d.Get<double>("Party:Ind_PopTh"                )
	                               + d.Get<double>("Party:Other_PopTh"              );
	Vector<double> Id1_1pt       =   d.Get<double>("Ideology:VeryLib_PopTh"         );
	Vector<double> Id1_2pt       =   d.Get<double>("Ideology:SomewhatLib_PopTh"     );
	Vector<double> Id1_3pt       =   d.Get<double>("Ideology:Middle_PopTh"          );
	Vector<double> Id1_4pt       =   d.Get<double>("Ideology:SomewhatCon_PopTh"     );
	Vector<double> Id1_5pt       =   d.Get<double>("Ideology:VeryCon_PopTh"         );

	/* Correct Rounding Errors */
	for(int i=0; i<I; i++)
	{
		double All2 = Age1_18_24pt(i) + Age1_25_34pt(i) + Age1_35_44pt(i) + Age1_45_54pt(i) + Age1_55_64pt(i) + Age1_65_ppt(i);
		double Diff = All1pt(i) - All2;
		Age1_18_24pt(i) *= (One + Diff / All2);
		Age1_25_34pt(i) *= (One + Diff / All2);
		Age1_35_44pt(i) *= (One + Diff / All2);
		Age1_45_54pt(i) *= (One + Diff / All2);
		Age1_55_64pt(i) *= (One + Diff / All2);
		Age1_65_ppt(i)  *= (One + Diff / All2);
	}
	for(int i=0; i<I; i++)
	{
		double All2 = Educ1_1pt(i) + Educ1_2pt(i) + Educ1_3pt(i) + Educ1_4pt(i) + Educ1_5pt(i) + Educ1_6pt(i) + Educ1_7pt(i);
		double Diff = All1pt(i) - All2;
		Educ1_1pt(i) *= (One + Diff / All2);
		Educ1_2pt(i) *= (One + Diff / All2);
		Educ1_3pt(i) *= (One + Diff / All2);
		Educ1_4pt(i) *= (One + Diff / All2);
		Educ1_5pt(i) *= (One + Diff / All2);
		Educ1_6pt(i) *= (One + Diff / All2);
		Educ1_7pt(i) *= (One + Diff / All2);
	}
	for(int i=0; i<I; i++)
	{
		double All2 = Income1_1pt(i) + Income1_2pt(i) + Income1_3pt(i) + Income1_4pt(i) + Income1_5pt(i) + Income1_6pt(i) + Income1_7pt(i) + Income1_8pt(i) + Income1_9pt(i);
		double Diff = All1pt(i) - All2;
		Income1_1pt(i) *= (One + Diff / All2);
		Income1_2pt(i) *= (One + Diff / All2);
		Income1_3pt(i) *= (One + Diff / All2);
		Income1_4pt(i) *= (One + Diff / All2);
		Income1_5pt(i) *= (One + Diff / All2);
		Income1_6pt(i) *= (One + Diff / All2);
		Income1_7pt(i) *= (One + Diff / All2);
		Income1_8pt(i) *= (One + Diff / All2);
		Income1_9pt(i) *= (One + Diff / All2);
	}
	for(int i=0; i<I; i++)
	{
		double All2 = Army1pt(i) + ArmyNo1pt(i);
		double Diff = All1pt(i) - All2;
		Army1pt(i)   *= (One + Diff / All2);
		ArmyNo1pt(i) *= (One + Diff / All2);
	}
	for(int i=0; i<I; i++)
	{
		double All2 = Northeast1pt(i) + Midwest1pt(i) + South1pt(i) + West1pt(i);
		double Diff = All1pt(i) - All2;
		Northeast1pt(i) *= (One + Diff / All2);
		Midwest1pt(i)   *= (One + Diff / All2);
		South1pt(i)     *= (One + Diff / All2);
		West1pt(i)      *= (One + Diff / All2);
	}
	for(int i=0; i<I; i++)
	{
		double All2 = PartyDem1pt(i) + PartyRep1pt(i) + PartyInd1pt(i);
		double Diff = All1pt(i) - All2;
		PartyDem1pt(i)   *= (One + Diff / All2);
		PartyRep1pt(i)   *= (One + Diff / All2);
		PartyInd1pt(i)   *= (One + Diff / All2);
	}
	for(int i=0; i<I; i++)
	{
		double All2 = Id1_1pt(i) + Id1_2pt(i) + Id1_3pt(i) + Id1_4pt(i) + Id1_5pt(i);
		double Diff = All1pt(i) - All2;
		Id1_1pt(i) *= (One + Diff / All2);
		Id1_2pt(i)   *= (One + Diff / All2);
		Id1_3pt(i)   *= (One + Diff / All2);
		Id1_4pt(i)   *= (One + Diff / All2);
		Id1_5pt(i)   *= (One + Diff / All2);
	}

	/* Population Marginals from Simmons */
	int Tot_p = BinarySearch(Item,ToString("Total Sample"));
	if(Tot_p < 0)
	{
		Print("Error: Did Not Find Total");
		HaltExecution(); // Break on Error
	}
	Vector< Vector<double> > SimmonsPop(13);
	SimmonsPop(0) = Vector<double>(2);
	SimmonsPop(0)(1) = Female1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(0)(0) = One - SimmonsPop(0)(1);
	SimmonsPop(1) = Vector<double>(2);
	SimmonsPop(1)(1) = Black1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(1)(0) = One - SimmonsPop(1)(1);
	SimmonsPop(2) = Vector<double>(2);
	SimmonsPop(2)(1) = Hispanic1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(2)(0) = One - SimmonsPop(2)(1);
	SimmonsPop(3) = Vector<double>(6);
	SimmonsPop(3)(0) = Age1_18_24pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(3)(1) = Age1_25_34pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(3)(2) = Age1_35_44pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(3)(3) = Age1_45_54pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(3)(4) = Age1_55_64pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(3)(5) = Age1_65_ppt(Tot_p)  / All1pt(Tot_p);
	SimmonsPop(4) = Vector<double>(7);
	SimmonsPop(4)(0) = Educ1_1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(4)(1) = Educ1_2pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(4)(2) = Educ1_3pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(4)(3) = Educ1_4pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(4)(4) = Educ1_5pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(4)(5) = Educ1_6pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(4)(6) = Educ1_7pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(5) = Vector<double>(2);
	SimmonsPop(5)(1) = Married1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(5)(0) = One - SimmonsPop(5)(1);
	SimmonsPop(6) = Vector<double>(4);
	SimmonsPop(6)(0) = Retired1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(6)(1) = Unemployed1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(6)(2) = Disabled1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(6)(3) = One - SimmonsPop(6)(0) - SimmonsPop(6)(1) - SimmonsPop(6)(2);
	SimmonsPop(7) = Vector<double>(9);
	SimmonsPop(7)(0) = Income1_1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(7)(1) = Income1_2pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(7)(2) = Income1_3pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(7)(3) = Income1_4pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(7)(4) = Income1_5pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(7)(5) = Income1_6pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(7)(6) = Income1_7pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(7)(7) = Income1_8pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(7)(8) = Income1_9pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(8) = Vector<double>(2);
	SimmonsPop(8)(1) = Army1pt(Tot_p) / (Army1pt(Tot_p) + ArmyNo1pt(Tot_p));
	SimmonsPop(8)(0) = ArmyNo1pt(Tot_p) / (Army1pt(Tot_p) + ArmyNo1pt(Tot_p));
	SimmonsPop(9) = Vector<double>(4);
	SimmonsPop(9)(0) = Northeast1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(9)(1) = Midwest1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(9)(2) = South1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(9)(3) = West1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(10) = Vector<double>(2);
	SimmonsPop(10)(1) = Registered1pt(Tot_p) / All1pt(Tot_p);
	SimmonsPop(10)(0) = One - SimmonsPop(10)(1);
	SimmonsPop(11) = Vector<double>(3);
	SimmonsPop(11)(0) = PartyDem1pt(Tot_p) / (PartyDem1pt(Tot_p) + PartyRep1pt(Tot_p) + PartyInd1pt(Tot_p));
	SimmonsPop(11)(1) = PartyRep1pt(Tot_p) / (PartyDem1pt(Tot_p) + PartyRep1pt(Tot_p) + PartyInd1pt(Tot_p));
	SimmonsPop(11)(2) = PartyInd1pt(Tot_p) / (PartyDem1pt(Tot_p) + PartyRep1pt(Tot_p) + PartyInd1pt(Tot_p));
	SimmonsPop(12) = Vector<double>(5);
	SimmonsPop(12)(0) = Id1_1pt(Tot_p) / (Id1_1pt(Tot_p) + Id1_2pt(Tot_p) + Id1_3pt(Tot_p) + Id1_4pt(Tot_p) + Id1_5pt(Tot_p));
	SimmonsPop(12)(1) = Id1_2pt(Tot_p) / (Id1_1pt(Tot_p) + Id1_2pt(Tot_p) + Id1_3pt(Tot_p) + Id1_4pt(Tot_p) + Id1_5pt(Tot_p));
	SimmonsPop(12)(2) = Id1_3pt(Tot_p) / (Id1_1pt(Tot_p) + Id1_2pt(Tot_p) + Id1_3pt(Tot_p) + Id1_4pt(Tot_p) + Id1_5pt(Tot_p));
	SimmonsPop(12)(3) = Id1_4pt(Tot_p) / (Id1_1pt(Tot_p) + Id1_2pt(Tot_p) + Id1_3pt(Tot_p) + Id1_4pt(Tot_p) + Id1_5pt(Tot_p));
	SimmonsPop(12)(4) = Id1_5pt(Tot_p) / (Id1_1pt(Tot_p) + Id1_2pt(Tot_p) + Id1_3pt(Tot_p) + Id1_4pt(Tot_p) + Id1_5pt(Tot_p));

	/* Check The Probabilities Sum to 1 */
	if(FreqCheck(SimmonsPop))
	{
		Print("Error - FreqCheck Failed");
		Print("FreqCheck(SimmonsPop)",FreqCheck(SimmonsPop));
		Print("SimmonsPop",SimmonsPop);
		HaltExecution();
	}

	/* Vertical Shares */
	Vector<double> All1vt        = All1pt        / All1pt(Tot_p);
	Vector<double> Female1vt     = Female1pt     / Female1pt(Tot_p);
	Vector<double> Black1vt      = Black1pt      / Black1pt(Tot_p);
	Vector<double> Hispanic1vt   = Hispanic1pt   / Hispanic1pt(Tot_p);
	Vector<double> Age1_18_24vt  = Age1_18_24pt  / Age1_18_24pt(Tot_p);
	Vector<double> Age1_25_34vt  = Age1_25_34pt  / Age1_25_34pt(Tot_p);
	Vector<double> Age1_35_44vt  = Age1_35_44pt  / Age1_35_44pt(Tot_p);
	Vector<double> Age1_45_54vt  = Age1_45_54pt  / Age1_45_54pt(Tot_p);
	Vector<double> Age1_55_64vt  = Age1_55_64pt  / Age1_55_64pt(Tot_p);
	Vector<double> Age1_65_pvt   = Age1_65_ppt   / Age1_65_ppt(Tot_p);
	Vector<double> Educ1_1vt     = Educ1_1pt     / Educ1_1pt(Tot_p);
	Vector<double> Educ1_2vt     = Educ1_2pt     / Educ1_2pt(Tot_p);
	Vector<double> Educ1_3vt     = Educ1_3pt     / Educ1_3pt(Tot_p);
	Vector<double> Educ1_4vt     = Educ1_4pt     / Educ1_4pt(Tot_p);
	Vector<double> Educ1_5vt     = Educ1_5pt     / Educ1_5pt(Tot_p);
	Vector<double> Educ1_6vt     = Educ1_6pt     / Educ1_6pt(Tot_p);
	Vector<double> Educ1_7vt     = Educ1_7pt     / Educ1_7pt(Tot_p);
	Vector<double> Married1vt    = Married1pt    / Married1pt(Tot_p);
	Vector<double> Retired1vt    = Retired1pt    / Retired1pt(Tot_p);
	Vector<double> Unemployed1vt = Unemployed1pt / Unemployed1pt(Tot_p);
	Vector<double> Disabled1vt   = Disabled1pt   / Disabled1pt(Tot_p);
	Vector<double> Income1_1vt   = Income1_1pt   / Income1_1pt(Tot_p);
	Vector<double> Income1_2vt   = Income1_2pt   / Income1_2pt(Tot_p);
	Vector<double> Income1_3vt   = Income1_3pt   / Income1_3pt(Tot_p);
	Vector<double> Income1_4vt   = Income1_4pt   / Income1_4pt(Tot_p);
	Vector<double> Income1_5vt   = Income1_5pt   / Income1_5pt(Tot_p);
	Vector<double> Income1_6vt   = Income1_6pt   / Income1_6pt(Tot_p);
	Vector<double> Income1_7vt   = Income1_7pt   / Income1_7pt(Tot_p);
	Vector<double> Income1_8vt   = Income1_8pt   / Income1_8pt(Tot_p);
	Vector<double> Income1_9vt   = Income1_9pt   / Income1_9pt(Tot_p);
	Vector<double> Army1vt       = Army1pt       / Army1pt(Tot_p);
	Vector<double> ArmyNo1vt     = ArmyNo1pt     / ArmyNo1pt(Tot_p);
	Vector<double> Northeast1vt  = Northeast1pt  / Northeast1pt(Tot_p);
	Vector<double> Midwest1vt    = Midwest1pt    / Midwest1pt(Tot_p);
	Vector<double> South1vt      = South1pt      / South1pt(Tot_p);
	Vector<double> West1vt       = West1pt       / West1pt(Tot_p);
	Vector<double> Registered1vt = Registered1pt / Registered1pt(Tot_p);
	Vector<double> PartyDem1vt   = PartyDem1pt   / PartyDem1pt(Tot_p);
	Vector<double> PartyRep1vt   = PartyRep1pt   / PartyRep1pt(Tot_p);
	Vector<double> PartyInd1vt   = PartyInd1pt   / PartyInd1pt(Tot_p);
	Vector<double> Id1_1vt       = Id1_1pt       / Id1_1pt(Tot_p);
	Vector<double> Id1_2vt       = Id1_2pt       / Id1_2pt(Tot_p);
	Vector<double> Id1_3vt       = Id1_3pt       / Id1_3pt(Tot_p);
	Vector<double> Id1_4vt       = Id1_4pt       / Id1_4pt(Tot_p);
	Vector<double> Id1_5vt       = Id1_5pt       / Id1_5pt(Tot_p);

	/* Load NAES Data */
	Print("Loading NAES RCS Data...");
	DataFileDelim d2("NAES_RCS.dat",'\t');
	int N2 = d2.NumObs();
	Vector<int> cWA01 = d2.Get<int>("cWA01"); // Gender: 1=Male, 2=Female
	Vector<int> cWC03 = d2.Get<int>("cWC03"); // Race: 2=Black
	Vector<int> cWC01 = d2.Get<int>("cWC01"); // Hispanic: 1=Yes
	Vector<int> cWA02 = d2.Get<int>("cWA02"); // Age
	Vector<int> cWA03 = d2.Get<int>("cWA03"); // Education
	Vector<int> cWF07 = d2.Get<int>("cWF07");
	Vector<int> cWB01 = d2.Get<int>("cWB01");
	Vector<int> cWA04 = d2.Get<int>("cWA04");
	Vector<int> cWE01 = d2.Get<int>("cWE01");
	Vector<int> cWF08 = d2.Get<int>("cWF08");
	Vector<int> cRA01 = d2.Get<int>("cRA01");
	Vector<int> cMA01 = d2.Get<int>("cMA01");
	Vector<int> cMA06 = d2.Get<int>("cMA06");

	/* Find Observations to Drop */
	Vector<int> Drop1(N2,0);
	Drop1.Name = "Drop1";
	for(int n=0; n<N2; n++)
	{
		if(cWC03(n) == 998 || cWC03(n) == 999) Drop1(n)++; // Drop if Missing Black
		if(cWC01(n) == 998 || cWC01(n) == 999) Drop1(n)++; // Drop if Missing Hispanic
		if(cWA02(n) == 998 || cWA02(n) == 999) Drop1(n)++; // Drop if Missing Age
		if(cWA03(n) == 998 || cWA03(n) == 999) Drop1(n)++; // Drop if Missing Education
		if(cWF07(n) == 998 || cWF07(n) == 999) Drop1(n)++; // Drop if Missing Married
		if(cWB01(n) == 998 || cWB01(n) == 999) Drop1(n)++; // Drop if Missing Employment Status
		if(cWA04(n) == 998 || cWA04(n) == 999) Drop1(n)++; // Drop if Missing Income
		if(cWE01(n) == 998 || cWE01(n) == 999) Drop1(n)++; // Drop if Missing Army
		if(cMA01(n) == 998 || cMA01(n) == 999) Drop1(n)++; // Drop if Missing Party ID
	}

	/* Recode Annenberg Variables */
	Vector< DataPoint<int> > Female2(N2);		Female2.Name     = "Female2";
	Vector< DataPoint<int> > Black2(N2);		Black2.Name      = "Black2";
	Vector< DataPoint<int> > Hispanic2(N2);		Hispanic2.Name   = "Hispanic2";
	Vector< DataPoint<int> > Age2(N2);			Age2.Name        = "Age2";
	Vector< DataPoint<int> > Educ2(N2);			Educ2.Name       = "Educ2";
	Vector< DataPoint<int> > Married2(N2);		Married2.Name    = "Married2";
	Vector< DataPoint<int> > EmployStat2(N2);	EmployStat2.Name = "EmployStat2";
	Vector< DataPoint<int> > Income2(N2);		Income2.Name     = "Income2";
	Vector< DataPoint<int> > Army2(N2);			Army2.Name       = "Army2";
	Vector< DataPoint<int> > Region2(N2);		Region2.Name     = "Region2";
	Vector< DataPoint<int> > Registered2(N2);	Registered2.Name = "Registered2";
	Vector< DataPoint<int> > Party2(N2);		Party2.Name      = "Party2";
	Vector< DataPoint<int> > Id2(N2);			Id2.Name         = "Id2";

	for(int n=0; n<N2; n++)
	{
		if(cWA01(n) == 998 || cWA01(n) == 999) Female2(n).SetToMissing();
		else if(cWA01(n) == 2) Female2(n) = 1;
		else                   Female2(n) = 0;

		if(cWC03(n) == 998 || cWC03(n) == 999) Black2(n).SetToMissing();
		else if(cWC03(n) == 2) Black2(n) = 1;
		else                   Black2(n) = 0;

		if(cWC01(n) == 998 || cWC01(n) == 999) Hispanic2(n).SetToMissing();
		else if(cWC01(n) == 1) Hispanic2(n) = 1;
		else                   Hispanic2(n) = 0;

		if(cWA02(n) == 998 || cWA02(n) == 999) Age2(n).SetToMissing();
		else if(cWA02(n) >= 18 && cWA02(n) <= 24) Age2(n) = 1;
		else if(cWA02(n) >= 25 && cWA02(n) <= 34) Age2(n) = 2;
		else if(cWA02(n) >= 35 && cWA02(n) <= 44) Age2(n) = 3;
		else if(cWA02(n) >= 45 && cWA02(n) <= 54) Age2(n) = 4;
		else if(cWA02(n) >= 55 && cWA02(n) <= 64) Age2(n) = 5;
		else if(cWA02(n) >= 65) Age2(n) = 6;
		else
		{
			Print("Err1");
			Print("cWA02(n)",cWA02(n));
			HaltExecution();
		}

		if(cWA03(n) == 998 || cWA03(n) == 999) Educ2(n).SetToMissing();
		else if(cWA03(n) == 1) Educ2(n) = 1; // Grade 8 or lower
		else if(cWA03(n) == 2) Educ2(n) = 2; // Some high school, no diploma
		else if(cWA03(n) == 3) Educ2(n) = 3; // High school diploma or equivalent
		else if(cWA03(n) == 4 || cWA03(n) == 5 || cWA03(n) == 6) Educ2(n) = 4; // Tech/voc sch. after hs, some college but no deg., or Ass. or 2-year deg.
		else if(cWA03(n) == 7) Educ2(n) = 5; // Four-year college degree
		else if(cWA03(n) == 8) Educ2(n) = 6; // Graduate or professional school, no degree
		else if(cWA03(n) == 9) Educ2(n) = 7; // Graduate or professional degree
		else
		{
			Print("Err2");
			Print("cWA03(n)",cWA03(n));
			HaltExecution();
		}

		if(cWF07(n) == 998 || cWF07(n) == 999) Married2(n).SetToMissing();
		else if(cWF07(n) == 1) Married2(n) = 1;
		else                   Married2(n) = 0;

		if(cWB01(n) == 998 || cWB01(n) == 999) EmployStat2(n).SetToMissing();
		else if(cWB01(n) == 4) EmployStat2(n) = 1; // Retired
		else if(cWB01(n) == 3) EmployStat2(n) = 2; // Temporarily laid off or unemployed
		else if(cWB01(n) == 5) EmployStat2(n) = 3; // Permanently disabled
		else                   EmployStat2(n) = 4; // Working full time, Part time, Homemaker, Student, or Other

		if(cWA04(n) == 998 || cWA04(n) == 999) Income2(n).SetToMissing();
		else if(cWA04(n) == 1) Income2(n) = 1; // Less than $10,000
		else if(cWA04(n) == 2) Income2(n) = 2; // $10,000 to $15,000
		else if(cWA04(n) == 3) Income2(n) = 3; // $15,000 to $25,000
		else if(cWA04(n) == 4) Income2(n) = 4; // $25,000 to $35,000
		else if(cWA04(n) == 5) Income2(n) = 5; // $35,000 to $50,000
		else if(cWA04(n) == 6) Income2(n) = 6; // $50,000 to $75,000
		else if(cWA04(n) == 7) Income2(n) = 7; // $75,000 to $100,000
		else if(cWA04(n) == 8) Income2(n) = 8; // $100,000 to $150,000
		else if(cWA04(n) == 9) Income2(n) = 9; // More than $150,000
		else
		{
			Print("Err4");
			Print("cWA04(n)",cWA04(n));
			HaltExecution();
		}

		if(cWE01(n) == 998 || cWE01(n) == 999)  Army2(n).SetToMissing();
		else if(cWE01(n) == 1 || cWE01(n) == 3) Army2(n) = 1;
		else Army2(n) = 0;

		if(cWF08(n) == 998 || cWF08(n) == 999) Region2(n).SetToMissing();
		else if(cWF08(n) == 1 || cWF08(n) == 2) Region2(n) = 1; // New England/Middle Atlantic = (CT, MA, ME, NH, RI, VT, NJ, NY, PA)
		else if(cWF08(n) == 3 || cWF08(n) == 4) Region2(n) = 2; // East North Central/West North Central = (IL, IN, MI, OH, WI, IA, KS, MN, MO, ND, NE, SD)
		else if(cWF08(n) == 5 || cWF08(n) == 6 || cWF08(n) == 7) Region2(n) = 3; /* South Atlantic/East South Central/West South Central
		                                                                            = (DC, DE, FL, GA, MD, NC, SC, VA, WV, AL, KY, MS, TN,
		                                                                               AR, LA, OK, TX) */
		else if(cWF08(n) == 8 || cWF08(n) == 9) Region2(n) = 4; // Mountain/Pacific = (AZ, CO, ID, MT, NM, NV, UT, WY, CA, OR, WA)
		else
		{
			Print("Err5");
			Print("cWF08(n)",cWF08(n));
			HaltExecution();
		}

		if(cRA01(n) == 1) Registered2(n) = 1;
		else              Registered2(n) = 0;

		if(cMA01(n) == 998 || cMA01(n) == 999) Party2(n).SetToMissing();
		else if(cMA01(n) == 2) Party2(n) = 1; // Dem.
		else if(cMA01(n) == 1) Party2(n) = 2; // Rep.
		else                   Party2(n) = 3; // Ind.

		/* 1 Republican
		   2 Democrat
		   3 Independent
		   4 Something else */

		if(cMA06(n) == 998 || cMA06(n) == 999) Id2(n).SetToMissing();
		else if(cMA06(n) == 1) Id2(n) = 5;
		else if(cMA06(n) == 2) Id2(n) = 4;
		else if(cMA06(n) == 3) Id2(n) = 3;
		else if(cMA06(n) == 4) Id2(n) = 2;
		else if(cMA06(n) == 5) Id2(n) = 1;
		else
		{
			Print("Err1");
			Print("cMA06(n)",cMA06(n));
			HaltExecution();
		}
	}

	/* Drop Missing Observations */
	Stack<int> Female3;			Female3.Name     = "Female3";
	Stack<int> Black3;			Black3.Name      = "Black3";
	Stack<int> Hispanic3;		Hispanic3.Name   = "Hispanic3";
	Stack<int> Age3;			Age3.Name        = "Age3";
	Stack<int> Age3_Orig;		Age3_Orig.Name   = "Age3_Orig";
	Stack<int> Educ3;			Educ3.Name       = "Educ3";
	Stack<int> Married3;		Married3.Name    = "Married3";
	Stack<int> EmployStat3;		EmployStat3.Name = "EmployStat3";
	Stack<int> Income3;			Income3.Name     = "Income3";
	Stack<int> Army3;			Army3.Name       = "Army3";
	Stack<int> Region3;			Region3.Name     = "Region3";
	Stack<int> Registered3;		Registered3.Name = "Registered3";
	Stack<int> Party3;			Party3.Name      = "Party3";
	Stack<int> Id3;				Id3.Name         = "Id3";
	for(int n=0; n<N2; n++)
	{
		if(   !Female2(n).IsMissing()
		   && !Black2(n).IsMissing()
		   && !Hispanic2(n).IsMissing()
		   && !Age2(n).IsMissing()
		   && !Educ2(n).IsMissing()
		   && !Married2(n).IsMissing()
		   && !EmployStat2(n).IsMissing()
		   && !Income2(n).IsMissing()
		   && !Army2(n).IsMissing()
		   && !Region2(n).IsMissing()
		   && !Registered2(n).IsMissing()
		   && !Party2(n).IsMissing()
		   && !Id2(n).IsMissing())
		{
			Female3.Push(Female2(n).GetData());
			Black3.Push(Black2(n).GetData());
			Hispanic3.Push(Hispanic2(n).GetData());
			Age3.Push(Age2(n).GetData());
			Age3_Orig.Push(cWA02(n));
			Educ3.Push(Educ2(n).GetData());
			Married3.Push(Married2(n).GetData());
			EmployStat3.Push(EmployStat2(n).GetData());
			Income3.Push(Income2(n).GetData());
			Army3.Push(Army2(n).GetData());
			Region3.Push(Region2(n).GetData());
			Registered3.Push(Registered2(n).GetData());
			Party3.Push(Party2(n).GetData());
			Id3.Push(Id2(n).GetData());
		}
	}
	int N3 = Female3.Size(); // NAES sample size after dropping observations

	/* Put in Matrix Form */
	Matrix<int> XMat(N3,13);
	for(int n=0; n<N3; n++)
	{
		XMat(n,0)  = Female3(n);
		XMat(n,1)  = Black3(n);
		XMat(n,2)  = Hispanic3(n);
		XMat(n,3)  = Age3(n);
		XMat(n,4)  = Educ3(n);
		XMat(n,5)  = Married3(n);
		XMat(n,6)  = EmployStat3(n);
		XMat(n,7)  = Income3(n);
		XMat(n,8)  = Army3(n);
		XMat(n,9)  = Region3(n);
		XMat(n,10) = Registered3(n);
		XMat(n,11) = Party3(n);
		XMat(n,12) = Id3(n);
	}

	/* Do the Weighting - Raking Weights Based on Simmons Data */
	Print("Raking NAES Data...");
	Vector<double> w = Rake(XMat,SimmonsPop);

	Print("Compressing NAES Data...");
	Vector<string> Index(N3);
	Index.Name = "Index";
	for(int n=0; n<N3; n++)
	{
		Index(n) =   ToString(Female3(n))
		           + ToString(Black3(n))
		           + ToString(Hispanic3(n))
		           + ToString(Age3(n))
		           + ToString(Educ3(n))
		           + ToString(Married3(n))
		           + ToString(EmployStat3(n))
		           + ToString(Income3(n))
		           + ToString(Army3(n))
		           + ToString(Region3(n))
		           + ToString(Registered3(n))
		           + ToString(Party3(n))
		           + ToString(Id3(n));
	}
	Vector<string> XVals = ListValues(Index);
	XVals.Name = "XVals";
	L = XVals.Size();
	qTilde = Vector<double>(L,Zero);
	qTilde.Name = "qTilde";
	for(int n=0; n<N3; n++)
	{
		int Info = BinarySearch(XVals,Index(n));
		if(Info < 0)
		{
			Print("Error");
			HaltExecution();
		}
		qTilde(Info) += w(n) / N3;
	}

	xTilde = Matrix<int>(L,13);
	xTilde.Name = "xTilde";
	Vector<int> XVals0(L);	XVals0.Name  = "Female";
	Vector<int> XVals1(L);	XVals1.Name  = "Black";
	Vector<int> XVals2(L);	XVals2.Name  = "Hispanic";
	Vector<int> XVals3(L);	XVals3.Name  = "Age";
	Vector<int> XVals4(L);	XVals4.Name  = "Educ";
	Vector<int> XVals5(L);	XVals5.Name  = "Married";
	Vector<int> XVals6(L);	XVals6.Name  = "Employ";
	Vector<int> XVals7(L);	XVals7.Name  = "Income";
	Vector<int> XVals8(L);	XVals8.Name  = "Army";
	Vector<int> XVals9(L);	XVals9.Name  = "Region";
	Vector<int> XVals10(L);	XVals10.Name = "Regis";
	Vector<int> XVals11(L);	XVals11.Name = "Party";
	Vector<int> XVals12(L);	XVals12.Name = "Id";
	for(int l=0; l<L; l++)
	{
		xTilde(l,0)  = ToInteger(XVals(l)[0]);
		xTilde(l,1)  = ToInteger(XVals(l)[1]);
		xTilde(l,2)  = ToInteger(XVals(l)[2]);
		xTilde(l,3)  = ToInteger(XVals(l)[3]);
		xTilde(l,4)  = ToInteger(XVals(l)[4]);
		xTilde(l,5)  = ToInteger(XVals(l)[5]);
		xTilde(l,6)  = ToInteger(XVals(l)[6]);
		xTilde(l,7)  = ToInteger(XVals(l)[7]);
		xTilde(l,8)  = ToInteger(XVals(l)[8]);
		xTilde(l,9)  = ToInteger(XVals(l)[9]);
		xTilde(l,10) = ToInteger(XVals(l)[10]);
		xTilde(l,11) = ToInteger(XVals(l)[11]);
		xTilde(l,12) = ToInteger(XVals(l)[12]);

		XVals0(l)  = ToInteger(XVals(l)[0]);
		XVals1(l)  = ToInteger(XVals(l)[1]);
		XVals2(l)  = ToInteger(XVals(l)[2]);
		XVals3(l)  = ToInteger(XVals(l)[3]);
		XVals4(l)  = ToInteger(XVals(l)[4]);
		XVals5(l)  = ToInteger(XVals(l)[5]);
		XVals6(l)  = ToInteger(XVals(l)[6]);
		XVals7(l)  = ToInteger(XVals(l)[7]);
		XVals8(l)  = ToInteger(XVals(l)[8]);
		XVals9(l)  = ToInteger(XVals(l)[9]);
		XVals10(l) = ToInteger(XVals(l)[10]);
		XVals11(l) = ToInteger(XVals(l)[11]);
		XVals12(l) = ToInteger(XVals(l)[12]);
	}

	/* Load the Map Between Simmons Survey Items and Simmons Shows */
	Print("Loading Simmons Map...");
	DataFileDelim d4("Simmons_Map.dat",'\t');
	int N4 = d4.NumObs();
	d4.SortBy<string>("Show");
	Vector< string         > Show4   = d4.Get< string         >("Show");
	Vector< string         > Type    = d4.Get< string         >("Type");
	Vector< string         > DayPart = d4.Get< string         >("Day Part");
	Vector< DataPoint<int> > TimesWk = d4.Get< DataPoint<int> >("Times a Week");
	Vector< DataPoint<int> > TimesYr = d4.Get< DataPoint<int> >("Times a Year");
	Vector< string         > Cat1    = d4.Get< string         >("Cat1");
	Vector< string         > Cat2    = d4.Get< string         >("Cat2");
	Vector< string         > Cat3    = d4.Get< string         >("Cat3");
	Vector< string         > Cat4    = d4.Get< string         >("Cat4");
	Vector< string         > Cat5    = d4.Get< string         >("Cat5");
	Vector< string         > Cat6    = d4.Get< string         >("Cat6");
	Vector< string         > Cat7    = d4.Get< string         >("Cat7");

	/* Transform Simmons Data to Common Frequency */
	Print("Transforming Simmons Data to Common Frequency...");
	Stack<string> Show;
	Stack<string> Type2;
	Stack<string> Type3;
	Stack< DataPoint<double> > All1;
	Stack< DataPoint<double> > Female1;
	Stack< DataPoint<double> > Black1;
	Stack< DataPoint<double> > Hispanic1;
	Stack< DataPoint<double> > Age1_18_24;
	Stack< DataPoint<double> > Age1_25_34;
	Stack< DataPoint<double> > Age1_35_44;
	Stack< DataPoint<double> > Age1_45_54;
	Stack< DataPoint<double> > Age1_55_64;
	Stack< DataPoint<double> > Age1_65_p;
	Stack< DataPoint<double> > Educ1_1;
	Stack< DataPoint<double> > Educ1_2;
	Stack< DataPoint<double> > Educ1_3;
	Stack< DataPoint<double> > Educ1_4;
	Stack< DataPoint<double> > Educ1_5;
	Stack< DataPoint<double> > Educ1_6;
	Stack< DataPoint<double> > Educ1_7;
	Stack< DataPoint<double> > Married1;
	Stack< DataPoint<double> > Retired1;
	Stack< DataPoint<double> > Unemployed1;
	Stack< DataPoint<double> > Disabled1;
	Stack< DataPoint<double> > Income1_1;
	Stack< DataPoint<double> > Income1_2;
	Stack< DataPoint<double> > Income1_3;
	Stack< DataPoint<double> > Income1_4;
	Stack< DataPoint<double> > Income1_5;
	Stack< DataPoint<double> > Income1_6;
	Stack< DataPoint<double> > Income1_7;
	Stack< DataPoint<double> > Income1_8;
	Stack< DataPoint<double> > Income1_9;
	Stack< DataPoint<double> > Army1;
	Stack< DataPoint<double> > ArmyNo1;
	Stack< DataPoint<double> > Northeast1;
	Stack< DataPoint<double> > Midwest1;
	Stack< DataPoint<double> > South1;
	Stack< DataPoint<double> > West1;
	Stack< DataPoint<double> > Registered1;
	Stack< DataPoint<double> > PartyDem1;
	Stack< DataPoint<double> > PartyRep1;
	Stack< DataPoint<double> > PartyInd1;
	Stack< DataPoint<double> > Id1_1;
	Stack< DataPoint<double> > Id1_2;
	Stack< DataPoint<double> > Id1_3;
	Stack< DataPoint<double> > Id1_4;
	Stack< DataPoint<double> > Id1_5;
	for(int m=0; m<N4; m++)
	{

		if(    (Type(m) == "Local News" && (    Show4(m) == "LOCAL NEWS ON YOUR ABC STATION - MORNING"
		                                     || Show4(m) == "LOCAL NEWS ON YOUR CBS STATION - MORNING"
			                                 || Show4(m) == "LOCAL NEWS ON YOUR FOX STATION - MORNING"
			                                 || Show4(m) == "LOCAL NEWS ON YOUR NBC STATION - MORNING"))
	        || (Type(m) == "Cable" && TimesWk(m) == 1)
	        || (Type(m) == "Network Weekly")
	        || (Type(m) == "Network Weekday"))
		{
			/* Local Morning News or Once a Week Cable or Network */
			int Info1;
			if(Type(m) == "Local News" || Type(m) == "Network Weekday")
			{
				Info1 = BinarySearch(Item,Cat2(m)); // Viewed yesterday
				if(Info1 < 0)
				{
					Print("Error: Cannot Find Category");
					Print("Cat2(m)",Cat2(m));
					HaltExecution();
				}
			}
			else
			{
				Info1 = BinarySearch(Item,Cat1(m)); // Viewed past 7 days
				if(Info1 < 0)
				{
					Print("Error: Cannot Find Category");
					Print("Cat1(m)",Cat1(m));
					HaltExecution();
				}
			}

			// No need to assume model
			Type2.Push(Type(m));
			Type3.Push("No Model");
			Show.Push(Show4(m));
			All1.Push(All1vt(Info1));
			Female1.Push(Female1vt(Info1));
			Black1.Push(Black1vt(Info1));
			Hispanic1.Push(Hispanic1vt(Info1));
			Age1_18_24.Push(Age1_18_24vt(Info1));
			Age1_25_34.Push(Age1_25_34vt(Info1));
			Age1_35_44.Push(Age1_35_44vt(Info1));
			Age1_45_54.Push(Age1_45_54vt(Info1));
			Age1_55_64.Push(Age1_55_64vt(Info1));
			Age1_65_p.Push(Age1_65_pvt(Info1));
			Educ1_1.Push(Educ1_1vt(Info1));
			Educ1_2.Push(Educ1_2vt(Info1));
			Educ1_3.Push(Educ1_3vt(Info1));
			Educ1_4.Push(Educ1_4vt(Info1));
			Educ1_5.Push(Educ1_5vt(Info1));
			Educ1_6.Push(Educ1_6vt(Info1));
			Educ1_7.Push(Educ1_7vt(Info1));
			Married1.Push(Married1vt(Info1));
			Retired1.Push(Retired1vt(Info1));
			Unemployed1.Push(Unemployed1vt(Info1));
			Disabled1.Push(Disabled1vt(Info1));
			Income1_1.Push(Income1_1vt(Info1));
			Income1_2.Push(Income1_2vt(Info1));
			Income1_3.Push(Income1_3vt(Info1));
			Income1_4.Push(Income1_4vt(Info1));
			Income1_5.Push(Income1_5vt(Info1));
			Income1_6.Push(Income1_6vt(Info1));
			Income1_7.Push(Income1_7vt(Info1));
			Income1_8.Push(Income1_8vt(Info1));
			Income1_9.Push(Income1_9vt(Info1));
			Army1.Push(Army1vt(Info1));
			ArmyNo1.Push(ArmyNo1vt(Info1));
			Northeast1.Push(Northeast1vt(Info1));
			Midwest1.Push(Midwest1vt(Info1));
			South1.Push(South1vt(Info1));
			West1.Push(West1vt(Info1));
			Registered1.Push(Registered1vt(Info1));
			PartyDem1.Push(PartyDem1vt(Info1));
			PartyRep1.Push(PartyRep1vt(Info1));
			PartyInd1.Push(PartyInd1vt(Info1));
			Id1_1.Push(Id1_1vt(Info1));
			Id1_2.Push(Id1_2vt(Info1));
			Id1_3.Push(Id1_3vt(Info1));
			Id1_4.Push(Id1_4vt(Info1));
			Id1_5.Push(Id1_5vt(Info1));
		}
		else if(    Type(m) == "Local News"
		         && DayPart(m) != ""
		         && Show4(m) != "LOCAL NEWS ON YOUR ABC STATION - MORNING"
		         && Show4(m) != "LOCAL NEWS ON YOUR CBS STATION - MORNING"
		         && Show4(m) != "LOCAL NEWS ON YOUR FOX STATION - MORNING"
		         && Show4(m) != "LOCAL NEWS ON YOUR NBC STATION - MORNING")
		{
			/* Local Morning News */
			int Info1 = BinarySearch(Item,Cat1(m));
			if(Info1 < 0)
			{
				Print("Error: Cannot Find Local News Category");
				Print("Cat1(m)",Cat1(m));
				HaltExecution();
			}

			// Assume indepedent probabilities
			Type2.Push(Type(m));
			Type3.Push("Ind. Prob.");
			Show.Push(Show4(m));
			All1.Push(       One - pow(One - All1vt(Info1)       ,0.2));
			Female1.Push(    One - pow(One - Female1vt(Info1)    ,0.2));
			Black1.Push(     One - pow(One - Black1vt(Info1)     ,0.2));
			Hispanic1.Push(  One - pow(One - Hispanic1vt(Info1)  ,0.2));
			Age1_18_24.Push( One - pow(One - Age1_18_24vt(Info1) ,0.2));
			Age1_25_34.Push( One - pow(One - Age1_25_34vt(Info1) ,0.2));
			Age1_35_44.Push( One - pow(One - Age1_35_44vt(Info1) ,0.2));
			Age1_45_54.Push( One - pow(One - Age1_45_54vt(Info1) ,0.2));
			Age1_55_64.Push( One - pow(One - Age1_55_64vt(Info1) ,0.2));
			Age1_65_p.Push(  One - pow(One - Age1_65_pvt(Info1)  ,0.2));
			Educ1_1.Push(    One - pow(One - Educ1_1vt(Info1)    ,0.2));
			Educ1_2.Push(    One - pow(One - Educ1_2vt(Info1)    ,0.2));
			Educ1_3.Push(    One - pow(One - Educ1_3vt(Info1)    ,0.2));
			Educ1_4.Push(    One - pow(One - Educ1_4vt(Info1)    ,0.2));
			Educ1_5.Push(    One - pow(One - Educ1_5vt(Info1)    ,0.2));
			Educ1_6.Push(    One - pow(One - Educ1_6vt(Info1)    ,0.2));
			Educ1_7.Push(    One - pow(One - Educ1_7vt(Info1)    ,0.2));
			Married1.Push(   One - pow(One - Married1vt(Info1)   ,0.2));
			Retired1.Push(   One - pow(One - Retired1vt(Info1)   ,0.2));
			Unemployed1.Push(One - pow(One - Unemployed1vt(Info1),0.2));
			Disabled1.Push(  One - pow(One - Disabled1vt(Info1)  ,0.2));
			Income1_1.Push(  One - pow(One - Income1_1vt(Info1)  ,0.2));
			Income1_2.Push(  One - pow(One - Income1_2vt(Info1)  ,0.2));
			Income1_3.Push(  One - pow(One - Income1_3vt(Info1)  ,0.2));
			Income1_4.Push(  One - pow(One - Income1_4vt(Info1)  ,0.2));
			Income1_5.Push(  One - pow(One - Income1_5vt(Info1)  ,0.2));
			Income1_6.Push(  One - pow(One - Income1_6vt(Info1)  ,0.2));
			Income1_7.Push(  One - pow(One - Income1_7vt(Info1)  ,0.2));
			Income1_8.Push(  One - pow(One - Income1_8vt(Info1)  ,0.2));
			Income1_9.Push(  One - pow(One - Income1_9vt(Info1)  ,0.2));
			Army1.Push(      One - pow(One - Army1vt(Info1)      ,0.2));
			ArmyNo1.Push(    One - pow(One - ArmyNo1vt(Info1)    ,0.2));
			Northeast1.Push( One - pow(One - Northeast1vt(Info1) ,0.2));
			Midwest1.Push(   One - pow(One - Midwest1vt(Info1)   ,0.2));
			South1.Push(     One - pow(One - South1vt(Info1)     ,0.2));
			West1.Push(      One - pow(One - West1vt(Info1)      ,0.2));
			Registered1.Push(One - pow(One - Registered1vt(Info1),0.2));
			PartyDem1.Push(  One - pow(One - PartyDem1vt(Info1)  ,0.2));
			PartyRep1.Push(  One - pow(One - PartyRep1vt(Info1)  ,0.2));
			PartyInd1.Push(  One - pow(One - PartyInd1vt(Info1)  ,0.2));
			Id1_1.Push(      One - pow(One - Id1_1vt(Info1)      ,0.2));
			Id1_2.Push(      One - pow(One - Id1_2vt(Info1)      ,0.2));
			Id1_3.Push(      One - pow(One - Id1_3vt(Info1)      ,0.2));
			Id1_4.Push(      One - pow(One - Id1_4vt(Info1)      ,0.2));
			Id1_5.Push(      One - pow(One - Id1_5vt(Info1)      ,0.2));
		}
		else if(Type(m) == "Cable" && !TimesWk(m).IsMissing())
		{
			if(TimesWk(m).GetData() != 1)
			{
				/* More than Once a Week Cable Shows */
				int Info1 = BinarySearch(Item,Cat1(m)); // Viewed past 7 days
				int Info2 = BinarySearch(Item,Cat2(m)); // Viewed past month
				if(Info1 < 0)
				{
					Print("Error: Cannot Find Cable News Category 1 (More Than Once a Week Show)");
					Print("Cat1(m)",Cat1(m));
					HaltExecution();
				}
				if(Info2 < 0)
				{
					Print("Error: Cannot Find Cable News Category 2 (More Than Once a Week Show)");
					Print("Cat2(m)",Cat2(m));
					HaltExecution();
				}

				int Times = TimesWk(m).GetData();
				Show.Push(Show4(m));
				Type2.Push(Type(m));
				Type3.Push("ProbFunc1(split pop)");
				All1.Push(       ProbFunc1(All1vt(Info1)       ,All1vt(Info2)       ,Times));
				Female1.Push(    ProbFunc1(Female1vt(Info1)    ,Female1vt(Info2)    ,Times));
				Black1.Push(     ProbFunc1(Black1vt(Info1)     ,Black1vt(Info2)     ,Times));
				Hispanic1.Push(  ProbFunc1(Hispanic1vt(Info1)  ,Hispanic1vt(Info2)  ,Times));
				Age1_18_24.Push( ProbFunc1(Age1_18_24vt(Info1) ,Age1_18_24vt(Info2) ,Times));
				Age1_25_34.Push( ProbFunc1(Age1_25_34vt(Info1) ,Age1_25_34vt(Info2) ,Times));
				Age1_35_44.Push( ProbFunc1(Age1_35_44vt(Info1) ,Age1_35_44vt(Info2) ,Times));
				Age1_45_54.Push( ProbFunc1(Age1_45_54vt(Info1) ,Age1_45_54vt(Info2) ,Times));
				Age1_55_64.Push( ProbFunc1(Age1_55_64vt(Info1) ,Age1_55_64vt(Info2) ,Times));
				Age1_65_p.Push(  ProbFunc1(Age1_65_pvt(Info1)  ,Age1_65_pvt(Info2)  ,Times));
				Educ1_1.Push(    ProbFunc1(Educ1_1vt(Info1)    ,Educ1_1vt(Info2)    ,Times));
				Educ1_2.Push(    ProbFunc1(Educ1_2vt(Info1)    ,Educ1_2vt(Info2)    ,Times));
				Educ1_3.Push(    ProbFunc1(Educ1_3vt(Info1)    ,Educ1_3vt(Info2)    ,Times));
				Educ1_4.Push(    ProbFunc1(Educ1_4vt(Info1)    ,Educ1_4vt(Info2)    ,Times));
				Educ1_5.Push(    ProbFunc1(Educ1_5vt(Info1)    ,Educ1_5vt(Info2)    ,Times));
				Educ1_6.Push(    ProbFunc1(Educ1_6vt(Info1)    ,Educ1_6vt(Info2)    ,Times));
				Educ1_7.Push(    ProbFunc1(Educ1_7vt(Info1)    ,Educ1_7vt(Info2)    ,Times));
				Married1.Push(   ProbFunc1(Married1vt(Info1)   ,Married1vt(Info2)   ,Times));
				Retired1.Push(   ProbFunc1(Retired1vt(Info1)   ,Retired1vt(Info2)   ,Times));
				Unemployed1.Push(ProbFunc1(Unemployed1vt(Info1),Unemployed1vt(Info2),Times));
				Disabled1.Push(  ProbFunc1(Disabled1vt(Info1)  ,Disabled1vt(Info2)  ,Times));
				Income1_1.Push(  ProbFunc1(Income1_1vt(Info1)  ,Income1_1vt(Info2)  ,Times));
				Income1_2.Push(  ProbFunc1(Income1_2vt(Info1)  ,Income1_2vt(Info2)  ,Times));
				Income1_3.Push(  ProbFunc1(Income1_3vt(Info1)  ,Income1_3vt(Info2)  ,Times));
				Income1_4.Push(  ProbFunc1(Income1_4vt(Info1)  ,Income1_4vt(Info2)  ,Times));
				Income1_5.Push(  ProbFunc1(Income1_5vt(Info1)  ,Income1_5vt(Info2)  ,Times));
				Income1_6.Push(  ProbFunc1(Income1_6vt(Info1)  ,Income1_6vt(Info2)  ,Times));
				Income1_7.Push(  ProbFunc1(Income1_7vt(Info1)  ,Income1_7vt(Info2)  ,Times));
				Income1_8.Push(  ProbFunc1(Income1_8vt(Info1)  ,Income1_8vt(Info2)  ,Times));
				Income1_9.Push(  ProbFunc1(Income1_9vt(Info1)  ,Income1_9vt(Info2)  ,Times));
				Army1.Push(      ProbFunc1(Army1vt(Info1)      ,Army1vt(Info2)      ,Times));
				ArmyNo1.Push(    ProbFunc1(ArmyNo1vt(Info1)    ,ArmyNo1vt(Info2)    ,Times));
				Northeast1.Push( ProbFunc1(Northeast1vt(Info1) ,Northeast1vt(Info2) ,Times));
				Midwest1.Push(   ProbFunc1(Midwest1vt(Info1)   ,Midwest1vt(Info2)   ,Times));
				South1.Push(     ProbFunc1(South1vt(Info1)     ,South1vt(Info2)     ,Times));
				West1.Push(      ProbFunc1(West1vt(Info1)      ,West1vt(Info2)      ,Times));
				Registered1.Push(ProbFunc1(Registered1vt(Info1),Registered1vt(Info2),Times));
				PartyDem1.Push(  ProbFunc1(PartyDem1vt(Info1)  ,PartyDem1vt(Info2)  ,Times));
				PartyRep1.Push(  ProbFunc1(PartyRep1vt(Info1)  ,PartyRep1vt(Info2)  ,Times));
				PartyInd1.Push(  ProbFunc1(PartyInd1vt(Info1)  ,PartyInd1vt(Info2)  ,Times));
				Id1_1.Push(      ProbFunc1(Id1_1vt(Info1)      ,Id1_1vt(Info2)      ,Times));
				Id1_2.Push(      ProbFunc1(Id1_2vt(Info1)      ,Id1_2vt(Info2)      ,Times));
				Id1_3.Push(      ProbFunc1(Id1_3vt(Info1)      ,Id1_3vt(Info2)      ,Times));
				Id1_4.Push(      ProbFunc1(Id1_4vt(Info1)      ,Id1_4vt(Info2)      ,Times));
				Id1_5.Push(      ProbFunc1(Id1_5vt(Info1)      ,Id1_5vt(Info2)      ,Times));
			}
		}
		else if(Type(m) == "Sports" && !TimesYr(m).IsMissing())
		{
			int Info1 = BinarySearch(Item,Cat2(m)); // Viewed once lsat year
			int Info2 = BinarySearch(Item,Cat3(m)); // Viewed twice last year
			int Info3 = BinarySearch(Item,Cat4(m)); // Viewed three times last year
			int Info4 = BinarySearch(Item,Cat5(m)); // Viewed four or more times last year
			if(Info1 < 0)
			{
				Print("Error: Cannot Find Sports Category 1");
				Print("Cat2(m)",Cat2(m));
				HaltExecution();
			}
			if(Info2 < 0)
			{
				Print("Error: Cannot Find Sports Category 2");
				Print("Cat3(m)",Cat3(m));
				HaltExecution();
			}
			if(Info3 < 0)
			{
				Print("Error: Cannot Find Sports Category 3");
				Print("Cat4(m)",Cat4(m));
				HaltExecution();
			}
			if(Info4 < 0)
			{
				Print("Error: Cannot Find Sports Category 4");
				Print("Cat5(m)",Cat5(m));
				HaltExecution();
			}

			Show.Push(Show4(m));
			int Times = TimesWk(m).GetData();
			Vector<int> InfoVec(4);
			InfoVec(0) = Info1;
			InfoVec(1) = Info2;
			InfoVec(2) = Info3;
			InfoVec(3) = Info4;
			Type2.Push(Type(m));
			Type3.Push("Sports");
			All1.Push(       ProbFunc3(All1vt       ,InfoVec,Times));
			Female1.Push(    ProbFunc3(Female1vt    ,InfoVec,Times));
			Black1.Push(     ProbFunc3(Black1vt     ,InfoVec,Times));
			Hispanic1.Push(  ProbFunc3(Hispanic1vt  ,InfoVec,Times));
			Age1_18_24.Push( ProbFunc3(Age1_18_24vt ,InfoVec,Times));
			Age1_25_34.Push( ProbFunc3(Age1_25_34vt ,InfoVec,Times));
			Age1_35_44.Push( ProbFunc3(Age1_35_44vt ,InfoVec,Times));
			Age1_45_54.Push( ProbFunc3(Age1_45_54vt ,InfoVec,Times));
			Age1_55_64.Push( ProbFunc3(Age1_55_64vt ,InfoVec,Times));
			Age1_65_p.Push(  ProbFunc3(Age1_65_pvt  ,InfoVec,Times));
			Educ1_1.Push(    ProbFunc3(Educ1_1vt    ,InfoVec,Times));
			Educ1_2.Push(    ProbFunc3(Educ1_2vt    ,InfoVec,Times));
			Educ1_3.Push(    ProbFunc3(Educ1_3vt    ,InfoVec,Times));
			Educ1_4.Push(    ProbFunc3(Educ1_4vt    ,InfoVec,Times));
			Educ1_5.Push(    ProbFunc3(Educ1_5vt    ,InfoVec,Times));
			Educ1_6.Push(    ProbFunc3(Educ1_6vt    ,InfoVec,Times));
			Educ1_7.Push(    ProbFunc3(Educ1_7vt    ,InfoVec,Times));
			Married1.Push(   ProbFunc3(Married1vt   ,InfoVec,Times));
			Retired1.Push(   ProbFunc3(Retired1vt   ,InfoVec,Times));
			Unemployed1.Push(ProbFunc3(Unemployed1vt,InfoVec,Times));
			Disabled1.Push(  ProbFunc3(Disabled1vt  ,InfoVec,Times));
			Income1_1.Push(  ProbFunc3(Income1_1vt  ,InfoVec,Times));
			Income1_2.Push(  ProbFunc3(Income1_2vt  ,InfoVec,Times));
			Income1_3.Push(  ProbFunc3(Income1_3vt  ,InfoVec,Times));
			Income1_4.Push(  ProbFunc3(Income1_4vt  ,InfoVec,Times));
			Income1_5.Push(  ProbFunc3(Income1_5vt  ,InfoVec,Times));
			Income1_6.Push(  ProbFunc3(Income1_6vt  ,InfoVec,Times));
			Income1_7.Push(  ProbFunc3(Income1_7vt  ,InfoVec,Times));
			Income1_8.Push(  ProbFunc3(Income1_8vt  ,InfoVec,Times));
			Income1_9.Push(  ProbFunc3(Income1_9vt  ,InfoVec,Times));
			Army1.Push(      ProbFunc3(Army1vt      ,InfoVec,Times));
			ArmyNo1.Push(    ProbFunc3(ArmyNo1vt    ,InfoVec,Times));
			Northeast1.Push( ProbFunc3(Northeast1vt ,InfoVec,Times));
			Midwest1.Push(   ProbFunc3(Midwest1vt   ,InfoVec,Times));
			South1.Push(     ProbFunc3(South1vt     ,InfoVec,Times));
			West1.Push(      ProbFunc3(West1vt      ,InfoVec,Times));
			Registered1.Push(ProbFunc3(Registered1vt,InfoVec,Times));
			PartyDem1.Push(  ProbFunc3(PartyDem1vt  ,InfoVec,Times));
			PartyRep1.Push(  ProbFunc3(PartyRep1vt  ,InfoVec,Times));
			PartyInd1.Push(  ProbFunc3(PartyInd1vt  ,InfoVec,Times));
			Id1_1.Push(      ProbFunc3(Id1_1vt      ,InfoVec,Times));
			Id1_2.Push(      ProbFunc3(Id1_2vt      ,InfoVec,Times));
			Id1_3.Push(      ProbFunc3(Id1_3vt      ,InfoVec,Times));
			Id1_4.Push(      ProbFunc3(Id1_4vt      ,InfoVec,Times));
			Id1_5.Push(      ProbFunc3(Id1_5vt      ,InfoVec,Times));
		}
	}
	int P = All1.Size(); // Number of Simmons Programs

	/* Output the Program Demographics */
	Print("Outputting Show Viewer Data...");
	ofstream out_Viewers("Viewers.dat");
	out_Viewers << "Show"         << "\t";
	out_Viewers << "Rating"       << "\t";
	out_Viewers << "Registered"   << "\t";
	out_Viewers << "Net. Con."    << "\n";
	for(int p=0; p<P; p++)
	{
		DataPoint<double> Reg = Registered1(p) * SimmonsPop(10)(1) / All1(p);
		DataPoint<double> Id1 = Id1_1(p)       * SimmonsPop(12)(0) / All1(p);
		DataPoint<double> Id2 = Id1_2(p)       * SimmonsPop(12)(1) / All1(p);
		DataPoint<double> Id4 = Id1_4(p)       * SimmonsPop(12)(3) / All1(p);
		DataPoint<double> Id5 = Id1_5(p)       * SimmonsPop(12)(4) / All1(p);
		DataPoint<double> NetCon = Id4 + Id5 - Id1 - Id2;
		out_Viewers << Show(p) << "\t";
		out_Viewers << All1(p) << "\t";
		out_Viewers << Reg     << "\t";
		out_Viewers << NetCon  << "\n";
	}
	out_Viewers.close();

	/* Main Estimation Loop */
	Print("Main Estimation...");
	Timer tm;
	tm.Name = "tm";
	tm.Start();
	Matrix< DataPoint<double> > Gamma(P,K1);	Gamma.Name = "Gamma"; // Show logistic parameter estimates
	Vector< int               > Error(P,0); Error.Name = "Error"; // Flag errors
	Vector< DataPoint<double> > g(P);       g.Name     = "g";     // Final objective value
	for(int p=0; p<P; p++)
	{
		Print("****************");
		Print("p",p,"P",P);
		Print("****************");

		try // Will fail if missing data in moments
		{
			/* Store Moments */
			EmpMom(0)  = All1(p).GetData(); // Channel Intercept
			EmpMom(1)  = Female1(p).GetData(); // Female (Male is Baseline)
			EmpMom(2)  = Black1(p).GetData(); // Black (non-Black is Baseline)
			EmpMom(3)  = Hispanic1(p).GetData(); // Hispanic (non-Hispanic is Baseline)
			EmpMom(4)  = Age1_18_24(p).GetData(); // Age (18-24 is Baseline)
			EmpMom(5)  = Age1_25_34(p).GetData();
			EmpMom(6)  = Age1_45_54(p).GetData();
			EmpMom(7)  = Age1_55_64(p).GetData();
			EmpMom(8)  = Age1_65_p(p).GetData();
			EmpMom(9)  = Educ1_1(p).GetData(); // (Grade 8 or Lower is Baseline)
			EmpMom(10) = Educ1_2(p).GetData();
			EmpMom(11) = Educ1_3(p).GetData();
			EmpMom(12) = Educ1_5(p).GetData();
			EmpMom(13) = Educ1_6(p).GetData();
			EmpMom(14) = Educ1_7(p).GetData();
			EmpMom(15) = Married1(p).GetData(); // Married (Not Married is Baselile)
			EmpMom(16) = Retired1(p).GetData(); // Employment Status (Baseline is Working full time, Part time, Homemaker, Student, or Other)
			EmpMom(17) = Unemployed1(p).GetData();
			EmpMom(18) = Disabled1(p).GetData();
			EmpMom(19) = Income1_1(p).GetData(); // Income (Baseline = Lowest)
			EmpMom(20) = Income1_2(p).GetData();
			EmpMom(21) = Income1_3(p).GetData();
			EmpMom(22) = Income1_4(p).GetData();
			EmpMom(23) = Income1_6(p).GetData();
			EmpMom(24) = Income1_7(p).GetData();
			EmpMom(25) = Income1_8(p).GetData();
			EmpMom(26) = Income1_9(p).GetData();
			EmpMom(27) = Army1(p).GetData(); // Army
			EmpMom(28) = Midwest1(p).GetData(); // Region (Baseline is Northeast)
			EmpMom(29) = South1(p).GetData(); //
			EmpMom(30) = West1(p).GetData(); //
			EmpMom(31) = Registered1(p).GetData(); // Registered
			EmpMom(32) = PartyDem1(p).GetData(); // Dem. Party ID
			EmpMom(33) = PartyRep1(p).GetData(); // Rep. Party ID
			EmpMom(34) = Id1_1(p).GetData(); // Ideology = 1 (very lib.)
			EmpMom(35) = Id1_2(p).GetData(); // Ideology = 2 (somewhat lib.)
			EmpMom(36) = Id1_4(p).GetData(); // Ideology = 4 (somewhat con.)
			EmpMom(37) = Id1_5(p).GetData(); // Ideology = 5 (very con.)

			SolveNewton< Matrix<double> > sn(MomentsFunc,K1);
			Timer tm2;
			tm2.Name = "tm2";
			tm2.Start();
			sn.Solve();
			tm2.Stop();
			Print("p",p);
			Print("sn.x",sn.x);
			Print("sn.f",sn.f);
			Print("sn.g",sn.g);
			if(sn.g > 0.000001)
			{
				Print("Found Big g"); // Was not able to equate model and empirical moments
				Error(p) = 1;
			}
			g(p) = sn.g;
			for(int k=0; k<K1; k++) Gamma(p,k) = sn.x(k);
		}
		catch(int e)
		{
			Print("Missing Moments");
			g(p).SetToMissing();
			Error(p) = 2;
		}
		tm.Stop();
	}

	/* Output the Estimation Coeficients for the Logistic Models */
	Print("Outputting Parameter Estimates...");
	ofstream out_Gamma("Gamma.dat");
	out_Gamma << "p"          << "\t";
	out_Gamma << "Show"       << "\t";
	out_Gamma << "Error"      << "\t";
	out_Gamma << "g"          << "\t";
	out_Gamma << "Constant"   << "\t";
	out_Gamma << "Female"     << "\t";
	out_Gamma << "Black"      << "\t";
	out_Gamma << "Hispanic"   << "\t";
	out_Gamma << "Age:1"      << "\t";
	out_Gamma << "Age:2"      << "\t";
	out_Gamma << "Age:4"      << "\t";
	out_Gamma << "Age:5"      << "\t";
	out_Gamma << "Age:6"      << "\t";
	out_Gamma << "Educ:1"     << "\t";
	out_Gamma << "Educ:2"     << "\t";
	out_Gamma << "Educ:3"     << "\t";
	out_Gamma << "Educ:5"     << "\t";
	out_Gamma << "Educ:6"     << "\t";
	out_Gamma << "Educ:7"     << "\t";
	out_Gamma << "Married"    << "\t";
	out_Gamma << "EmpStat:1"  << "\t";
	out_Gamma << "EmpStat:2"  << "\t";
	out_Gamma << "EmpStat:3"  << "\t";
	out_Gamma << "Income:1"   << "\t";
	out_Gamma << "Income:2"   << "\t";
	out_Gamma << "Income:3"   << "\t";
	out_Gamma << "Income:4"   << "\t";
	out_Gamma << "Income:6"   << "\t";
	out_Gamma << "Income:7"   << "\t";
	out_Gamma << "Income:8"   << "\t";
	out_Gamma << "Income:9"   << "\t";
	out_Gamma << "Army"       << "\t";
	out_Gamma << "Region:2"   << "\t";
	out_Gamma << "Region:3"   << "\t";
	out_Gamma << "Region:4"   << "\t";
	out_Gamma << "Registered" << "\t";
	out_Gamma << "Party:Dem"  << "\t";
	out_Gamma << "Party:Rep"  << "\t";
	out_Gamma << "Id:1"       << "\t";
	out_Gamma << "Id:2"       << "\t";
	out_Gamma << "Id:4"       << "\t";
	out_Gamma << "Id:5"       << "\n";
	for(int p=0; p<P; p++)
	{
		out_Gamma << p + 1 << "\t";
		out_Gamma << Show(p) << "\t";
		out_Gamma << Error(p) << "\t";
		out_Gamma << g(p) << "\t";
		for(int k=0; k<K1-1; k++) out_Gamma << Gamma(p,k) << "\t";
		out_Gamma << Gamma(p,K1-1) << "\n";
	}
	out_Gamma.close();
}

void Prepare2()
{
	Print("Begin");
	Timer tm;
	tm.Name = "A";

	int P;
	int J;
	Vector<int> Dma_1_List;
	Vector<string> Dma_CongDist_1_List;
	Matrix<short int> AdsDem;
	Matrix<short int> AdsRep;
	Matrix<short int> AdsOth;
	Matrix<short int> AdsDemPres;
	Matrix<short int> AdsRepPres;
	Matrix<short int> AdsOthPres;
	Vector< string            > Show_4;
	Vector< string            > Type_4;
	Vector< string            > Network_4;
	Vector< DataPoint<int>    > Times_4;
	Vector< DataPoint<double> > Constant_4;
	Vector< DataPoint<double> > Female_4;
	Vector< DataPoint<double> > Black_4;
	Vector< DataPoint<double> > Hispanic_4;
	Vector< DataPoint<double> > Age1_4;
	Vector< DataPoint<double> > Age2_4;
	Vector< DataPoint<double> > Age4_4;
	Vector< DataPoint<double> > Age5_4;
	Vector< DataPoint<double> > Age6_4;
	Vector< DataPoint<double> > Educ1_4;
	Vector< DataPoint<double> > Educ2_4;
	Vector< DataPoint<double> > Educ3_4;
	Vector< DataPoint<double> > Educ5_4;
	Vector< DataPoint<double> > Educ6_4;
	Vector< DataPoint<double> > Educ7_4;
	Vector< DataPoint<double> > Married_4;
	Vector< DataPoint<double> > EmpStat1_4;
	Vector< DataPoint<double> > EmpStat2_4;
	Vector< DataPoint<double> > EmpStat3_4;
	Vector< DataPoint<double> > Income1_4;
	Vector< DataPoint<double> > Income2_4;
	Vector< DataPoint<double> > Income3_4;
	Vector< DataPoint<double> > Income4_4;
	Vector< DataPoint<double> > Income6_4;
	Vector< DataPoint<double> > Income7_4;
	Vector< DataPoint<double> > Income8_4;
	Vector< DataPoint<double> > Income9_4;
	Vector< DataPoint<double> > Army_4;
	Vector< DataPoint<double> > Region2_4;
	Vector< DataPoint<double> > Region3_4;
	Vector< DataPoint<double> > Region4_4;
	Vector< DataPoint<double> > Registered_4;
	Vector< DataPoint<double> > PartyDem_4;
	Vector< DataPoint<double> > PartyRep_4;
	Vector< DataPoint<double> > Id1_4;
	Vector< DataPoint<double> > Id2_4;
	Vector< DataPoint<double> > Id4_4;
	Vector< DataPoint<double> > Id5_4;
	Vector< int               > Error_4;

	{
		/* Load CMAG (Ad) Data */
		Print("Loading CMAG Data...");
		tm.Start();
		int N1;
		Vector< string         > Show_1;
		Vector< Date           > Date_1;
		Vector< string         > Affiliate_1;
		Vector< int            > AirHour_1;
		Vector< int            > Dma_1;
		Vector< string         > Party_1;
		Vector< int            > Office_1;
		Vector< int            > CongDist_1;
		Vector< string         > Dma_CongDist_1;

		/* Block to allow CMAG data to be cleared from memory */
		{
			DataFileDelim d1("WAP.dat",'\t');
			d1.SortBy<string>("programn");
			               N1             = d1.NumObs();
				           Show_1         = d1.Get<string>("programn");
			               Date_1         = d1.Get<Date>  ("date");
			               Affiliate_1    = d1.Get<string>("affiliat");
			               Party_1        = d1.Get<string>("party");
			               Office_1       = d1.Get<int>   ("office");
			               CongDist_1     = d1.Get<int>   ("statdist");
			Vector<string> Market_1       = d1.Get<string>("market");
			Vector<string> Airtime_1      = d1.Get<string>("airtime");
			Vector<string> Day_1          = d1.Get<string>("day");
			Vector<string> DateStr_1      = d1.Get<string>("date");
			               AirHour_1      = Vector<int>(N1);
			               Dma_1          = Vector<int>(N1);
			               Dma_CongDist_1 = Vector<string>(N1);
			Vector<string> AirHourStr_1(N1);
			for(int n=0; n<N1; n++)
			{
				Stack<string> Temp = ParseBy(Airtime_1(n),':');
				AirHourStr_1(n) = Temp(0);
				AirHour_1(n) = ToInteger(Temp(0));
			}
			Vector<string> ShowAffiliate = Show_1 + Vector<string>(N1,"_") + Affiliate_1;
			Vector<string> ShowDay       = Show_1 + Vector<string>(N1,"_") + Day_1;
			Vector<string> ShowHour      = Show_1 + Vector<string>(N1,"_") + AirHourStr_1;
			Vector<string> ShowDate      = Show_1 + Vector<string>(N1,"_") + DateStr_1;

			DataFileDelim d8("DMA_Map.dat",'\t');
			int N8 = d8.NumObs();
			d8.SortBy<string>("DMA Name");
			Vector<int> Dma_8 = d8.Get<int>("DMA Code");
			Vector<string> Market_8 = d8.Get<string>("DMA Name");
			Vector< DataPoint<double> > Temp_8 = d8.Get< DataPoint<double> >("Adult 18+ Population (mil.)");
			for(int n=0; n<N1; n++)
			{
				if(Market_1(n) == "Manchester, NH") Market_1(n) = "Boston";
				int Info = BinarySearch(Market_8,Market_1(n));
				if(Info < 0)
				{
					Print("Cannot Find Market_1(n)");
					Print("Market_1(n)",Market_1(n));
					HaltExecution();
				}
				else
				{
					Dma_1(n) = Dma_8(Info);
				}
				Dma_CongDist_1(n) = ToString(Dma_1(n)) + "_" + ToString(CongDist_1(n));
			}
		}
		Dma_1_List = ListValues(Dma_1);
		Vector<int> CongDist_1_List = ListValues(CongDist_1);
		Dma_CongDist_1_List = ListValues(Dma_CongDist_1);
		J = Dma_CongDist_1_List.Size();
		int JCD = CongDist_1_List.Size();
		tm.Stop();

		/* Map Between CMAG Shows and Simmons Shows */
		Print("Loading CMAG-Simmons Show Map...");
		tm.Start();
		DataFileDelim d5("CMAG_Map.dat",'\t');
		int N5 = d5.NumObs();
		d5.SortBy<string>("CMAG Label");
		Vector<string> CMAG_Label_5 = d5.Get<string>("CMAG Label");
		Vector<string> SimmonsShow_5 = d5.Get<string>("Show");
		tm.Stop();

		/* Map Between Simmons Shows and Simmons Items */
		Print("Loading Simmons Show-Category Map...");
		tm.Start();
		DataFileDelim d6("Simmons_Map.dat",'\t');
		int N6 = d6.NumObs();
		d6.SortBy<string>("Show");
		Vector<string> SimmonsShow_6 = d6.Get<string>("Show");
		Vector<string> DayPart_6 = d6.Get<string>("Day Part");
		Vector<string> Type_6 = d6.Get<string>("Type");
		Vector<string> Network_6 = d6.Get<string>("Network");
		Vector< DataPoint<int> > Times_6 = d6.Get< DataPoint<int> >("Times a Week");
		tm.Stop();

		/* Load Estimates of Gamma (Estiamtes for Logistic Exposure Models) */
		Print("Loading Estimates of Show Viewership Model Map...");
		tm.Start();
		DataFileDelim d4("Gamma.dat",'\t');
		P = d4.NumObs();
		d4.SortBy<string>("Show");
		Show_4       = d4.Get<string>("Show");
		Error_4      = d4.Get<int>("Error");
		Constant_4   = d4.Get< DataPoint<double> >("Constant");
		Female_4     = d4.Get< DataPoint<double> >("Female");
		Black_4      = d4.Get< DataPoint<double> >("Black");
		Hispanic_4   = d4.Get< DataPoint<double> >("Hispanic");
		Age1_4       = d4.Get< DataPoint<double> >("Age:1");
		Age2_4       = d4.Get< DataPoint<double> >("Age:2");
		Age4_4       = d4.Get< DataPoint<double> >("Age:4");
		Age5_4       = d4.Get< DataPoint<double> >("Age:5");
		Age6_4       = d4.Get< DataPoint<double> >("Age:6");
		Educ1_4      = d4.Get< DataPoint<double> >("Educ:1");
		Educ2_4      = d4.Get< DataPoint<double> >("Educ:2");
		Educ3_4      = d4.Get< DataPoint<double> >("Educ:3");
		Educ5_4      = d4.Get< DataPoint<double> >("Educ:5");
		Educ6_4      = d4.Get< DataPoint<double> >("Educ:6");
		Educ7_4      = d4.Get< DataPoint<double> >("Educ:7");
		Married_4    = d4.Get< DataPoint<double> >("Married");
		EmpStat1_4   = d4.Get< DataPoint<double> >("EmpStat:1");
		EmpStat2_4   = d4.Get< DataPoint<double> >("EmpStat:2");
		EmpStat3_4   = d4.Get< DataPoint<double> >("EmpStat:3");
		Income1_4    = d4.Get< DataPoint<double> >("Income:1");
		Income2_4    = d4.Get< DataPoint<double> >("Income:2");
		Income3_4    = d4.Get< DataPoint<double> >("Income:3");
		Income4_4    = d4.Get< DataPoint<double> >("Income:4");
		Income6_4    = d4.Get< DataPoint<double> >("Income:6");
		Income7_4    = d4.Get< DataPoint<double> >("Income:7");
		Income8_4    = d4.Get< DataPoint<double> >("Income:8");
		Income9_4    = d4.Get< DataPoint<double> >("Income:9");
		Army_4       = d4.Get< DataPoint<double> >("Army");
		Region2_4    = d4.Get< DataPoint<double> >("Region:2");
		Region3_4    = d4.Get< DataPoint<double> >("Region:3");
		Region4_4    = d4.Get< DataPoint<double> >("Region:4");
		Registered_4 = d4.Get< DataPoint<double> >("Registered");
		PartyDem_4   = d4.Get< DataPoint<double> >("Party:Dem");
		PartyRep_4   = d4.Get< DataPoint<double> >("Party:Rep");
		Id1_4        = d4.Get< DataPoint<double> >("Id:1");
		Id2_4        = d4.Get< DataPoint<double> >("Id:2");
		Id4_4        = d4.Get< DataPoint<double> >("Id:4");
		Id5_4        = d4.Get< DataPoint<double> >("Id:5");
		Type_4    = Vector<string>(P);
		Network_4 = Vector<string>(P);
		Times_4 = Vector< DataPoint<int> >(P);
		for(int p=0; p<P; p++)
		{
			int Info = BinarySearch(SimmonsShow_6,Show_4(p));
			if(Info < 0)
			{
				Print("Error 09823ddr");
				HaltExecution();
			}
			Type_4(p) = Type_6(Info);
			Network_4(p) = Network_6(Info);
			Times_4(p) = Times_6(Info);
		}
		tm.Stop();

		/* Calculate Ads by Category */
		Print("Counting Ads By Market...");
		tm.Start();

		AdsDem = Matrix<short int>(P,J,(short int)0);			AdsDem.Name = "AdsDem";
		AdsRep = Matrix<short int>(P,J,(short int)0);			AdsRep.Name = "AdsRep";
		AdsOth = Matrix<short int>(P,J,(short int)0);			AdsOth.Name = "AdsOth";

		AdsDemPres = Matrix<short int>(P,J,(short int)0);		AdsDemPres.Name = "AdsDemPres";
		AdsRepPres = Matrix<short int>(P,J,(short int)0);		AdsRepPres.Name = "AdsRepPres";
		AdsOthPres = Matrix<short int>(P,J,(short int)0);		AdsOthPres.Name = "AdsOthPres";

		for(int m=0; m<N1; m++)
		{
			if(m % 100000 == 0) Print("m",m);
			if(Date_1(m) >= Date(9,6,2004)) // Post Labor Day
			{
				/* Find Dma/Cong. Dist. for Current Ad */
				int j = BinarySearch(Dma_CongDist_1_List,Dma_CongDist_1(m));
				if(j < 0)
				{
					HaltExecution("Error QQQ");
				}

				int j2 = BinarySearch(CongDist_1_List,CongDist_1(m));
				if(j2 < 0)
				{
					HaltExecution("Error QQQ");
				}

				/* Find Show for Current Ad */
				int Info = BinarySearch(CMAG_Label_5,Show_1(m));
				if(Info < 0)
				{
					Print("Error 897234");
					Print("Info",Info);
					Print("Show_1(m)",Show_1(m));
					Print("CMAG_Label_5(-Info-1)",CMAG_Label_5(-Info-1));
					Print("CMAG_Label_5(-Info)",CMAG_Label_5(-Info));
					Print("CMAG_Label_5(-Info+1)",CMAG_Label_5(-Info+1));
					Print("CMAG_Label_5",CMAG_Label_5);
					HaltExecution();
				}

				int p = -1;
				int p2 = -1;
				if(SimmonsShow_5(Info) == "")
				{
					/* Do Nothing Here */
				}
				else if(SimmonsShow_5(Info) == "LOCAL NEWS")
				{
					/* Local News */
					if(Affiliate_1(m) == "ABC")
					{
						if(AirHour_1(m) >= 17 && AirHour_1(m) <= 19)
						{
							// Early Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR ABC STATION - EARLY EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR ABC STATION - EARLY EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 1");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 20 || AirHour_1(m) <= 4)
						{
							// Late Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR ABC STATION - LATE EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR ABC STATION - LATE EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 2");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 9 && AirHour_1(m) <= 16)
						{
							// Afternoon News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR ABC STATION - AFTERNOON"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR ABC STATION - AFTERNOON"));
							if(p < 0)
							{
								Print("Cannot Find 3");
								PauseExecution();
							}
						}
						else
						{
							// Morning News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR ABC STATION - MORNING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR ABC STATION - MORNING"));
							if(p < 0)
							{
								Print("Cannot Find 4");
								PauseExecution();
							}
						}
					}
					else if(Affiliate_1(m) == "CBS")
					{
						if(AirHour_1(m) >= 17 && AirHour_1(m) <= 19)
						{
							// Early Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR CBS STATION - EARLY EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR CBS STATION - EARLY EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 5");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 20 || AirHour_1(m) <= 4)
						{
							// Late Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR CBS STATION - LATE EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR CBS STATION - LATE EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 6");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 9 && AirHour_1(m) <= 16)
						{
							// Afternoon News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR CBS STATION - AFTERNOON"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR CBS STATION - AFTERNOON"));
							if(p < 0)
							{
								Print("Cannot Find 7");
								PauseExecution();
							}
						}
						else
						{
							// Morning News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR CBS STATION - MORNING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR CBS STATION - MORNING"));
							if(p < 0)
							{
								Print("Cannot Find 8");
								PauseExecution();
							}
						}
					}
					else if(Affiliate_1(m) == "FOX")
					{
						if(AirHour_1(m) >= 17 && AirHour_1(m) <= 19)
						{
							// Early Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR FOX STATION - EARLY EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR FOX STATION - EARLY EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 9");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 20 || AirHour_1(m) <= 4)
						{
							// Late Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR FOX STATION - LATE EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR FOX STATION - LATE EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 10");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 9 && AirHour_1(m) <= 16)
						{
							// Afternoon News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR FOX STATION - AFTERNOON"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR FOX STATION - AFTERNOON"));
							if(p < 0)
							{
								Print("Cannot Find 11");
								PauseExecution();
							}
						}
						else
						{
							// Morning News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR FOX STATION - MORNING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR FOX STATION - MORNING"));
							if(p < 0)
							{
								Print("Cannot Find 12");
								PauseExecution();
							}
						}
					}
					else if(Affiliate_1(m) == "NBC")
					{
						if(AirHour_1(m) >= 17 && AirHour_1(m) <= 19)
						{
							// Early Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR NBC STATION - EARLY EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR NBC STATION - EARLY EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 13");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 20 || AirHour_1(m) <= 4)
						{
							// Late Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR NBC STATION - LATE EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR NBC STATION - LATE EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 14");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 9 && AirHour_1(m) <= 16)
						{
							// Afternoon News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR NBC STATION - AFTERNOON"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR NBC STATION - AFTERNOON"));
							if(p < 0)
							{
								Print("Cannot Find 15");
								PauseExecution();
							}
						}
						else
						{
							// Morning News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR NBC STATION - MORNING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR NBC STATION - MORNING"));
							if(p < 0)
							{
								Print("Cannot Find 16");
								PauseExecution();
							}
						}
					}
					else if(Affiliate_1(m) == "PAX")
					{
						if(AirHour_1(m) >= 17 && AirHour_1(m) <= 19)
						{
							// Early Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR PAX STATION - EARLY EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR PAX STATION - EARLY EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 17");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 20 || AirHour_1(m) <= 4)
						{
							// Late Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR PAX STATION - LATE EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR PAX STATION - LATE EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 18");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 9 && AirHour_1(m) <= 16)
						{
							// Afternoon News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR PAX STATION - AFTERNOON"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR PAX STATION - AFTERNOON"));
							if(p < 0)
							{
								Print("Cannot Find 19");
								PauseExecution();
							}
						}
						else
						{
							// Morning News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR PAX STATION - MORNING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR PAX STATION - MORNING"));
							if(p < 0)
							{
								Print("Cannot Find 20");
								PauseExecution();
							}
						}
					}
					else if(Affiliate_1(m) == "UPN")
					{
						if(AirHour_1(m) >= 17 && AirHour_1(m) <= 19)
						{
							// Early Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR UPN STATION - EARLY EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR UPN STATION - EARLY EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 21");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 20 || AirHour_1(m) <= 4)
						{
							// Late Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR UPN STATION - LATE EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR UPN STATION - LATE EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 22");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 9 && AirHour_1(m) <= 16)
						{
							// Afternoon News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR UPN STATION - AFTERNOON"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR UPN STATION - AFTERNOON"));
							if(p < 0)
							{
								Print("Cannot Find 23");
								PauseExecution();
							}
						}
						else
						{
							// Morning News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR UPN STATION - MORNING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR UPN STATION - MORNING"));
							if(p < 0)
							{
								Print("Cannot Find 24");
								PauseExecution();
							}
						}
					}
					else if(Affiliate_1(m) == "WB")
					{
						if(AirHour_1(m) >= 17 && AirHour_1(m) <= 19)
						{
							// Early Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR WB STATION - EARLY EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR WB STATION - EARLY EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 25");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 20 || AirHour_1(m) <= 4)
						{
							// Late Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR WB STATION - LATE EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR WB STATION - LATE EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 26");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 9 && AirHour_1(m) <= 16)
						{
							// Afternoon News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR WB STATION - AFTERNOON"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR WB STATION - AFTERNOON"));
							if(p < 0)
							{
								Print("Cannot Find 27");
								PauseExecution();
							}
						}
						else
						{
							// Morning News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON YOUR WB STATION - MORNING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON YOUR WB STATION - MORNING"));
							if(p < 0)
							{
								Print("Cannot Find 28");
								PauseExecution();
							}
						}
					}
					else
					{
						// Other Network
						if(AirHour_1(m) >= 17 && AirHour_1(m) <= 19)
						{
							// Early Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON OTHER NETWORK/STATION - EARLY EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON OTHER NETWORK/STATION - EARLY EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 29");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 20 || AirHour_1(m) <= 4)
						{
							// Late Evening
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON OTHER NETWORK/STATION - LATE EVENING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON OTHER NETWORK/STATION - LATE EVENING"));
							if(p < 0)
							{
								Print("Cannot Find 30");
								PauseExecution();
							}
						}
						else if(AirHour_1(m) >= 9 && AirHour_1(m) <= 16)
						{
							// Afternoon News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON OTHER NETWORK/STATION - AFTERNOON"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON OTHER NETWORK/STATION - AFTERNOON"));
							if(p < 0)
							{
								Print("Cannot Find 31");
								PauseExecution();
							}
						}
						else
						{
							// Morning News
							p = BinarySearch(Show_4,ToString("LOCAL NEWS ON OTHER NETWORK/STATION - MORNING"));
							p2 = BinarySearch(SimmonsShow_6,ToString("LOCAL NEWS ON OTHER NETWORK/STATION - MORNING"));
							if(p < 0)
							{
								Print("Cannot Find 32");
								PauseExecution();
							}
						}
					}
				}
				else
				{
					p = BinarySearch(Show_4,SimmonsShow_5(Info));
					p2 = BinarySearch(SimmonsShow_6,SimmonsShow_5(Info));
					if(p < 0)
					{
						Print("Cannot Find 33");
						Print("SimmonsShow_5(Info)",SimmonsShow_5(Info));
						PauseExecution();
					}
				}

				if(SimmonsShow_5(Info) != "" && p2 < 0)
				{
					Print("SimmonsShow_5(Info)",SimmonsShow_5(Info));
					Print("error 5567");
					PauseExecution();
				}

				if(p >= 0)
				{
					if(Party_1(m) == "D")
					{
						AdsDem(p,j)++;
						if(Office_1(m) == 1) AdsDemPres(p,j)++;
					}
					else if(Party_1(m) == "R")
					{
						AdsRep(p,j)++;
						if(Office_1(m) == 1) AdsRepPres(p,j)++;
					}
					else
					{
						AdsOth(p,j)++;
						if(Office_1(m) == 1) AdsOthPres(p,j)++;
					}
				}
			}
		}

		/* Output Pres Ads. vs. CD/DMA */
		ofstream out_AdsDemPres("AdsDemPres.dat");
		ofstream out_AdsRepPres("AdsRepPres.dat");
		out_AdsDemPres << "Show" << "\t";
		out_AdsRepPres << "Show" << "\t";
		for(int j=0; j<J-1; j++)
		{
			out_AdsDemPres << Dma_CongDist_1_List(j) << "\t";
			out_AdsRepPres << Dma_CongDist_1_List(j) << "\t";
		}
		out_AdsDemPres << Dma_CongDist_1_List(J-1) << "\n";
		out_AdsRepPres << Dma_CongDist_1_List(J-1) << "\n";
		for(int p=0; p<P; p++)
		{

			out_AdsDemPres << Show_4(p) << "\t";
			out_AdsRepPres << Show_4(p) << "\t";
			for(int j=0; j<J-1; j++)
			{
				out_AdsDemPres << AdsDemPres(p,j) << "\t";
				out_AdsRepPres << AdsRepPres(p,j) << "\t";
			}
			out_AdsDemPres << AdsDemPres(p,J-1) << "\n";
			out_AdsRepPres << AdsRepPres(p,J-1) << "\n";
		}
		out_AdsDemPres.close();
		out_AdsRepPres.close();

		tm.Stop();
	}

	/* Loop Over NAES Samples */
	Vector<string> NaesFiles(2);
	NaesFiles(0) = "NAES_EP.dat";
	NaesFiles(1) = "NAES_RCS.dat";
	for(int i=0; i<2; i++)
	{
		/* Load NAES Data */
		if(i == 0) Print("Loading NAES Election Panel Data...");
		else       Print("Loading NAES Rolling Cross Section Data...");
		tm.Start();
		int N3;
		Vector< DataPoint<int> > Female3;
		Vector< DataPoint<int> > Black3;
		Vector< DataPoint<int> > Hispanic3;
		Vector< DataPoint<int> > Age3;
		Vector< DataPoint<int> > Educ3;
		Vector< DataPoint<int> > Married3;
		Vector< DataPoint<int> > EmployStat3;
		Vector< DataPoint<int> > Income3;
		Vector< DataPoint<int> > Army3;
		Vector< DataPoint<int> > Region3;
		Vector< DataPoint<int> > Registered3;
		Vector< DataPoint<int> > Party3;
		Vector< DataPoint<int> > Id3;
		Matrix< DataPoint<int> > X2;
		Vector<int> Key_3;	Key_3.Name = "Key_3";
		Vector<int> cWA02_3;	cWA02_3.Name = "cWA02_3";
		Vector<int> Dma3;		Dma3.Name = "Dma3";
		Vector<int> CongDist3;	CongDist3.Name = "CongDist3";
		Vector< DataPoint<int> > Voted;		Voted.Name   = "Voted";
		Vector< DataPoint<int> > Pres;		Pres.Name    = "Pres";

		/* Block to allow NAES data to be cleared from memory */
		{
			DataFileDelim d3 = DataFileDelim(NaesFiles(i),'\t');
			N3 = d3.NumObs();

			/* Demographic Variables */
			            Key_3   = d3.Get<int>("cKEY");  // Key
			Vector<int> cWA01_3 = d3.Get<int>("cWA01"); // Gender: 1=Male, 2=Female
			Vector<int> cWC03_3 = d3.Get<int>("cWC03"); // Race: 2=Black
			Vector<int> cWC01_3 = d3.Get<int>("cWC01"); // Hispanic: 1=Yes
			            cWA02_3 = d3.Get<int>("cWA02"); // Age
			Vector<int> cWA03_3 = d3.Get<int>("cWA03"); // Education
			Vector<int> cWF07_3 = d3.Get<int>("cWF07"); // Marital Status
			Vector<int> cWB01_3 = d3.Get<int>("cWB01"); // Employment Status
			Vector<int> cWA04_3 = d3.Get<int>("cWA04"); // Income
			Vector<int> cWE01_3 = d3.Get<int>("cWE01"); // Military
			Vector<int> cWF08_3 = d3.Get<int>("cWF08"); // Region
			Vector<int> cRA01_3 = d3.Get<int>("cRA01"); // Registered to vote
			Vector<int> cMA01_3 = d3.Get<int>("cMA01"); // Party ID
			Vector<int> cMA06_3 = d3.Get<int>("cMA06"); // Ideology
                        CongDist3 = d3.Get<int>("cUA01"); // Cong. Dist.
			            Dma3 = d3.Get<int>("cWF14"); // Media Market

			/* Vote Choice Variables (Election Panel Only) */
			Vector< DataPoint<int> > PresA;		PresA.Name   = "PresA";
			Vector< DataPoint<int> > PresB;		PresB.Name   = "PresB";
			Pres = Vector< DataPoint<int> >(N3);	Pres.Name    = "Pres";
			if(i == 0)
			{
				Voted = d3.Get< DataPoint<int> >("rRC28");		Voted.Name = "Voted";
				PresA = d3.Get< DataPoint<int> >("rRC29");		PresA.Name = "PresA";
				PresB = d3.Get< DataPoint<int> >("rRC30");		PresB.Name = "PresB";
			}
			else
			{
				Voted   = Vector< DataPoint<int> >(N3);			Voted.Name = "Voted";
				PresA   = Vector< DataPoint<int> >(N3);			PresA.Name = "PresA";
				PresB   = Vector< DataPoint<int> >(N3);			PresB.Name = "PresB";
			}
			for(int n=0; n<N3; n++)
			{
				if(!PresA(n).IsMissing()) Pres(n) = PresA(n);
				else                      Pres(n) = PresB(n);

				if(!Voted(n).IsMissing()) if(Voted(n).GetData() >= 900) Voted(n).SetToMissing();
				if(!Pres(n).IsMissing()) if(Pres(n).GetData() >= 900) Pres(n).SetToMissing();
			}

			/* Find Observations to Drop */
			Vector<int> Drop3(N3,0);	Drop3.Name = "Drop1_3";
			for(int n=0; n<N3; n++)
			{
				if(cWC03_3(n) == 998 || cWC03_3(n) == 999) Drop3(n)++; // Drop if Missing Race
				if(cWC01_3(n) == 998 || cWC01_3(n) == 999) Drop3(n)++; // Drop if Missing Hispanic
				if(cWA02_3(n) == 998 || cWA02_3(n) == 999) Drop3(n)++; // Drop if Missing Age
				if(cWA03_3(n) == 998 || cWA03_3(n) == 999) Drop3(n)++; // Drop if Missing Education
				if(cWF07_3(n) == 998 || cWF07_3(n) == 999) Drop3(n)++; // Drop if Missing Marital Status
				if(cWB01_3(n) == 998 || cWB01_3(n) == 999) Drop3(n)++; // Drop if Missing Employment Status
				if(cWA04_3(n) == 998 || cWA04_3(n) == 999) Drop3(n)++; // Drop if Missing Income
				if(cWE01_3(n) == 998 || cWE01_3(n) == 999) Drop3(n)++; // Drop if Missing Military Status
				if(cMA01_3(n) == 998 || cMA01_3(n) == 999) Drop3(n)++; // Drop if Missing Party ID
			}

			/* Recode Annenberg Variables */
			Female3 = Vector< DataPoint<int> >(N3);		Female3.Name     = "Female3";
			Black3 = Vector< DataPoint<int> >(N3);		Black3.Name      = "Black3";
			Hispanic3 = Vector< DataPoint<int> >(N3);	Hispanic3.Name   = "Hispanic3";
			Age3 = Vector< DataPoint<int> >(N3);		Age3.Name        = "Age3";
			Educ3 = Vector< DataPoint<int> >(N3);		Educ3.Name       = "Educ3";
			Married3 = Vector< DataPoint<int> >(N3);	Married3.Name    = "Married3";
			EmployStat3 = Vector< DataPoint<int> >(N3);	EmployStat3.Name = "EmployStat3";
			Income3 = Vector< DataPoint<int> >(N3);		Income3.Name     = "Income3";
			Army3 = Vector< DataPoint<int> >(N3);		Army3.Name       = "Army3";
			Region3 = Vector< DataPoint<int> >(N3);		Region3.Name     = "Region3";
			Registered3 = Vector< DataPoint<int> >(N3);	Registered3.Name = "Registered3";
			Party3 = Vector< DataPoint<int> >(N3);		Party3.Name      = "Party3";
			Id3 = Vector< DataPoint<int> >(N3);			Id3.Name         = "Id3";
			X2 = Matrix< DataPoint<int> >(N3,13); X2.Name = "X2";
			for(int n=0; n<N3; n++)
			{
				if(cWA01_3(n) == 998 || cWA01_3(n) == 999) Female3(n).SetToMissing();
				else if(cWA01_3(n) == 2) Female3(n) = 1;
				else                   Female3(n) = 0;

				if(cWC03_3(n) == 998 || cWC03_3(n) == 999) Black3(n).SetToMissing();
				else if(cWC03_3(n) == 2) Black3(n) = 1;
				else                   Black3(n) = 0;

				if(cWC01_3(n) == 998 || cWC01_3(n) == 999) Hispanic3(n).SetToMissing();
				else if(cWC01_3(n) == 1) Hispanic3(n) = 1;
				else                   Hispanic3(n) = 0;

				if(cWA02_3(n) == 998 || cWA02_3(n) == 999) Age3(n).SetToMissing();
				else if(cWA02_3(n) >= 18 && cWA02_3(n) <= 24) Age3(n) = 1;
				else if(cWA02_3(n) >= 25 && cWA02_3(n) <= 34) Age3(n) = 2;
				else if(cWA02_3(n) >= 35 && cWA02_3(n) <= 44) Age3(n) = 3;
				else if(cWA02_3(n) >= 45 && cWA02_3(n) <= 54) Age3(n) = 4;
				else if(cWA02_3(n) >= 55 && cWA02_3(n) <= 64) Age3(n) = 5;
				else if(cWA02_3(n) >= 65) Age3(n) = 6;
				else
				{
					Print("Err1");
					Print("cWA02_3(n)",cWA02_3(n));
					HaltExecution();
				}

				if(cWA03_3(n) == 998 || cWA03_3(n) == 999) Educ3(n).SetToMissing();
				else if(cWA03_3(n) == 1) Educ3(n) = 1; // Grade 8 or lower
				else if(cWA03_3(n) == 2) Educ3(n) = 2; // Some high school, no diploma
				else if(cWA03_3(n) == 3) Educ3(n) = 3; // High school diploma or equivalent
				else if(cWA03_3(n) == 4 || cWA03_3(n) == 5 || cWA03_3(n) == 6) Educ3(n) = 4; // Tech/voc sch. after hs, some college but no deg., or Ass. or 2-year deg.
				else if(cWA03_3(n) == 7) Educ3(n) = 5; // Four-year college degree
				else if(cWA03_3(n) == 8) Educ3(n) = 6; // Graduate or professional school, no degree
				else if(cWA03_3(n) == 9) Educ3(n) = 7; // Graduate or professional degree
				else
				{
					Print("Err2");
					Print("cWA03_3(n)",cWA03_3(n));
					HaltExecution();
				}

				if(cWF07_3(n) == 998 || cWF07_3(n) == 999) Married3(n).SetToMissing();
				else if(cWF07_3(n) == 1) Married3(n) = 1;
				else                   Married3(n) = 0;

				if(cWB01_3(n) == 998 || cWB01_3(n) == 999) EmployStat3(n).SetToMissing();
				else if(cWB01_3(n) == 4) EmployStat3(n) = 1; // Retired
				else if(cWB01_3(n) == 3) EmployStat3(n) = 2; // Temporarily laid off or unemployed
				else if(cWB01_3(n) == 5) EmployStat3(n) = 3; // Permanently disabled
				else                   EmployStat3(n) = 4; // Working full time, Part time, Homemaker, Student, or Other

				if(cWA04_3(n) == 998 || cWA04_3(n) == 999) Income3(n).SetToMissing();
				else if(cWA04_3(n) == 1) Income3(n) = 1; // Less than $10,000
				else if(cWA04_3(n) == 2) Income3(n) = 2; // $10,000 to $15,000
				else if(cWA04_3(n) == 3) Income3(n) = 3; // $15,000 to $25,000
				else if(cWA04_3(n) == 4) Income3(n) = 4; // $25,000 to $35,000
				else if(cWA04_3(n) == 5) Income3(n) = 5; // $35,000 to $50,000
				else if(cWA04_3(n) == 6) Income3(n) = 6; // $50,000 to $75,000
				else if(cWA04_3(n) == 7) Income3(n) = 7; // $75,000 to $100,000
				else if(cWA04_3(n) == 8) Income3(n) = 8; // $100,000 to $150,000
				else if(cWA04_3(n) == 9) Income3(n) = 9; // More than $150,000
				else
				{
					Print("Err4");
					Print("cWA04_3(n)",cWA04_3(n));
					HaltExecution();
				}

				if(cWE01_3(n) == 998 || cWE01_3(n) == 999)  Army3(n).SetToMissing();
				else if(cWE01_3(n) == 1 || cWE01_3(n) == 3) Army3(n) = 1;
				else Army3(n) = 0;

				if(cWF08_3(n) == 998 || cWF08_3(n) == 999) Region3(n).SetToMissing();
				else if(cWF08_3(n) == 1 || cWF08_3(n) == 2) Region3(n) = 1; // New England/Middle Atlantic = (CT, MA, ME, NH, RI, VT, NJ, NY, PA)
				else if(cWF08_3(n) == 3 || cWF08_3(n) == 4) Region3(n) = 2; // East North Central/West North Central = (IL, IN, MI, OH, WI, IA, KS, MN, MO, ND, NE, SD)
				else if(cWF08_3(n) == 5 || cWF08_3(n) == 6 || cWF08_3(n) == 7) Region3(n) = 3; /* South Atlantic/East South Central/West South Central
				                                                                            = (DC, DE, FL, GA, MD, NC, SC, VA, WV, AL, KY, MS, TN,
				                                                                               AR, LA, OK, TX) */
				else if(cWF08_3(n) == 8 || cWF08_3(n) == 9) Region3(n) = 4; // Mountain/Pacific = (AZ, CO, ID, MT, NM, NV, UT, WY, CA, OR, WA)
				else
				{
					Print("Err5");
					Print("cWF08_3(n)",cWF08_3(n));
					HaltExecution();
				}

				if(cRA01_3(n) == 1) Registered3(n) = 1;
				else              Registered3(n) = 0;

				if(cMA01_3(n) == 998 || cMA01_3(n) == 999) Party3(n).SetToMissing();
				else if(cMA01_3(n) == 2) Party3(n) = 1; // Dem.
				else if(cMA01_3(n) == 1) Party3(n) = 2; // Rep.
				else                   Party3(n) = 3; // Ind.

				if(cMA06_3(n) == 998 || cMA06_3(n) == 999) Id3(n).SetToMissing();
				else if(cMA06_3(n) == 1) Id3(n) = 5;
				else if(cMA06_3(n) == 2) Id3(n) = 4;
				else if(cMA06_3(n) == 3) Id3(n) = 3;
				else if(cMA06_3(n) == 4) Id3(n) = 2;
				else if(cMA06_3(n) == 5) Id3(n) = 1;
				else
				{
					Print("Err1");
					Print("cMA06_3(n)",cMA06_3(n));
					HaltExecution();
				}
			}
		}

		Stack< int            > Key3m;			Key3m.Name        = "Key3m";
		Stack< int            > Female3m;		Female3m.Name     = "Female3m";
		Stack< int            > Black3m;		Black3m.Name      = "Black3m";
		Stack< int            > Hispanic3m;		Hispanic3m.Name   = "Hispanic3m";
		Stack< int            > Age3m;			Age3m.Name        = "Age3m";
		Stack< int            > Age3m_Orig;		Age3m_Orig.Name   = "Age3m_Orig";
		Stack< int            > Educ3m;			Educ3m.Name       = "Educ3m";
		Stack< int            > Married3m;		Married3m.Name    = "Married3m";
		Stack< int            > EmployStat3m;	EmployStat3m.Name = "EmployStat3m";
		Stack< int            > Income3m;		Income3m.Name     = "Income3m";
		Stack< int            > Army3m;			Army3m.Name       = "Army3m";
		Stack< int            > Region3m;		Region3m.Name     = "Region3m";
		Stack< int            > Registered3m;	Registered3m.Name = "Registered3m";
		Stack< int            > Party3m;		Party3m.Name      = "Party3m";
		Stack< int            > Id3m;			Id3m.Name         = "Id3m";
		Stack< int            > Dma3m;			Dma3m.Name        = "Dma3m";
		Stack< int            > CongDist3m;		CongDist3m.Name   = "CongDist3m";
		Stack< DataPoint<int> > Voted3m;		Voted3m.Name      = "Voted";
		Stack< DataPoint<int> > House3m;		House3m.Name      = "House3m";
		Stack< DataPoint<int> > Pres3m;			Pres3m.Name       = "Pres3m";
		Stack< DataPoint<int> > Sen3m;			Sen3m.Name        = "Sen3m";

		/* Drop Missing Observations */
		for(int n=0; n<N3; n++)
		{
			if(   !Female3(n).IsMissing()
			   && !Black3(n).IsMissing()
			   && !Hispanic3(n).IsMissing()
			   && !Age3(n).IsMissing()
			   && !Educ3(n).IsMissing()
			   && !Married3(n).IsMissing()
			   && !EmployStat3(n).IsMissing()
			   && !Income3(n).IsMissing()
			   && !Army3(n).IsMissing()
			   && !Region3(n).IsMissing()
			   && !Registered3(n).IsMissing()
			   && !Party3(n).IsMissing()
			   && !Id3(n).IsMissing())
			{
				Key3m.Push(Key_3(n));
				Female3m.Push(Female3(n).GetData());
				Black3m.Push(Black3(n).GetData());
				Hispanic3m.Push(Hispanic3(n).GetData());
				Age3m.Push(Age3(n).GetData());
				Age3m_Orig.Push(cWA02_3(n));
				Educ3m.Push(Educ3(n).GetData());
				Married3m.Push(Married3(n).GetData());
				EmployStat3m.Push(EmployStat3(n).GetData());
				Income3m.Push(Income3(n).GetData());
				Army3m.Push(Army3(n).GetData());
				Region3m.Push(Region3(n).GetData());
				Registered3m.Push(Registered3(n).GetData());
				Party3m.Push(Party3(n).GetData());
				Id3m.Push(Id3(n).GetData());
				Dma3m.Push(Dma3(n));
				CongDist3m.Push(CongDist3(n));
				Voted3m.Push(Voted(n));
				Pres3m.Push(Pres(n));
			}
		}
		int N3m = Female3m.Size();

		/* Two Party Variables */
		Vector< DataPoint<int> > Pres2p(N3m);
		for(int n=0; n<N3m; n++)
		{
			     if(Pres3m(n) == 2) Pres2p(n) = 1;
			else if(Pres3m(n) == 1) Pres2p(n) = 2;
		}
		tm.Stop();

		/* Calculate Exposure */
		if(i == 0) Print("Calculating Exposure for Election Panel...");
		else       Print("Calculating Exposure for Rolling Cross Section...");
		tm.Start();

		Vector< DataPoint<float> > ExposureDemPres(N3m);	ExposureDemPres.Name      = "ExposureDemPres";
		Vector< DataPoint<float> > ExposureRepPres(N3m);	ExposureRepPres.Name      = "ExposureRepPres";
		Vector< DataPoint<float> > ExposureOthPres(N3m);	ExposureOthPres.Name      = "ExposureOthPres";
		Matrix< DataPoint<float> > ExposureDem(N3m,R);		ExposureDem.Name          = "ExposureDem";
		Matrix< DataPoint<float> > ExposureRep(N3m,R);		ExposureRep.Name          = "ExposureRep";
		Matrix< DataPoint<float> > ExposureOth(N3m,R);		ExposureOth.Name          = "ExposureOth";
		Matrix< DataPoint<float> > FacMat(N3m,P,Zero);		FacMat.Name               = "FacMat";
		for(int n=0; n<N3m; n++)
		{
			if(n % 1000 == 0) Print("i",i,"n",n);
			int Info = BinarySearch(Dma_1_List,Dma3m(n));
			if(Info >= 0)
			{
				ExposureDemPres(n) = Zero;
				ExposureRepPres(n) = Zero;
				ExposureOthPres(n) = Zero;
				for(int r=0; r<R; r++)
				{
					ExposureDem(n,r) = Zero;
					ExposureRep(n,r) = Zero;
					ExposureOth(n,r) = Zero;
				}
				for(int j=0; j<J; j++)
				{
					int CurrDma      = ToInteger(ParseBy(Dma_CongDist_1_List(j),"_")(0));
					int CurrCongDist = ToInteger(ParseBy(Dma_CongDist_1_List(j),"_")(1));

					if(CurrDma == Dma3m(n) || (CurrDma == 9999 && CurrCongDist == CongDist3m(n)))
					{
						for(int p=0; p<P; p++)
						{
							if(Error_4(p) == 0)
							{
								/* Form Gamma(c)'x(n) */
								double Temp = Constant_4(p).GetData();
								if(Female3m(n) == 1) Temp += Female_4(p).GetData();

								if(Black3m(n) == 1) Temp += Black_4(p).GetData();

								if(Hispanic3m(n) == 1) Temp += Hispanic_4(p).GetData();

								     if(Age3m(n) == 1) Temp += Age1_4(p).GetData();
								else if(Age3m(n) == 2) Temp += Age2_4(p).GetData();
								else if(Age3m(n) == 4) Temp += Age4_4(p).GetData();
								else if(Age3m(n) == 5) Temp += Age5_4(p).GetData();
								else if(Age3m(n) == 6) Temp += Age6_4(p).GetData();

								     if(Educ3m(n) == 1) Temp += Educ1_4(p).GetData();
								else if(Educ3m(n) == 2) Temp += Educ2_4(p).GetData();
								else if(Educ3m(n) == 3) Temp += Educ3_4(p).GetData();
								else if(Educ3m(n) == 5) Temp += Educ5_4(p).GetData();
								else if(Educ3m(n) == 6) Temp += Educ6_4(p).GetData();
								else if(Educ3m(n) == 7) Temp += Educ7_4(p).GetData();

								if(Married3m(n) == 1) Temp += Married_4(p).GetData();

								     if(EmployStat3m(n) == 1) Temp += EmpStat1_4(p).GetData();
								else if(EmployStat3m(n) == 2) Temp += EmpStat2_4(p).GetData();
								else if(EmployStat3m(n) == 3) Temp += EmpStat3_4(p).GetData();

								     if(Income3m(n) == 1) Temp += Income1_4(p).GetData();
								else if(Income3m(n) == 2) Temp += Income2_4(p).GetData();
								else if(Income3m(n) == 3) Temp += Income3_4(p).GetData();
								else if(Income3m(n) == 4) Temp += Income4_4(p).GetData();
								else if(Income3m(n) == 6) Temp += Income6_4(p).GetData();
								else if(Income3m(n) == 7) Temp += Income7_4(p).GetData();
								else if(Income3m(n) == 8) Temp += Income8_4(p).GetData();
								else if(Income3m(n) == 9) Temp += Income9_4(p).GetData();

								if(Army3m(n) == 1) Temp += Army_4(p).GetData();

								     if(Region3m(n) == 2) Temp += Region2_4(p).GetData();
								else if(Region3m(n) == 3) Temp += Region3_4(p).GetData();
								else if(Region3m(n) == 4) Temp += Region4_4(p).GetData();

								if(Registered3m(n) == 1) Temp += Registered_4(p).GetData();

								     if(Party3m(n) == 1) Temp += PartyDem_4(p).GetData();
								else if(Party3m(n) == 2) Temp += PartyRep_4(p).GetData();

								     if(Id3m(n) == 1) Temp += Id1_4(p).GetData();
								else if(Id3m(n) == 2) Temp += Id2_4(p).GetData();
								else if(Id3m(n) == 4) Temp += Id4_4(p).GetData();
								else if(Id3m(n) == 5) Temp += Id5_4(p).GetData();

								/* Form exp(Gamma(c)*x(n)) / (1 + exp(Gamma(c)*x(n))) */
								double Fac = exp(Temp) / (One + exp(Temp));
								FacMat(n,p) = Fac;

								/* Mean Imputation */
								ExposureDemPres(n) += Fac * AdsDemPres(p,j);
								ExposureRepPres(n) += Fac * AdsRepPres(p,j);
								ExposureOthPres(n) += Fac * AdsOthPres(p,j);
								for(int r=0; r<R; r++)
								{
									/* Multiple Imputation */
									ExposureDem(n,r) += BinomialSample(AdsDem(p,j),Fac,RandomSeed);
									ExposureRep(n,r) += BinomialSample(AdsRep(p,j),Fac,RandomSeed);
									ExposureOth(n,r) += BinomialSample(AdsOth(p,j),Fac,RandomSeed);
								}
							}
						}
					}
				}
			}
		}

		if(i == 1)
		{
			Print("Outputting Show Watching Probabilities...");
			Output("Fac.dat",Key3m,FacMat);
		}

		if(i == 0) Print("Outputting Exposure Data for Election Panel...");
		else       Print("Outputting Exposure Data for Rolling Cross Section...");

		string FileName;
		if(i == 0) FileName = "Exp_EP.dat";
		else       FileName = "Exp_RCS.dat";
		ofstream out3(FileName.c_str());

		out3 << "Key"        << "\t";
		out3 << "Female"     << "\t";
		out3 << "Black"      << "\t";
		out3 << "Hispanic"   << "\t";
		out3 << "Age"        << "\t";
		out3 << "Age_Orig"   << "\t";
		out3 << "Educ"       << "\t";
		out3 << "Married"    << "\t";
		out3 << "EmployStat" << "\t";
		out3 << "Income"     << "\t";
		out3 << "Army"       << "\t";
		out3 << "Region"     << "\t";
		out3 << "Registered" << "\t";
		out3 << "Party"      << "\t";
		out3 << "Id"         << "\t";
		out3 << "Dma"        << "\t";
		out3 << "CongDist"   << "\t";
		out3 << "Voted"      << "\t";
		out3 << "Pres"       << "\t";
		out3 << "Pres2p"     << "\t";
		for(int r=0; r<R; r++)
		{
			out3 << "ExposureDem_" + ToString(r+1) << "\t";
			out3 << "ExposureRep_" + ToString(r+1) << "\t";
			out3 << "ExposureOth_" + ToString(r+1) << "\t";
		}
		out3 << "ExposureDemPres" << "\t";
		out3 << "ExposureRepPres" << "\t";
		out3 << "ExposureOthPres" << "\n";
		for(int n=0; n<N3m; n++)
		{
			out3 << Key3m(n)        << "\t";
			out3 << Female3m(n)     << "\t";
			out3 << Black3m(n)      << "\t";
			out3 << Hispanic3m(n)   << "\t";
			out3 << Age3m(n)        << "\t";
			out3 << Age3m_Orig(n)   << "\t";
			out3 << Educ3m(n)       << "\t";
			out3 << Married3m(n)    << "\t";
			out3 << EmployStat3m(n) << "\t";
			out3 << Income3m(n)     << "\t";
			out3 << Army3m(n)       << "\t";
			out3 << Region3m(n)     << "\t";
			out3 << Registered3m(n) << "\t";
			out3 << Party3m(n)      << "\t";
			out3 << Id3m(n)         << "\t";
			out3 << Dma3m(n)        << "\t";
			out3 << CongDist3m(n)   << "\t";
			out3 << Voted3m(n)      << "\t";
			out3 << Pres3m(n)       << "\t";
			out3 << Pres2p(n)       << "\t";
			for(int r=0; r<R; r++)
			{
				out3 << ExposureDem(n,r) << "\t";
				out3 << ExposureRep(n,r) << "\t";
				out3 << ExposureOth(n,r) << "\t";
			}
			out3 << ExposureDemPres(n) << "\t";
			out3 << ExposureRepPres(n) << "\t";
			out3 << ExposureOthPres(n) << "\n";
		}
		out3.close();
		tm.Stop();
	}
}

void Estimate()
{
	/* Count Covariates */
	K = 7;
	Beta_t = Vector<double>(K);
	Beta_v = Vector<double>(K);

	/* Count Constraints */
	int M = 4;
	if(Check != 1) M+=2;

	/* Size of Parameter Vector */
	const int KTheta = 2*K+4; // Size of Parameter Vector

	/* Labels */
	Vector<string> ThetaLabels(KTheta,"");
	int Curr = 0;
	ThetaLabels(Curr++) = "T_Const";
	ThetaLabels(Curr++) = "T_Registered";
	ThetaLabels(Curr++) = "T_Id";
	ThetaLabels(Curr++) = "T_Black";
	ThetaLabels(Curr++) = "T_Educ";
	ThetaLabels(Curr++) = "T_Age";
	ThetaLabels(Curr++) = "T_Female";
	ThetaLabels(Curr++) = "V_Const";
	ThetaLabels(Curr++) = "V_Registered";
	ThetaLabels(Curr++) = "V_Id";
	ThetaLabels(Curr++) = "V_Black";
	ThetaLabels(Curr++) = "V_Educ";
	ThetaLabels(Curr++) = "V_Age";
	ThetaLabels(Curr++) = "V_Female";
	ThetaLabels(Curr++) = "Alpha_t_Ads";
	ThetaLabels(Curr++) = "Rho_t_Ads";
	ThetaLabels(Curr++) = "Alpha_v_Ads";
	ThetaLabels(Curr++) = "Rho_v_Ads";

	/* Load Aggregate Data */
	Print("Loading CD/DMA Aggregate Data...");
	DataFileDelim d3("District.dat",'\t');
	d3.SortBy<string>("key");
	Vector< string            > CdDmaCode = d3.Get< string            >("key");
	Vector< string            > BGDma3    = d3.Get< string            >("battleground dma");
	Vector< int               > Dma3      = d3.Get< int               >("dmacode");
	Vector< DataPoint<double> > Turnout   = d3.Get< DataPoint<double> >("turnpres04");
	Vector< DataPoint<double> > RepShare  = d3.Get< DataPoint<double> >("presrepsh04");
	Vector< bool              > InSample  = d3.Get< bool              >("pressamp");

	/* List of CD/DMAs */
	Stack<string> CdDmaList;
	for(int n=0; n<d3.NumObs(); n++) if(InSample(n)) CdDmaList.Push(CdDmaCode(n));
	Sort(CdDmaList);
	J1 = CdDmaList.Size();
	if(ListValues(CdDmaList).Size() != J1)
	{
		Print("Error");
		Print("Duplicates in CdDmaList");
		HaltExecution();
	}

	/* List of DMAs */
	SetObj<int> DmaSet;
	for(int j=0; j<J1; j++)
	{
		Stack<string> Temp = ParseBy(CdDmaList(j),'_');
		DmaSet.Insert(ToInteger(Temp(0)));
	}
	Vector<int> DmaList = DmaSet.ToVector();
	J2 = DmaList.Size();

	/* Aggregate Data for Share Inversion */
	s_t_Emp = Vector<double>(J1);
	s_v_Emp = Vector<double>(J1);
	for(int j=0; j<J1; j++)
	{
		int Info = BinarySearch(CdDmaCode,CdDmaList(j));
		if(Turnout(Info).IsMissing() || RepShare(Info).IsMissing())
		{
			Print("Error: Missing Aggregate Data");
			Print("Info",Info);
			Print("CdDmaList(j)",CdDmaList(j));
			Print("CdDmaCode(Info)",CdDmaCode(Info));
			Print("Turnout(Info)",Turnout(Info));
			Print("RepShare(Info)",RepShare(Info));
			HaltExecution();
		}
		s_t_Emp(j) = Turnout(Info).GetData();
		s_v_Emp(j) = RepShare(Info).GetData();
	}
	Psi_t = Vector<double>(J1);	Psi_t.Name = "Psi_t";
	Psi_v = Vector<double>(J1);	Psi_v.Name = "Psi_v";

	/* Load Saved Show Demographics */
	Print("Loading Show File...");
	DataFileDelim dViewers("Viewers.dat",'\t');
	dViewers.SortBy<string>("Show");
	Vector<double> Rating         = dViewers.Get<double>("Rating");
	Vector<double> NetConVert     = dViewers.Get<double>("Net. Con.");
	Vector<double> RegisteredVert = dViewers.Get<double>("Registered");

	/* Compute Cost by DMA and CD/DMA */
	Vector< DataPoint<double> > MeanCostPerGRP(9);		MeanCostPerGRP.Name = "cost/GRP (mean)";
	Vector< DataPoint<double> > SdCostPerGRP(9);		SdCostPerGRP.Name = "cost/GRP (st.dev.)";
	Vector< DataPoint<double> > MinCostPerGRP(9);		MinCostPerGRP.Name = "cost/GRP (min)";
	Vector< DataPoint<double> > MaxCostPerGRP(9);		MaxCostPerGRP.Name = "cost/GRP (max)";

	Vector< DataPoint<double> > MeanCostPerViewer(9);	MeanCostPerViewer.Name = "cost/viewer (mean)";
	Vector< DataPoint<double> > SdCostPerViewer(9);		SdCostPerViewer.Name = "cost/viewer (st.dev.)";
	Vector< DataPoint<double> > MinCostPerViewer(9);	MinCostPerViewer.Name = "cost/viewer (min)";
	Vector< DataPoint<double> > MaxCostPerViewer(9);	MinCostPerViewer.Name = "cost/viewer (min)";

	Matrix<double> CostByDma(J2,8);		CostByDma.Name   = "CostByDma";
	Matrix<double> CostByCdDma(J1,8);	CostByCdDma.Name = "CostByCdDma";

	/* Load Cost Data for Marginal Effects */
	{
		Print("Loading Cost File...");
		DataFileDelim dCost("DMA_Map.dat",'\t');
		int NCost = dCost.NumObs();
		dCost.SortBy<string>("DMA Code");
		Vector<int> Dma_dCost = dCost.Get<int>("DMA Code");
		Vector< DataPoint<double> > Pop_dCost = dCost.Get< DataPoint<double> >("Adult 18+ Population (mil.)");
		Matrix< DataPoint<double> > CostMat   = dCost.Get< DataPoint<double> >(LoadVector<string>("DMA -CPP: Early Morn,DMA -CPP: Day time,DMA -CPP: Early Fringe,DMA -CPP: Early News,DMA -CPP: Prime Access,DMA -CPP: Prime Time,DMA -CPP: Late News,DMA -CPP: Late Fringe"));

		/* Cost by DMA */
		for(int j=0; j<J2; j++)
		{
			int Info = BinarySearch(Dma_dCost,DmaList(j));
			for(int i=0; i<8; i++) CostByDma(j,i) = CostMat(Info,i).GetData();
		}

		/* Cost by CD/DMA */
		for(int j=0; j<J1; j++)
		{
			int Info = BinarySearch(Dma_dCost,ToInteger((ParseBy(CdDmaList(j),'_'))(0)));
			for(int i=0; i<8; i++) CostByCdDma(j,i) = CostMat(Info,i).GetData();
		}

		for(int i=0; i<8; i++)
		{
			Vector< DataPoint<double> > Temp(CostMat.Rows());
			for(int j=0; j<CostMat.Rows(); j++) Temp(j) = CostMat(j,i);

			MeanCostPerGRP(i) = Mean(Temp);
			SdCostPerGRP(i) = StanDev(Temp);
			MinCostPerGRP(i) = Min(Temp);
			MaxCostPerGRP(i) = Max(Temp);

			Vector< DataPoint<double> > Temp2 = ComponentDiv(Temp,Pop_dCost);
			MeanCostPerViewer(i) = 100.0 * Mean(Temp2);
			SdCostPerViewer(i)   = 100.0 * StanDev(Temp2);
			MinCostPerViewer(i)  = 100.0 * Min(Temp2);
			MaxCostPerViewer(i)  = 100.0 * Max(Temp2);
		}
	}

	/* Load Estimates of Gamma */
	Print("Loading Gamma File...");
	DataFileDelim d4("Gamma.dat",'\t');
	int P = d4.NumObs();
	d4.SortBy<string>("Show");
	Vector< string            > Show          = d4.Get< string            >("Show");
	Vector< int               > Error         = d4.Get< int               >("Error");
	Vector< DataPoint<double> > Constant      = d4.Get< DataPoint<double> >("Constant");
	Vector< DataPoint<double> > FemaleShare   = d4.Get< DataPoint<double> >("Female");
	Vector< DataPoint<double> > BlackShare    = d4.Get< DataPoint<double> >("Black");
	Vector< DataPoint<double> > HispanicShare = d4.Get< DataPoint<double> >("Hispanic");
	Vector< DataPoint<double> > Age1Share     = d4.Get< DataPoint<double> >("Age:1");
	Vector< DataPoint<double> > Age2Share     = d4.Get< DataPoint<double> >("Age:2");
	Vector< DataPoint<double> > Age4Share     = d4.Get< DataPoint<double> >("Age:4");
	Vector< DataPoint<double> > Age5Share	  = d4.Get< DataPoint<double> >("Age:5");
	Vector< DataPoint<double> > Age6Share	  = d4.Get< DataPoint<double> >("Age:6");

	/* Load Shows Data */
	Print("Loading Simmons Map File...");
	Vector< string            > DayPart(P);		DayPart.Name    = "DayPart";
	Vector< string            > NoAds(P);		NoAds.Name      = "NoAds";
	Vector< DataPoint<double> > YoungChar(P);	YoungChar.Name  = "YoungChar";
	Vector< DataPoint<double> > OldChar(P);		OldChar.Name    = "OldChar";
	Vector< DataPoint<double> > BlackChar(P);	BlackChar.Name  = "BlackChar";
	Vector< DataPoint<double> > HispChar(P);	HispChar.Name   = "HispChar";
	Vector< DataPoint<double> > FemaleChar(P);	FemaleChar.Name = "FemaleChar";
	Vector< DataPoint<double> > AsianChar(P);	AsianChar.Name  = "AsianChar";
	{
		DataFileDelim d5("Simmons_Map.dat",'\t');
		d5.SortBy<string>("Show");
		Vector< string            > Show_5       = d5.Get< string            >("Show");
		Vector< string            > DayPart_5    = d5.Get< string            >("Day Part");
		Vector< string            > NoAds_5      = d5.Get< string            >("No Ads");
		Vector< DataPoint<double> > YoungChar_5  = d5.Get< DataPoint<double> >("Young Characters");
		Vector< DataPoint<double> > OldChar_5    = d5.Get< DataPoint<double> >("Old Characters");
		Vector< DataPoint<double> > BlackChar_5  = d5.Get< DataPoint<double> >("Black Characters");
		Vector< DataPoint<double> > HispChar_5   = d5.Get< DataPoint<double> >("Hispanic Characters");
		Vector< DataPoint<double> > FemaleChar_5 = d5.Get< DataPoint<double> >("Female Characters");
		Vector< DataPoint<double> > AsianChar_5  = d5.Get< DataPoint<double> >("Asian Characters");
		for(int p=0; p<P; p++)
		{
			int p2 = BinarySearch(Show_5,Show(p));
			if(p2 < 0)
			{
				Print("Err QQQ5");
				HaltExecution();
			}
			DayPart(p)    = DayPart_5(p2);
			NoAds(p)      = NoAds_5(p2);
			YoungChar(p)  = YoungChar_5(p2);
			OldChar(p)    = OldChar_5(p2);
			BlackChar(p)  = BlackChar_5(p2);
			HispChar(p)   = HispChar_5(p2);
			FemaleChar(p) = FemaleChar_5(p2);
			AsianChar(p)  = AsianChar_5(p2);
		}
	}

	/* Compute Cost by Show */
	Matrix< DataPoint<double> > CostByShow(P,J1);
	for(int p=0; p<P; p++) for(int j=0; j<J1; j++)
	{
		     if(DayPart(p) == "EM"   ) CostByShow(p,j) = CostByCdDma(j,0);
		else if(DayPart(p) == "DAY"  ) CostByShow(p,j) = CostByCdDma(j,1);
		else if(DayPart(p) == "EF"   ) CostByShow(p,j) = CostByCdDma(j,2);
		else if(DayPart(p) == "EN"   ) CostByShow(p,j) = CostByCdDma(j,3);
		else if(DayPart(p) == "PA"   ) CostByShow(p,j) = CostByCdDma(j,4);
		else if(DayPart(p) == "PRIME") CostByShow(p,j) = CostByCdDma(j,5);
		else if(DayPart(p) == "LN"   ) CostByShow(p,j) = CostByCdDma(j,6);
		else if(DayPart(p) == "LF"   ) CostByShow(p,j) = CostByCdDma(j,7);
	}

	/* Count Presidential Ads by Day Part */
	Print("Loading Presidential Ads by Day Part...");

	Vector<string> DayParts = LoadVector<string>("EM,DAY,EF,EN,PA,PRIME,LN,LF,OTH");

	Vector< int               > AdsDemPresByPart(DayParts.Size(),0);				AdsDemPresByPart.Name = "dem. pres. ads";
	Vector< int               > AdsRepPresByPart(DayParts.Size(),0);				AdsRepPresByPart.Name = "rep. pres. ads";
	Vector< double            > GRPDemPresByPart(DayParts.Size(),Zero);				GRPDemPresByPart.Name = "dem. pres. grps";
	Vector< double            > GRPRepPresByPart(DayParts.Size(),Zero);				GRPRepPresByPart.Name = "rep. pres. grps";

	Vector< double            > AdsDemPresByProgram(P,Zero);						AdsDemPresByProgram.Name = "dem. pres. ads";
	Vector< double            > AdsRepPresByProgram(P,Zero);						AdsRepPresByProgram.Name = "rep. pres. ads";
	Vector< double            > AdsTotPresByProgram(P,Zero);						AdsTotPresByProgram.Name = "tot. pres. ads";
	Vector< double            > GRPDemPresByProgram(P,Zero);						GRPDemPresByProgram.Name = "dem. pres. grps";
	Vector< double            > GRPRepPresByProgram(P,Zero);						GRPRepPresByProgram.Name = "rep. pres. grps";
	Vector< double            > GRPTotPresByProgram(P,Zero);						GRPTotPresByProgram.Name = "tot. pres. grps";
	Vector< DataPoint<double> > SpendDemPresByProgram(P,DataPoint<double>(Zero));	SpendDemPresByProgram.Name   = "dem. pres. spending";
	Vector< DataPoint<double> > SpendRepPresByProgram(P,DataPoint<double>(Zero));	SpendRepPresByProgram.Name   = "rep. pres. spending";
	Vector< DataPoint<double> > SpendTotPresByProgram(P,DataPoint<double>(Zero));	SpendTotPresByProgram.Name   = "tot. pres. spending";

	DataFileDelim dAdsDemPres("AdsDemPres.dat",'\t');
	dAdsDemPres.SortBy<string>("Show");
	Vector<string> DemVarNames = dAdsDemPres.GetVarNames();

	DataFileDelim dAdsRepPres("AdsRepPres.dat",'\t');
	dAdsRepPres.SortBy<string>("Show");
	Vector<string> RepVarNames = dAdsRepPres.GetVarNames();

	for(int j=0; j<DemVarNames.Size(); j++)
	{
		if(DemVarNames(j) != "Show")
		{
			Vector<int> TempAdsDem = dAdsDemPres.Get<int>(DemVarNames(j));
			Vector<int> TempAdsRep = dAdsRepPres.Get<int>(RepVarNames(j));

			Stack<string> Temp = ParseBy(DemVarNames(j),'_');
			if(ToInteger(Temp(0)) != 744 && ToInteger(Temp(0)) != 9999) // Honolulu not in WAP and 9999 is missing value code
			{
				int Info = Search(DmaList,ToInteger(Temp(0)));
				if(Info < 0)
				{
					Print("Error");
					Print("Cant find DMA");
					Print("DMA",Temp(0));
					Print("DmaList",DmaList);
					HaltExecution();
				}

				for(int p=0; p<P; p++)
				{
					AdsDemPresByProgram(p) += TempAdsDem(p);
					AdsRepPresByProgram(p) += TempAdsRep(p);
					AdsTotPresByProgram(p) += TempAdsDem(p) + TempAdsRep(p);

					double DemGRP = (double)TempAdsDem(p) * (100.0 * Rating(p)) / 1000.0;
					double RepGRP = (double)TempAdsRep(p) * (100.0 * Rating(p)) / 1000.0;

					GRPDemPresByProgram(p) += DemGRP;
					GRPRepPresByProgram(p) += RepGRP;
					GRPTotPresByProgram(p) += DemGRP + RepGRP;

					int i = Search(DayParts,DayPart(p));
					if(i >= 0)
					{
						AdsDemPresByPart(i) += TempAdsDem(p);
						AdsRepPresByPart(i) += TempAdsRep(p);

						GRPDemPresByPart(i) += DemGRP;
						GRPRepPresByPart(i) += RepGRP;

						double DemSpend = DemGRP * CostByDma(Info,i) / 1000.0;
						double RepSpend = RepGRP * CostByDma(Info,i) / 1000.0;

						SpendDemPresByProgram(p) += DemSpend;
						SpendRepPresByProgram(p) += RepSpend;
						SpendTotPresByProgram(p) += DemSpend + RepSpend;
					}
					else
					{
						AdsDemPresByPart(8) += TempAdsDem(p);
						AdsRepPresByPart(8) += TempAdsRep(p);

						GRPDemPresByPart(8) += DemGRP;
						GRPRepPresByPart(8) += RepGRP;
					}
				}
			}
		}
	}

	/* Tables in Tex Format */
	ofstream out1t("TV_Tables.tex");

	/* ********************
	   Table 1 -- Day Parts
	   ******************** */
	{
		Print("Writing Table 1...");

		out1t << "\n";
		out1t << "\\documentclass[11pt]{article} \n";
		out1t << "\\usepackage{float,amsmath,amssymb,amsthm,fullpage,setspace,natbib,enumerate,url,multirow,lscape} \n";
		out1t << "\\usepackage[dvips]{graphicx} \n";
		out1t << "\\onehalfspacing \n";
		out1t << "\\begin{document} \n";
		out1t << "\n";

		out1t << "\\begin{table}[htp]\\centering \n";
		out1t << "\\begin{singlespace} \n";
		out1t << "\\begin{footnotesize} \n";
		out1t << "\\begin{tabular}{ c c c c c c c c c c } \\hline \\hline \n";
		out1t << " & & \\textbf{Early} & \\textbf{Day} & \\textbf{Early} & \\textbf{Early} & \\textbf{Prime} & \\textbf{Prime} & \\textbf{Late} & \\textbf{Late} \\\\ \n";
		out1t << " & & \\textbf{Morning} & \\textbf{Time} & \\textbf{Fringe} & \\textbf{News} & \\textbf{Access} & \\textbf{Time} & \\textbf{News} & \\textbf{Fringe} \\\\ \n";
		out1t << " &  & (12:30pm- & (9am- & (4pm- & (6pm- & (7pm- & (8pm- & (11pm- & (11:30pm- \\\\ \n";
		out1t << " &  & 9am) & 4pm) & 6pm) & 7pm) & 8pm) & 11pm) & 11:30pm) & 12:30pm) \\\\ \\hline \n";

		out1t << "Cost per & \\textit{Avg.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(MeanCostPerGRP(i));
		out1t << "\\\\ \n";

		out1t << "Rating & \\textit{Sd.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(SdCostPerGRP(i));
		out1t << "\\\\ \n";

		out1t << "Point & \\textit{Min.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(MinCostPerGRP(i));
		out1t << "\\\\ \n";

		out1t << "(in dollars) & \\textit{Max.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(MaxCostPerGRP(i));
		out1t << "\\\\ \\hline \n";

		out1t << "Cost per & \\textit{Avg.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(MeanCostPerViewer(i),1);
		out1t << "\\\\ \n";

		out1t << "Thousand & \\textit{Sd.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(SdCostPerViewer(i),1);
		out1t << "\\\\ \n";

		out1t << "Viewers & \\textit{Min}";
		for(int i=0; i<8; i++) out1t << " & " << Round(MinCostPerViewer(i),1);
		out1t << "\\\\ \n";

		out1t << "(in dollars) & \\textit{Max}";
		for(int i=0; i<8; i++) out1t << " & " << Round(MaxCostPerViewer(i),1);
		out1t << "\\\\ \\hline \n";

		out1t << "Presidential & \\textit{Dem.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(AdsDemPresByPart(i));
		out1t << "\\\\ \n";

		out1t << "Ads & \\textit{Rep.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(AdsRepPresByPart(i));
		out1t << "\\\\ \\hline \n";

		out1t << "Presidential & \\textit{Dem.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(GRPDemPresByPart(i));
		out1t << "\\\\ \n";

		out1t << "GRPs (in 1000s) & \\textit{Rep.}";
		for(int i=0; i<8; i++) out1t << " & " << Round(GRPRepPresByPart(i));
		out1t << "\\\\ \n";

		out1t << "\\hline \\hline \n";
		out1t << "\\end{tabular} \n";
		out1t << "\\end{footnotesize} \n";
		out1t << "\\end{singlespace} \n";
		out1t << "\\caption{\\footnotesize{Summary Statistics for Day Parts. Source: SQAD Inc. cost estimates and Wisconsin Advertising Project.}} \n";
		out1t << "\\label{DayPartSummaryTable} \n";
		out1t << "\\end{table} \n";
	}

	/* ****************************
	   Table 2 -- Gamma Regressions
	   **************************** */

	{
		Print("Running Gamma Regressions...");

		Matrix< DataPoint<double> > XShows(P,7,Zero);
		for(int p=0; p<P; p++)
		{
			XShows(p,0) = One;
			XShows(p,1) = FemaleChar(p);
			XShows(p,2) = BlackChar(p);
			XShows(p,3) = HispChar(p);
			XShows(p,4) = AsianChar(p);
			XShows(p,5) = YoungChar(p);
			XShows(p,6) = OldChar(p);
			if(Error(p) != 0) XShows(p,0).SetToMissing(); // Drop Observations
		}

		Vector<LinRegObj> lr(8);
		lr(0) = LinRegObj(FemaleShare  ,XShows);
		lr(1) = LinRegObj(BlackShare   ,XShows);
		lr(2) = LinRegObj(HispanicShare,XShows);
		lr(3) = LinRegObj(Age1Share    ,XShows);
		lr(4) = LinRegObj(Age2Share    ,XShows);
		lr(5) = LinRegObj(Age4Share    ,XShows);
		lr(6) = LinRegObj(Age5Share    ,XShows);
		lr(7) = LinRegObj(Age6Share    ,XShows);
		for(int j=0; j<8; j++) lr(j).Solve();

		Matrix<string> BetaMat(7,8);
		Matrix<string> BetaSeMat(7,8);
		for(int i=0; i<7; i++) for(int j=0; j<8; j++)
		{
			if(!lr(j).BetaSe(i).IsMissing())
			{
				BetaMat(i,j) = Round(lr(j).Beta(i),3) + NormalStars(lr(j).Beta(i),lr(j).BetaSe(i).GetData());
				BetaSeMat(i,j) = "(" + Round(lr(j).BetaSe(i),3) + ")";
			}
			else
			{
				BetaMat(i,j) = lr(j).Beta(i);
				BetaSeMat(i,j) = "(0.000)";
			}
		}

		Print("Writing Table 2...");

		out1t << "\n \\begin{table}[htp]\\centering \n";
		out1t << "\\begin{singlespace} \n";
		out1t << "\\begin{scriptsize} \n";
		out1t << "\\begin{tabular}{ l c c c c c c c c } \n";
		out1t << "\\hline \\hline \n";
		out1t << "DV: & \\textbf{Female} & \\textbf{Black} & \\textbf{Hispanic} & \\multicolumn{5}{c}{\\textbf{Age}} \\\\ \n";
		out1t << " & & & & \\textit{18-24} & \\textit{25-34} & \\textit{45-54} & \\textit{55-64} & \\textit{65+} \\\\ \n";
		out1t << "\\\\ \n";
		out1t << "\\textbf{Independent Variables:} \\\\ \n";

		out1t << "\\hspace{.4cm}Constant";
		for(int j=0; j<8; j++) out1t << " & " << BetaMat(0,j);
		out1t << "\\\\ \n";
		for(int j=0; j<8; j++) out1t << " & " << BetaSeMat(0,j);
		out1t << "\\\\ \n";
		out1t << "\\cline{2-2} \n";

		out1t << "\\hspace{.4cm}Female Characters & \\multicolumn{1}{|c|}{";
		out1t << BetaMat(1,0);
		out1t << "}";
		for(int j=1; j<8; j++) out1t << " & " << BetaMat(1,j);
		out1t << "\\\\ \n";
		out1t << " & \\multicolumn{1}{|c|}{";
		out1t << BetaSeMat(1,0);
		out1t << "}";
		for(int j=1; j<8; j++) out1t << " & " << BetaSeMat(1,j);
		out1t << "\\\\ \n";
		out1t << "\\cline{2-3} \n";

		out1t << "\\hspace{.4cm}Black Characters";
		out1t << " & " << BetaMat(2,0);
		out1t << " & \\multicolumn{1}{|c|}{" << BetaMat(2,1) << "}";
		for(int j=2; j<8; j++) out1t << " & " << BetaMat(2,j);
		out1t << "\\\\ \n";
		out1t << " & (" << BetaSeMat(2,0);
		out1t << " & \\multicolumn{1}{|c|}{" << BetaSeMat(2,1) << "}";
		for(int j=2; j<8; j++) out1t << " & " << BetaSeMat(2,j);
		out1t << "\\\\ \n";
		out1t << "\\cline{3-4} \n";

		out1t << "\\hspace{.4cm}Hispanic Characters";
		for(int j=0; j<2; j++) out1t << " & " << BetaMat(3,j);
		out1t << " & \\multicolumn{1}{|c|}{" << BetaMat(3,2) << "}";
		for(int j=3; j<8; j++) out1t << " & " << BetaMat(3,j);
		out1t << "\\\\ \n";
		for(int j=0; j<2; j++) out1t << " & " << BetaSeMat(3,j);
		out1t << " & \\multicolumn{1}{|c|}{" << BetaSeMat(3,2) << "}";
		for(int j=3; j<8; j++) out1t << " & " <<  BetaSeMat(3,j);
		out1t << "\\\\ \n";
		out1t << "\\cline{4-4} \n";

		out1t << "\\hspace{.4cm}Asian Characters";
		for(int j=0; j<8; j++) out1t << " & " << BetaMat(4,j);
		out1t << "\\\\ \n";
		for(int j=0; j<8; j++) out1t << " & " << BetaSeMat(4,j);
		out1t << "\\\\ \n";
		out1t << "\\cline{5-9} \n";

		out1t << "\\hspace{.4cm}Young Characters";
		for(int j=0; j<3; j++) out1t << " & " << BetaMat(5,j);
	 	out1t << "& \\multicolumn{1}{|c}{" << BetaMat(5,3) << "}";
	 	for(int j=4; j<7; j++) out1t << " & " << BetaMat(5,j);
	 	out1t << "& \\multicolumn{1}{c|}{" << BetaMat(5,7) << "}";
	 	out1t << "\\\\ \n";

	  	for(int j=0; j<3; j++) out1t << " & " << BetaSeMat(5,j);
	 	out1t << "& \\multicolumn{1}{|c}{" << BetaSeMat(5,3) << "}";
	 	for(int j=4; j<7; j++) out1t << " & " << BetaSeMat(5,j);
	 	out1t << "& \\multicolumn{1}{c|}{" << BetaSeMat(5,7) << "}";
	 	out1t << "\\\\ \n";

	 	out1t << "\\hspace{.4cm}Old Characters";
	 	for(int j=0; j<3; j++) out1t << " & " << BetaMat(6,j);
	 	out1t << "& \\multicolumn{1}{|c}{" << BetaMat(6,3) << "}";
	 	for(int j=4; j<7; j++) out1t << " & " << BetaMat(6,j);
	 	out1t << "& \\multicolumn{1}{c|}{" << BetaMat(6,7) << "}";
	  	out1t << "\\\\ \n";
	  	for(int j=0; j<3; j++) out1t << " & " << BetaSeMat(6,j);
	 	out1t << "& \\multicolumn{1}{|c}{" << BetaSeMat(6,3) << "}";
	 	for(int j=4; j<7; j++) out1t << " & " << BetaSeMat(6,j);
	 	out1t << "& \\multicolumn{1}{c|}{" << BetaSeMat(6,7) << "}";
	  	out1t << "\\\\ \n";
	 	out1t << "\\cline{5-9} \n";

		out1t << "\\\\ \n";
		out1t << "\\textbf{R-Squared}";
		for(int j=0; j<8; j++) out1t << " & " << Round(lr(j).RSquared,3);
		out1t << "\\\\ \n";

		out1t << "\\textbf{N}";
		for(int j=0; j<8; j++) out1t << " & " << lr(j).N;
		out1t << "\\\\ \n";

		out1t << "\\hline \\hline \n";
		out1t << "\\end{tabular} \n";
		out1t << "\\caption{\\footnotesize{Match Between Show Viewership Parameters and Cast Demographics -- Results obtained by regressing the show viewership parameter ($\\gamma_p$) on cast demographics dummies. Standard errors are reported in parentheses. One star indicates statistical significance at the 5\\% level. Two stars indicates statistical significance at the 1\\% level. Three stars indicates statistical significance at the 0.1\\% level. A plus sign indicates statistical significance at the 10\\% level. Source: Estimates based on Simmons National Consumer Survey.}} \n";
		out1t << "\\label{DemographicMatchTable} \n";
		out1t << "\\end{scriptsize} \n";
		out1t << "\\end{singlespace} \n";
		out1t << "\\end{table} \n";
	}

	{ /* To Save Memory */
		/* Load the NAES Election Panel Data */
		DataFileDelim d("Exp_EP.dat",'\t');
		const int N = d.NumObs();
		Vector< int               > Female       = d.Get< int               >("Female");
		Vector< int               > Black        = d.Get< int               >("Black");
		Vector< int               > Hispanic     = d.Get< int               >("Hispanic");
		Vector< int               > Age          = d.Get< int               >("Age");
		Vector< int               > Age_Orig     = d.Get< int               >("Age_Orig");
		Vector< int               > Educ         = d.Get< int               >("Educ");
		Vector< int               > Married      = d.Get< int               >("Married");
		Vector< int               > EmployStat   = d.Get< int               >("EmployStat");
		Vector< int               > Income       = d.Get< int               >("Income");
		Vector< int               > Army         = d.Get< int               >("Army");
		Vector< int               > Region       = d.Get< int               >("Region");
		Vector< int               > Registered   = d.Get< int               >("Registered");
		Vector< int               > Party        = d.Get< int               >("Party");
		Vector< int               > Id           = d.Get< int               >("Id");
		Vector< int               > Dma          = d.Get< int               >("Dma");
		Vector< int               > CongDist     = d.Get< int               >("CongDist");
		Vector< string            > Dma_CongDist = d.Get< string            >("Dma") + Vector<string>(N,"_") + d.Get<string>("CongDist");
		Vector< DataPoint<int>    > Voted        = d.Get< DataPoint<int>    >("Voted");
		Vector< DataPoint<int>    > Pres         = d.Get< DataPoint<int>    >("Pres");
		Stack<string> ExposureDemLabels;
		for(int r=0; r<R; r++) ExposureDemLabels.Push("ExposureDem_" + ToString(r + 1));
		Stack<string> ExposureRepLabels;
		for(int r=0; r<R; r++) ExposureRepLabels.Push("ExposureRep_" + ToString(r + 1));
		Stack<string> ExposureOthLabels;
		for(int r=0; r<R; r++) ExposureOthLabels.Push("ExposureOth_" + ToString(r + 1));
		Matrix< DataPoint<double> > ExposureDem  = d.Get< DataPoint<double> >(ExposureDemLabels);
		Matrix< DataPoint<double> > ExposureRep  = d.Get< DataPoint<double> >(ExposureRepLabels);
		Matrix< DataPoint<double> > ExposureOth  = d.Get< DataPoint<double> >(ExposureOthLabels);

		Matrix<double> X(N,K);
		X.Name = "X";
		for(int n=0; n<N; n++)
		{
			int Curr = 0;
			X(n,Curr++) = One;
			X(n,Curr++) = Registered(n);
			X(n,Curr++) = Id(n);
			X(n,Curr++) = Black(n);
			X(n,Curr++) = Educ(n);
			X(n,Curr++) = Age(n);
			X(n,Curr++) = Female(n);
		}

		/* Find Observations to Drop */
		Nep = 0;
		Vector<bool> Drop(N,False);
		for(int n=0; n<N; n++)
		{
			if(Voted(n) == 1)
			{
				if(Pres(n).IsMissing())  Drop(n) = True;
			}

			if(ExposureDem(n,0).IsMissing()) Drop(n) = True;
			if(ExposureRep(n,0).IsMissing()) Drop(n) = True;
			if(ExposureOth(n,0).IsMissing()) Drop(n) = True;
			int Info = BinarySearch(CdDmaList,Dma_CongDist(n));
			if(Info < 0) Drop(n) = True;
			if(!Drop(n)) Nep++;
		}

		Xep     = Matrix<double>(Nep,K);
		Yep     = Vector<int   >(Nep);
		eTot_ep = Matrix<double>(Nep,R);
		eDem_ep = Matrix<double>(Nep,R);
		eRep_ep = Matrix<double>(Nep,R);
		CurrJ   = Vector<int   >(Nep);

		int Curr = 0;
		for(int n=0; n<N; n++)
		{
			if(!Drop(n))
			{
				for(int k=0; k<K; k++) Xep(Curr,k) = X(n,k);
				if(Voted(n) != 1 || Voted(n).IsMissing()) Yep(Curr) = 0; // Didn't vote for house
				else
				{
					if(Pres(n) == 2) Yep(Curr) = 1; // Voted for Dem. Pres cand.
					else             Yep(Curr) = 2; // Voted for Rep. Pres cand.
				}

				for(int r=0; r<R; r++)
				{
					eTot_ep(Curr,r) = (ExposureDem(n,r).GetData() + ExposureRep(n,r).GetData() + ExposureOth(n,r).GetData()) / 1000.0;
					eDem_ep(Curr,r) = ExposureDem(n,r).GetData() / 1000.0;
					eRep_ep(Curr,r) = ExposureRep(n,r).GetData() / 1000.0;
				}

				int j = BinarySearch(CdDmaList,Dma_CongDist(n));
				if(j < 0)
				{
					Print("Err978234");
					HaltExecution();
				}

				CurrJ(Curr) = j;
				Curr++;
			}
		}
	} /* End Save Memory */

	double SdExpDiff;
	Vector<int > Key;
	Vector<int > Female;
	Vector<int > Black;
	Vector<int > Hispanic;
	Vector<int > Age;
	Vector<int > Educ;
	Vector<int > Married;
	Vector<int > EmployStat;
	Vector<int > Income;
	Vector<int > Army;
	Vector<int > Region;
	Vector<int > Registered;
	Vector<int > Party;
	Vector<int > Id;
	Vector<bool> BGDma;
	Fac_m = Vector< Matrix<float> >(J1);				Fac_m.Name        = "Fac_m";
	Vector< Vector< int         > > Key_m(J1);			Key_m.Name        = "Key_m";
	Vector< Vector< int         > > Female_m(J1);		Female_m.Name     = "Female_m";
	Vector< Vector< int         > > Black_m(J1);		Black_m.Name      = "Black_m";
	Vector< Vector< int         > > Hispanic_m(J1);		Hispanic_m.Name   = "Hispanic_m";
	Vector< Vector< int         > > Age_m(J1);			Age_m.Name        = "Age_m";
	Vector< Vector< int         > > Educ_m(J1);			Educ_m.Name       = "Educ_m";
	Vector< Vector< int         > > Married_m(J1);		Married_m.Name    = "Married_m";
	Vector< Vector< int         > > EmployStat_m(J1);	EmployStat_m.Name = "EmployStat_m";
	Vector< Vector< int         > > Income_m(J1);		Income_m.Name     = "Income_m";
	Vector< Vector< int         > > Army_m(J1);			Army_m.Name       = "Army_m";
	Vector< Vector< int         > > Region_m(J1);		Region_m.Name     = "Region_m";
	Vector< Vector< int         > > Registered_m(J1);	Registered_m.Name = "Registered_m";
	Vector< Vector< int         > > Party_m(J1);		Party_m.Name      = "Party_m";
	Vector< Vector< int         > > Id_m(J1);			Id_m.Name         = "Id_m";
	Vector< Vector< int         > > CongDist_m(J1);		CongDist_m.Name   = "CongDist_m";
	Matrix< double                > X;
	{ /* To Save Memory */
		/* Load the RCS Data */
		DataFileDelim d("Exp_RCS.dat",'\t');
		int N = d.NumObs();
				                    Key              = d.Get< int               >("Key");
		                            Female           = d.Get< int               >("Female");
		                            Black            = d.Get< int               >("Black");
		                            Hispanic         = d.Get< int               >("Hispanic");
		                            Age              = d.Get< int               >("Age");
		Vector< int               > Age_Orig         = d.Get< int               >("Age_Orig");
		                            Educ             = d.Get< int               >("Educ");
		                            Married          = d.Get< int               >("Married");
		                            EmployStat       = d.Get< int               >("EmployStat");
		                            Income           = d.Get< int               >("Income");
		                            Army             = d.Get< int               >("Army");
		                            Region           = d.Get< int               >("Region");
		                            Registered       = d.Get< int               >("Registered");
		                            Party            = d.Get< int               >("Party");
		                            Id               = d.Get< int               >("Id");
		Vector< int               > Dma              = d.Get< int               >("Dma");
		Vector< int               > CongDist         = d.Get< int               >("CongDist");
		Vector< string            > Dma_CongDist     = d.Get< string            >("Dma") + Vector<string>(N,"_") + d.Get<string>("CongDist");
		Stack<string> ExposureDemLabels;
		for(int r=0; r<R; r++) ExposureDemLabels.Push("ExposureDem_" + ToString(r + 1));
		Stack<string> ExposureRepLabels;
		for(int r=0; r<R; r++) ExposureRepLabels.Push("ExposureRep_" + ToString(r + 1));
		Stack<string> ExposureOthLabels;
		for(int r=0; r<R; r++) ExposureOthLabels.Push("ExposureOth_" + ToString(r + 1));
		Matrix< DataPoint<double> > ExposureDem      = d.Get< DataPoint<double> >(ExposureDemLabels);
		Matrix< DataPoint<double> > ExposureRep      = d.Get< DataPoint<double> >(ExposureRepLabels);
		Matrix< DataPoint<double> > ExposureOth      = d.Get< DataPoint<double> >(ExposureOthLabels);
		Vector< DataPoint<double> > ExposurePresDem  = d.Get< DataPoint<double> >("ExposureDemPres");
		Vector< DataPoint<double> > ExposurePresRep  = d.Get< DataPoint<double> >("ExposureRepPres");
		Vector< DataPoint<double> > ExposurePresOth  = d.Get< DataPoint<double> >("ExposureOthPres");

		BGDma = Vector<bool>(N,False);
		for(int n=0; n<N; n++)
		{
			int Info = Search(Dma3,Dma(n));
			     if(BGDma3(Info) == "1") BGDma(n) = True;
			else if(BGDma3(Info) == "0") BGDma(n) = False;
			else
			{
				Print("Errir 09823409832433");
				HaltExecution();
			}
		}
		Vector< DataPoint<double> > ExposurePresTot  = ExposurePresDem + ExposurePresRep + ExposurePresOth;
		Vector< DataPoint<double> > ExposurePresDiff = ExposurePresRep - ExposurePresDem;
		SdExpDiff = StanDev(ExposurePresDiff).GetData() / 1000.0; // Save for later

		X = Matrix<double>(N,K);
		X.Name = "X";
		for(int n=0; n<N; n++)
		{
			int Curr = 0;
			X(n,Curr++) = One;
			X(n,Curr++) = Registered(n);
			X(n,Curr++) = Id(n);
			X(n,Curr++) = Black(n);
			X(n,Curr++) = Educ(n);
			X(n,Curr++) = Age(n);
			X(n,Curr++) = Female(n);
		}

		/* Find Observations to Drop */
		Vector<bool> Drop(N,False);
		for(int n=0; n<N; n++)
		{
			if(ExposureDem(n,0).IsMissing()) Drop(n) = True;
			if(ExposureRep(n,0).IsMissing()) Drop(n) = True;
			if(ExposureOth(n,0).IsMissing()) Drop(n) = True;
		}

		/* Count Sample in Each Complete CD */
		NrcsTot = 0;
		Nrcs = Vector<int>(J1,0);
		for(int n=0; n<N; n++)
		{
			int Info = BinarySearch(CdDmaList,Dma_CongDist(n));
			if(Info >= 0 && !Drop(n))
			{
				Nrcs(Info)++;
				NrcsTot++;
			}
		}

		Print("Loading Fac.dat...");
		Timer tm;
		tm.Start();
		Fac = Matrix<float>(N,P);
		Fac.Name = "Fac";
		Vector<string> Index(N);
		Input("Fac.dat",Index,Fac);
		tm.Stop();

		/* Partition RCS Survey by CD/DMA */
		Xrcs         = Vector< Matrix<double> >(J1);	Xrcs.Name         = "Xrcs";
		eTot_rcs     = Vector< Matrix<double> >(J1);	eTot_rcs.Name     = "eTot_rcs";
		eDem_rcs     = Vector< Matrix<double> >(J1);	eDem_rcs.Name     = "eDem_rcs";
		eRep_rcs     = Vector< Matrix<double> >(J1);	eRep_rcs.Name     = "eRep_rcs";
		for(int j=0; j<J1; j++)
		{
			Xrcs(j)         = Matrix<double>(Nrcs(j),K);	Xrcs(j).Name = "Xrcs(" + ToString(j) + ")";
			Key_m(j)        = Vector<int   >(Nrcs(j));		Key_m(j).Name        = "Key_m("        + ToString(j) + ")";
			Female_m(j)     = Vector<int   >(Nrcs(j));		Female_m(j).Name     = "Female_m("     + ToString(j) + ")";
			Black_m(j)      = Vector<int   >(Nrcs(j));		Black_m(j).Name      = "Black_m("      + ToString(j) + ")";
			Hispanic_m(j)   = Vector<int   >(Nrcs(j));		Hispanic_m(j).Name   = "Hispanic_m("   + ToString(j) + ")";
			Age_m(j)        = Vector<int   >(Nrcs(j));		Age_m(j).Name        = "Age_m("        + ToString(j) + ")";
			Educ_m(j)       = Vector<int   >(Nrcs(j));		Educ_m(j).Name       = "Educ_m("       + ToString(j) + ")";
			Married_m(j)    = Vector<int   >(Nrcs(j));		Married_m(j).Name    = "Married_m("    + ToString(j) + ")";
			EmployStat_m(j) = Vector<int   >(Nrcs(j));		EmployStat_m(j).Name = "EmployStat_m(" + ToString(j) + ")";
			Income_m(j)     = Vector<int   >(Nrcs(j));		Income_m(j).Name     = "Income_m("     + ToString(j) + ")";
			Army_m(j)       = Vector<int   >(Nrcs(j));		Army_m(j).Name       = "Army_m("       + ToString(j) + ")";
			Region_m(j)     = Vector<int   >(Nrcs(j));		Region_m(j).Name     = "Region_m("     + ToString(j) + ")";
			Registered_m(j) = Vector<int   >(Nrcs(j));		Registered_m(j).Name = "Registered_m(" + ToString(j) + ")";
			Party_m(j)      = Vector<int   >(Nrcs(j));		Party_m(j).Name      = "Party_m("      + ToString(j) + ")";
			Id_m(j)         = Vector<int   >(Nrcs(j));		Id_m(j).Name         = "Id_m("         + ToString(j) + ")";
			CongDist_m(j)   = Vector<int   >(Nrcs(j));		CongDist_m(j).Name   = "CongDist_m("   + ToString(j) + ")";
			Fac_m(j)        = Matrix<float >(Nrcs(j),P);	Fac_m(j).Name        = "Fac_m("        + ToString(j) + ")";
			eTot_rcs(j)     = Matrix<double>(Nrcs(j),R);	eTot_rcs(j).Name = "eTot_rcs(" + ToString(j) + ")";
			eDem_rcs(j)     = Matrix<double>(Nrcs(j),R);	eDem_rcs(j).Name = "eDem_rcs(" + ToString(j) + ")";
			eRep_rcs(j)     = Matrix<double>(Nrcs(j),R);	eRep_rcs(j).Name = "eRep_rcs(" + ToString(j) + ")";
		}

		Vector<int> Curr(J1,0);
		Curr.Name = "Curr";
		for(int n=0; n<N; n++)
		{
			int j = BinarySearch(CdDmaList,Dma_CongDist(n));
			if(j >= 0 && !Drop(n))
			{
				for(int k=0; k<K; k++) Xrcs(j)(Curr(j),k) = X(n,k);
				for(int r=0; r<R; r++)
				{
					eTot_rcs(j)(Curr(j),r) = (ExposureDem(n,r).GetData() + ExposureRep(n,r).GetData() + ExposureOth(n,r).GetData()) / 1000.0;
					eDem_rcs(j)(Curr(j),r) = ExposureDem(n,r).GetData() / 1000.0;
					eRep_rcs(j)(Curr(j),r) = ExposureRep(n,r).GetData() / 1000.0;
				}
				Key_m(j)(Curr(j)) = Key(n);
				Female_m(j)(Curr(j)) = Female(n);
				Black_m(j)(Curr(j)) = Black(n);
				Hispanic_m(j)(Curr(j)) = Hispanic(n);
				Age_m(j)(Curr(j)) = Age(n);
				Educ_m(j)(Curr(j)) = Educ(n);
				Married_m(j)(Curr(j)) = Married(n);
				EmployStat_m(j)(Curr(j)) = EmployStat(n);
				Income_m(j)(Curr(j)) = Income(n);
				Army_m(j)(Curr(j)) = Army(n);
				Region_m(j)(Curr(j)) = Region(n);
				Registered_m(j)(Curr(j)) = Registered(n);
				Party_m(j)(Curr(j)) = Party(n);
				Id_m(j)(Curr(j)) = Id(n);
				CongDist_m(j)(Curr(j)) = CongDist(n);
				for(int p=0; p<P; p++) Fac_m(j)(Curr(j),p) = Fac(n,p);
				Curr(j)++;
			}
		}

		/* *******************
	   	   Table 3 -- Exposure
	       ******************* */

		Print("Writing Table 3...");
		out1t << "\n";
		out1t << "\\begin{table}[htp]\\centering \n";
		out1t << "\\begin{singlespace} \n";
		out1t << "\\begin{footnotesize} \n";
		out1t << "\\begin{tabular}{ l c c c c } \\hline \\hline \n";
		out1t << "&\\multicolumn{2}{c}{\\textbf{Rating}} & \\textbf{Non-BG} & \\textbf{BG} \\\\ \n";
		out1t << "&\\multicolumn{2}{c}{\\textbf{Media Markets}} & \\textbf{Media Markets} & \\textbf{Media Market} \\\\ \n";
		out1t << " & \\textit{average} & \\textit{stan. dev.} & \\textit{average} & \\textit{average} \\\\ \n";

		out1t << "\\textbf{Democratic Candidate}";
		out1t << " & " << Round(Mean(ExposurePresDem));
		out1t << " & " << Round(StanDev(ExposurePresDem));
		out1t << " & " << Round(Mean(Subset(ExposurePresDem,!BGDma)));
		out1t << " & " << Round(Mean(Subset(ExposurePresDem,BGDma)));
		out1t << "\\\\ \n";

		out1t << "\\textbf{Republican Candidate}";
		out1t << " & " << Round(Mean(ExposurePresRep));
		out1t << " & " << Round(StanDev(ExposurePresRep));
		out1t << " & " << Round(Mean(Subset(ExposurePresRep,!BGDma)));
		out1t << " & " << Round(Mean(Subset(ExposurePresRep,BGDma)));
		out1t << "\\\\ \n";

		out1t << "\\textbf{Total Ad Exposure}";
		out1t << " & " << Round(Mean(ExposurePresTot));
		out1t << " & " << Round(StanDev(ExposurePresTot));
		out1t << " & " << Round(Mean(Subset(ExposurePresTot,!BGDma)));
		out1t << " & " << Round(Mean(Subset(ExposurePresTot,BGDma)));
		out1t << "\\\\ \n";

		out1t << "\\textbf{Difference in Ad Exposure}";
		out1t << " & " << Round(Mean(ExposurePresDiff));
		out1t << " & " << Round(StanDev(ExposurePresDiff));
		out1t << " & " << Round(Mean(Subset(ExposurePresDiff,!BGDma)));
		out1t << " & " << Round(Mean(Subset(ExposurePresDiff,BGDma)));
		out1t << "\\\\ \n";

		out1t << "\\hline \\hline \n";
		out1t << "\\end{tabular} \n";
		out1t << "\\end{footnotesize} \n";
		out1t << "\\end{singlespace} \n";
		out1t << "\\caption{\\footnotesize{Exposure to Presidential Ads -- Average and standard deviation in exposure of ads by the presidential candidates in battleground and non-battleground media markets. A media market was considered a battleground if at least 75\\% of the voting-age population in the media market resided in a battleground state. The following states were considered battleground: CO, FL, IA, MI, MN, NH, NM, NV, OH, OR, PA, and WI.}} \n";
		out1t << "\\label{ExposureTable} \n";
		out1t << "\\end{table} \n";
	} /* End Save Memory */

	/* Set Up Estimation Object */
	Matrix<double> A(M,KTheta,Zero);	A.Name = "A";
	Vector<double> b(M,Zero);			b.Name = "b";
	int m = 0;
	A(m,0)   = One;	b(m) = Zero;	m++;
	A(m,K)   = One;	b(m) = Zero;	m++;
	A(m,K+1) = One;	b(m) = Zero;	m++;
	A(m,2)   = One;	b(m) = Zero;	m++;
	if(Check != 1)
	{
		A(m,2*K+1) = One;	b(m) = One;	m++;
		A(m,2*K+3) = One;	b(m) = One;	m++;
	}

	MEst mest(LogProb1,Nep,KTheta);
	#ifdef _KNITRO
		mest.Method = 3;
	#else
		mest.Method = 1;
	#endif
	mest.AddConstraints(A,b,M,0);
	Copy(mest.ThetaLabels,ThetaLabels);;
	mest.MaxIter = 1000;

	/* Save Results when Looping Over Multiple Imputed Data */
	Matrix< double                      > ThetaMat1(R,KTheta);          // Estimates, No FE
	Matrix< DataPoint<double>           > ThetaSeMat1(R,KTheta);        // Standard Errors, No FE
	Matrix< DataPoint<double>           > ThetaVarMat1(R,KTheta);       // Variances, No FE
	Matrix< double                      > ThetaMat2(R,KTheta);          // Estimates, FE
	Matrix< DataPoint<double>           > ThetaSeMat2(R,KTheta);        // Standard Errors, FE
	Matrix< DataPoint<double>           > ThetaVarMat2(R,KTheta);       // Variances, FE
	Matrix< DataPoint<double>           > TurnoutMarginalEffects(R,3);  // Turnout MEs
	Matrix< DataPoint<double>           > RepShareMarginalEffects(R,3); // Rep. Share MEs
	Matrix< DataPoint<double>           > ShowTurnoutAll(P,R);          // Turnout for TV Shows
	Matrix< DataPoint<double>           > ShowRepShareAll(P,R);         // Rep. Share for TV Shows
	Vector< Matrix< DataPoint<double> > > MEByShowAll(R);               // Marginal Effects by Show
	Vector< Matrix< DataPoint<double> > > MEByShowCostAll(R);           // Cost Marginal Effects by Show
	for(Glob_r=0; Glob_r<R; Glob_r++) // Loop Over Imputations
	{
		/* Estimate w/o Fixed Effects */
		Opt = 1;

		/* Initial Points */
		Set(mest.Theta,Zero);
		for(int k=2*K+1; k<2*K+2; k++) mest.Theta(k) = One;
		for(int k=2*K+3; k<2*K+4; k++) mest.Theta(k) = One;
		if(UseSavedStartVals)
		{
			Matrix<double> ThetaMat0(5,KTheta);
			Input("ThetaMat_1.dat",ThetaMat0);
			for(int k=0; k<KTheta; k++) mest.Theta(k) = ThetaMat0(Glob_r,k);
		}

		/* Optimize */
		if(!UseSavedSes)
		{
			mest.Solve();
			mest.Inference();
			Print("mest.Theta",mest.Theta);
			Print("mest.ThetaSe",mest.ThetaSe);
			for(int k=0; k<KTheta; k++)
			{
				ThetaMat1(Glob_r,k)    = mest.Theta(k);
				ThetaSeMat1(Glob_r,k)  = mest.ThetaSe(k);
				ThetaVarMat1(Glob_r,k) = Sqr(ThetaSeMat1(Glob_r,k));
			}
		}
		else
		{
			Matrix<double> ThetaMat0(5,KTheta,Zero);
			Matrix<double> ThetaSeMat0(5,KTheta,Zero);
			Input("ThetaMat_1.dat",ThetaMat0);
			Input("ThetaSeMat_1.dat",ThetaSeMat0);
			for(int k=0; k<KTheta; k++)
			{
				ThetaMat1(Glob_r,k)    = ThetaMat0(Glob_r,k);
				ThetaSeMat1(Glob_r,k)  = ThetaSeMat0(Glob_r,k);
				ThetaVarMat1(Glob_r,k) = Sqr(ThetaSeMat1(Glob_r,k));
			}
		}

		/* Estimate w/ Fixed Effects */
		Opt = 2;

		/* Initial Points */
		Set(mest.Theta,Zero);
		for(int k=2*K+1; k<2*K+2; k++) mest.Theta(k) = One;
		for(int k=2*K+3; k<2*K+4; k++) mest.Theta(k) = One;
		if(UseSavedStartVals)
		{
			Matrix<double> ThetaMat0(5,KTheta);
			Input("ThetaMat_2.dat",ThetaMat0);
			for(int k=0; k<KTheta; k++) mest.Theta(k) = ThetaMat0(Glob_r,k);
		}

		/* Optimize */
		if(!UseSavedSes)
		{
			mest.Solve();
			mest.Inference();
			Print("mest.Theta",mest.Theta);
			Print("mest.ThetaSe",mest.ThetaSe);
			for(int k=0; k<KTheta; k++)
			{
				ThetaMat2(Glob_r,k) = mest.Theta(k);
				ThetaSeMat2(Glob_r,k) = mest.ThetaSe(k);
				ThetaVarMat2(Glob_r,k) = Sqr(ThetaSeMat2(Glob_r,k));
			}
		}
		else
		{
			Matrix<double> ThetaMat0(5,KTheta,Zero);
			Matrix<double> ThetaSeMat0(5,KTheta,Zero);
			Input("ThetaMat_2.dat",ThetaMat0);
			Input("ThetaSeMat_2.dat",ThetaSeMat0);
			for(int k=0; k<KTheta; k++)
			{
				ThetaMat2(Glob_r,k) = ThetaMat0(Glob_r,k);
				ThetaSeMat2(Glob_r,k) = ThetaSeMat0(Glob_r,k);
				ThetaVarMat2(Glob_r,k) = Sqr(ThetaSeMat2(Glob_r,k));
			}
		}

		/* Compute Estimated Fixed Effects for Model */
		Curr = 0;
		for(int k=0; k<K; k++) Beta_t(k) = mest.Theta(Curr++);
		for(int k=0; k<K; k++) Beta_v(k) = mest.Theta(Curr++);
		Alpha_t = mest.Theta(Curr++);
		Rho_t   = mest.Theta(Curr++);
		Alpha_v = mest.Theta(Curr++);
		Rho_v   = mest.Theta(Curr++);
		for(int j=0; j<J1; j++)
		{
			Glob_j = j;

			Solve1D s_t(Func1_t);
			s_t.TolX = TolX;
			s_t.Method = 4;
			int Info_t = s_t.Solve(-1000.0,1000.0);
			if(Info_t)
			{
				Print("Error-- did not converge (t)");
				Print("Info_t",Info_t);
				Print("j",j);
				Print("s_t_Emp(j)",s_t_Emp(j));
				Print("s_v_Emp(j)",s_v_Emp(j));
				Print("Func1_t(-1000.0)",Func1_t(-1000.0));
				Print("Func1_t(1000.0)",Func1_t(1000.0));
				HaltExecution();
			}
			Psi_t(j) = s_t.x;

			Solve1D s_v(Func1_v);
			s_v.TolX = TolX;
			s_v.Method = 4;
			int Info_v = s_v.Solve(-1000.0,1000.0);
			if(Info_v)
			{
				Print("Error-- did not converge (v)");
				Print("Info_v",Info_v);
				Print("j",j);
				Print("s_t_Emp(j)",s_t_Emp(j));
				Print("s_v_Emp(j)",s_v_Emp(j));
				Print("Func1_v(-1000.0)",Func1_v(-1000.0));
				Print("Func1_v(1000.0)",Func1_v(1000.0));
				HaltExecution();
			}
			Psi_v(j) = s_v.x;
		}

		/* Compute Marginal Effects of Exposure (in GRPs) */
		Print("Computing Marginal Effects...");

		/* Benchmark */
		Matrix<double> p0(NrcsTot,3);
		Curr = 0;
		for(int j=0; j<J1; j++) for(int n=0; n<Nrcs(j); n++)
		{
			double Temp_t = Psi_t(j);
			for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xrcs(j)(n,k);
			if(Check != 2) Temp_t += Alpha_t * pow(eTot_rcs(j)(n,Glob_r),Rho_t);
			else           Temp_t += Alpha_t * log(LogConst + eTot_rcs(j)(n,Glob_r));

			double Temp_v = Psi_v(j);
			for(int k=0; k<K; k++) Temp_v += Beta_v(k) * Xrcs(j)(n,k);
			if(Check != 2) Temp_v += Alpha_v * pow(eRep_rcs(j)(n,Glob_r),Rho_v);
			else           Temp_v += Alpha_v * log(LogConst + eRep_rcs(j)(n,Glob_r));
			if(Check != 2) Temp_v -= Alpha_v * pow(eDem_rcs(j)(n,Glob_r),Rho_v);
			else           Temp_v -= Alpha_v * log(LogConst + eDem_rcs(j)(n,Glob_r));

			double Probit_t = NormalCdf(Temp_t);
			double Probit_v = NormalCdf(Temp_v);

			p0(Curr,0) = (One - Probit_t);
			p0(Curr,1) = Probit_t * (One - Probit_v);
			p0(Curr,2) = Probit_t * Probit_v;
			Curr++;
		}

		/* Add Dem. Exposure */
		Matrix<double> pDp(NrcsTot,3);
		Curr = 0;
		for(int j=0; j<J1; j++) for(int n=0; n<Nrcs(j); n++)
		{
			double Temp_t = Psi_t(j);
			for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xrcs(j)(n,k);
			if(Check != 2) Temp_t += Alpha_t * pow(eTot_rcs(j)(n,Glob_r) + SdExpDiff,Rho_t);
			else           Temp_t += Alpha_t * log(LogConst + eTot_rcs(j)(n,Glob_r) + SdExpDiff);

			double Temp_v = Psi_v(j);
			for(int k=0; k<K; k++) Temp_v += Beta_v(k) * Xrcs(j)(n,k);
			if(Check != 2) Temp_v += Alpha_v * pow(eRep_rcs(j)(n,Glob_r),Rho_v);
			else           Temp_v += Alpha_v * log(LogConst + eRep_rcs(j)(n,Glob_r));
			if(Check != 2) Temp_v -= Alpha_v * pow(eDem_rcs(j)(n,Glob_r) + SdExpDiff,Rho_v);
			else           Temp_v -= Alpha_v * log(LogConst + eDem_rcs(j)(n,Glob_r) + SdExpDiff);

			double Probit_t = NormalCdf(Temp_t);
			double Probit_v = NormalCdf(Temp_v);

			pDp(Curr,0) = (One - Probit_t);
			pDp(Curr,1) = Probit_t * (One - Probit_v);
			pDp(Curr,2) = Probit_t * Probit_v;
			Curr++;
		}

		/* Add Rep. Exposure */
		Matrix<double> pRp(NrcsTot,3);
		Curr = 0;
		for(int j=0; j<J1; j++) for(int n=0; n<Nrcs(j); n++)
		{
			double Temp_t = Psi_t(j);
			for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xrcs(j)(n,k);
			if(Check != 2) Temp_t += Alpha_t * pow(eTot_rcs(j)(n,Glob_r) + SdExpDiff,Rho_t);
			else           Temp_t += Alpha_t * log(LogConst + eTot_rcs(j)(n,Glob_r) + SdExpDiff);

			double Temp_v = Psi_v(j);
			for(int k=0; k<K; k++) Temp_v += Beta_v(k) * Xrcs(j)(n,k);
			if(Check != 2) Temp_v += Alpha_v * pow(eRep_rcs(j)(n,Glob_r) + SdExpDiff,Rho_v);
			else           Temp_v += Alpha_v * log(LogConst + eRep_rcs(j)(n,Glob_r) + SdExpDiff);
			if(Check != 2) Temp_v -= Alpha_v * pow(eDem_rcs(j)(n,Glob_r),Rho_v);
			else           Temp_v -= Alpha_v * log(LogConst + eDem_rcs(j)(n,Glob_r));

			double Probit_t = NormalCdf(Temp_t);
			double Probit_v = NormalCdf(Temp_v);

			pRp(Curr,0) = (One - Probit_t);
			pRp(Curr,1) = Probit_t * (One - Probit_v);
			pRp(Curr,2) = Probit_t * Probit_v;
			Curr++;
		}

		Vector<double> Baseline = Mean(p0);
		Vector<double> AddDem   = Mean(pDp);
		Vector<double> AddRep   = Mean(pRp);

		Print("Baseline",Baseline);
		Print("Add Dem. Exposure",AddDem);
		Print("Add Rep. Exposure",AddRep);

		TurnoutMarginalEffects(Glob_r,0) = One - Baseline(0);
		TurnoutMarginalEffects(Glob_r,1) = One - AddDem(0);
		TurnoutMarginalEffects(Glob_r,2) = One - AddRep(0);

		RepShareMarginalEffects(Glob_r,0) = Baseline(2) / (Baseline(1) + Baseline(2));
		RepShareMarginalEffects(Glob_r,1) = AddDem(2)   / (AddDem(1)   + AddDem(2));
		RepShareMarginalEffects(Glob_r,2) = AddRep(2)   / (AddRep(1)   + AddRep(2));

		/* Latent Turnout/Rep. Share Variables for NAES RCS Sample */
		Vector<double> Pred0Cdf_t(NrcsTot);	Pred0Cdf_t.Name = "Pred0Cdf_t";
		Vector<double> Pred0Cdf_v(NrcsTot);	Pred0Cdf_v.Name = "Pred0Cdf_v";
		Curr = 0;
		for(int j=0; j<J1; j++) for(int n=0; n<Nrcs(j); n++)
		{
			double Temp_t = Psi_t(j);
			for(int k=0; k<K; k++) Temp_t += Beta_t(k) * Xrcs(j)(n,k);

			double Temp_v = Psi_v(j);
			for(int k=0; k<K; k++) Temp_v += Beta_v(k) * Xrcs(j)(n,k);

			Pred0Cdf_t(Curr) = NormalCdf(Temp_t);
			Pred0Cdf_v(Curr) = NormalCdf(Temp_v);

			Curr++;
		}

		/* Array Indicating with Individual n Watched Show p */
		Print("Computing Watch Matrix...");
		Timer tm;
		tm.Start();
		Watch = Vector< Matrix<bool> >(J1);	Watch.Name = "Watch";
		for(int j=0; j<J1; j++)
		{
			Watch(j) = Matrix<bool>(Nrcs(j),P,False);
			Watch(j).Name = "Watch(" + ToString(j) + ")";
		}

		for(int p=0; p<P; p++)
		{
			if(Error(p) == 0)
			{
				for(int j=0; j<J1; j++) for(int n=0; n<Nrcs(j); n++)
				{
					if(UniformSample(RandomSeed) < Fac_m(j)(n,p)) Watch(j)(n,p) = True;
					else   										  Watch(j)(n,p) = False;
				}
			}
		}
		tm.Stop();

		Print("Outputing Show Predictions...");
		tm.Start();
		if(Opt == 2)
		{
			for(int p=0; p<P; p++)
			{
				if(   Show(p) == "CAVUTO ON BUSINESS (FOX NEWS)"
				   || Show(p) == "60 MINUTES (CBS)"
				   || Show(p) == "STEVE HARVEY")
				{
					ofstream out_Pred2(("Pred_" + Show(p) + "_" + ToString(Glob_r + 1) + ".dat").c_str());
					out_Pred2 << "Key" << "\t";
					out_Pred2 << "t0Cdf" << "\t";
					out_Pred2 << "v0Cdf" << "\n";
					int Curr = 0;
					for(int j=0; j<J1; j++) for(int n=0; n<Nrcs(j); n++)
					{
						if(Watch(j)(n,p))
						{
							out_Pred2 << Key_m(j)(n) << "\t";
							out_Pred2 << Pred0Cdf_t(Curr) << "\t";
							out_Pred2 << Pred0Cdf_v(Curr) << "\n";
						}
						Curr++;
					}
					out_Pred2.close();
				}
			}
		}
		tm.Stop();

		/* Compute Marginal Effects by Show */
		if(Opt == 2)
		{
			Print("Computing Marginal Effects by Show...");
			tm.Start();

			Vector<double> aDem(P);	// Dem. Ads
			Vector<double> aRep(P);	// Rep. Ads
			Vector<double> aOth(P);	// Other Ads
			Matrix< DataPoint<double> > MEByShow(P,2);		MEByShow.Name     = "MEByShow";
			Matrix< DataPoint<double> > MEByShowCost(P,2);	MEByShowCost.Name = "MEByShowCost";
			for(int p=0; p<P; p++)
			{
				if(p % 50 == 0) Print("p",p);
				if(Error(p) == 0)
				{
					const double Delta = 0.003; // 300 GRPs
					Matrix<double> Mu(J1,2);
					Matrix<double> Mu2(J1,2);
					for(int j=0; j<J1; j++)
					{
						if(NoAds(p) != "YES")
						{
							Glob_j = j;

							Vector<double> F0(3);
							Func3(Zero,Zero,p,F0);

							Vector<double> FDp(3);
							Func3(Delta / Rating(p),Zero,p,FDp);

							Vector<double> FRp(3);
							Func3(Zero,Delta / Rating(p),p,FRp);

							Mu(j,0) = FDp(2) / (FDp(1) + FDp(2)) - F0(2) / (F0(1) + F0(2)); // Dp, vote share
							Mu(j,1) = FRp(2) / (FRp(1) + FRp(2)) - F0(2) / (F0(1) + F0(2)); // Rp, vote share

							Vector<double> MeanMu = Mean(Mu);
							for(int i=0; i<2; i++) MEByShow(p,i) = MeanMu(i);

							// Change vs. Cost
							if(!CostByShow(p,j).IsMissing())
							{
								const double Delta2 = Delta * CostByCdDma(j,0); // 3 Early Morning GRPs

								Vector<double> FDp2(3);
								Func3(Delta2 / (Rating(p) * CostByShow(p,j).GetData()),Zero,p,FDp2);

								Vector<double> FRp2(3);
								Func3(Zero,Delta2 / (Rating(p) * CostByShow(p,j).GetData()),p,FRp2);

								Mu2(j,0) = FDp2(2) / (FDp2(1) + FDp2(2)) - F0(2) / (F0(1) + F0(2));
								Mu2(j,1) = FRp2(2) / (FRp2(1) + FRp2(2)) - F0(2) / (F0(1) + F0(2));

								Vector<double> MeanMu2 = Mean(Mu2);
								for(int i=0; i<2; i++) MEByShowCost(p,i) = MeanMu2(i);
							}
						}
					}
				}
			}
			MEByShowAll(Glob_r)     = MEByShow;
			MEByShowCostAll(Glob_r) = MEByShowCost;
			tm.Stop();
		}

		/* Show Map */
		Print("Plotting Show Map...");
		tm.Start();
		Vector< DataPoint<double> > ShowTurnout(P);		ShowTurnout.Name  = "ShowTurnout";
		Vector< DataPoint<double> > ShowRepShare(P);	ShowRepShare.Name = "ShowRepShare";
		for(int p=0; p<P; p++)
		{
			if(p % 50 == 0) Print("p",p);
			if(Error(p) == 0) // Some missing data if MDE failed to converge
			{
				int Curr   = 0;
				double Den = Zero;
				ShowTurnout(p) = Zero;
				ShowRepShare(p) = Zero;
				for(int j=0; j<J1; j++) for(int n=0; n<Nrcs(j); n++)
				{
					Den     += Fac_m(j)(n,p);
					ShowTurnout(p) += Fac_m(j)(n,p) * Pred0Cdf_t(Curr);
					ShowRepShare(p) += Fac_m(j)(n,p) * Pred0Cdf_v(Curr);
					Curr++;
				}
				ShowTurnout(p) /= Den;
				ShowRepShare(p) /= Den;
			}
		}

		for(int p=0; p<P; p++)
		{
			ShowTurnoutAll(p,Glob_r) = ShowTurnout(p);
			ShowRepShareAll(p,Glob_r) = ShowRepShare(p);
		}
		tm.Stop();
	} /* End MI Loop */

	/* Save Results */
	OutputPrecision = 12;
	Output("ThetaMat_1.dat",ThetaMat1);     // Estimates, No FE
	Output("ThetaSeMat_1.dat",ThetaSeMat1); // Standard Errors, No FE
	Output("ThetaMat_2.dat",ThetaMat2);     // Estimates, w/ FE
	Output("ThetaSeMat_2.dat",ThetaSeMat2); // Standard Errors, w/ FE

	/* Combine Imputations and Get Standard Errors */
	Print("Combining Imputations...");
	Matrix< DataPoint<double>           > ThetaAll(KTheta,2);
	Matrix< DataPoint<double>           > ThetaSeAll(KTheta,2);
	Matrix< DataPoint<int>              > ThetaDfAll(KTheta,2);
	Matrix< string                      > ThetaStars(KTheta,2);
	{
		Vector<double> Theta = Mean(ThetaMat1);
		Vector< DataPoint<double> > ThetaAvgVar = Mean(ThetaVarMat1);
		Vector< DataPoint<double> > ThetaVar = To<double ,DataPoint<double> >(ToVector(Diag(Var(ThetaMat1))));
		Vector< DataPoint<double> > ThetaSe = Sqrt(ThetaAvgVar + (DataPoint<double>(One) + DataPoint<double>(One / R)) * ThetaVar);
		Vector< DataPoint<int> > ThetaDf(KTheta);
		for(int k=0; k<KTheta; k++)
		{
			DataPoint<double> Temp = (double)(R - 1) * Sqr(One + ((double)R / (R + 1)) * ThetaAvgVar(k) / ThetaVar(k));
			if(!Temp.IsMissing())
			{
				if(Temp.GetData() > INT_MAX) Temp = INT_MAX; // prevent overflow
				ThetaDf(k) = (int)Temp.GetData();
			}
			else
			{
				ThetaDf(k).SetToMissing();
			}
		}
		for(int k=0; k<KTheta; k++)
		{
			ThetaAll(k,0)   = Theta(k);
			ThetaSeAll(k,0) = ThetaSe(k);
			ThetaDfAll(k,0) = ThetaDf(k);
			if(!ThetaSe(k).IsMissing() && ! ThetaDf(k).IsMissing())
			{
				ThetaStars(k,0) = StudentStars(Theta(k),ThetaSe(k).GetData(),ThetaDf(k).GetData());
			}
			else
			{
				ThetaStars(k,0) = "";
			}
		}
	}
	{
		Vector<double> Theta = Mean(ThetaMat2);
		Vector< DataPoint<double> > ThetaAvgVar = Mean(ThetaVarMat2);
		Vector< DataPoint<double> > ThetaVar = To<double ,DataPoint<double> >(ToVector(Diag(Var(ThetaMat2))));
		Vector< DataPoint<double> > ThetaSe = Sqrt(ThetaAvgVar + (DataPoint<double>(One) + DataPoint<double>(One / R)) * ThetaVar);
		Vector< DataPoint<int> > ThetaDf(KTheta);
		for(int k=0; k<KTheta; k++)
		{
			DataPoint<double> Temp = (double)(R + 1) * Sqr(One + ((double)R / (R + 1)) * ThetaAvgVar(k) / ThetaVar(k));
			if(!Temp.IsMissing())
			{
				if(Temp.GetData() > INT_MAX) Temp = INT_MAX; // prevent overflow
				ThetaDf(k) = (int)Temp.GetData();
			}
			else
			{
				ThetaDf(k).SetToMissing();
			}
		}
		for(int k=0; k<KTheta; k++)
		{
			ThetaAll(k,1)   = Theta(k);
			ThetaSeAll(k,1) = ThetaSe(k);
			ThetaDfAll(k,1) = ThetaDf(k);
			if(!ThetaSe(k).IsMissing() && ! ThetaDf(k).IsMissing())
			{
				ThetaStars(k,1) = StudentStars(Theta(k),ThetaSe(k).GetData(),ThetaDf(k).GetData());
			}
			else
			{
				ThetaStars(k,1) = "";
			}
		}
	}

	/* **********************************
	   Table 4 -- Main Estimation Results
	   ********************************** */

	Print("Outputting Table 4...");

	Matrix<string> ThetaEntry(KTheta,2);
	for(int k=0; k<KTheta; k++) for(int l=0; l<2; l++)
		ThetaEntry(k,l) = Round(ThetaAll(k,l),3) + ThetaStars(k,l) + " (" + Round(ThetaSeAll(k,l),3) + ")";

	out1t << "\n";
	out1t << "\\begin{table}[htp]\\centering \n";
	out1t << "\\begin{singlespace} \n";
	out1t << "\\begin{footnotesize} \n";
	out1t << "\\begin{tabular}{ l c c } \\hline \\hline \n";
	out1t << " & (1) & (2) \\\\ \n";
	out1t << "\\textbf{Turnout:} \\\\ \n";
	if(Check != 2) out1t << "\\hspace{.4cm}Total Ad Exposures & " << ThetaEntry(14,0) << " & " <<ThetaEntry(14,1) << "\\\\ \n";
	else           out1t << "\\hspace{.4cm}log(" << LogConst << " + Total Ad Exposures) & " << ThetaEntry(14,0) << " & " <<ThetaEntry(14,1) << "\\\\ \n";
	if(Check == 1) out1t << "\\hspace{.4cm}$\rho_t$ & " << ThetaEntry(15,0) << " & " <<ThetaEntry(15,1) << "\\\\ \n";
	out1t << "\\hspace{.4cm}Registered & "         << ThetaEntry(1,0)  << " & " <<ThetaEntry(1,1)  << "\\\\ \n";
	out1t << "\\hspace{.4cm}Black & "              << ThetaEntry(3,0)  << " & " <<ThetaEntry(3,1)  << "\\\\ \n";
	out1t << "\\hspace{.4cm}Education & "          << ThetaEntry(4,0)  << " & " <<ThetaEntry(4,1)  << "\\\\ \n";
	out1t << "\\hspace{.4cm}Age & "                << ThetaEntry(5,0)  << " & " <<ThetaEntry(5,1)  << "\\\\ \n";
	out1t << "\\hspace{.4cm}Female & "             << ThetaEntry(6,0)  << " & " <<ThetaEntry(6,1)  << "\\\\ \n";
	out1t << "\\textbf{Voting:} \\\\ \n";
	if(Check != 2) out1t << "\\hspace{.4cm}Advantage in Ad Exposures & " << ThetaEntry(16,0) << " & " <<ThetaEntry(16,1) << "\\\\ \n";
	else           out1t << "\\hspace{.4cm}log(" << LogConst << " + Rep. Exp.) - log(" << LogConst << " + Dem. Exp.) & " << ThetaEntry(16,0) << " & " <<ThetaEntry(16,1) << "\\\\ \n";
	if(Check == 1) out1t << "\\hspace{.4cm}$\rho_v$ & " << ThetaEntry(17,0) << " & " <<ThetaEntry(17,1) << "\\\\ \n";
	out1t << "\\hspace{.4cm}Ideology & "                  << ThetaEntry(9,0)  << " & " << ThetaEntry(9,1) << "\\\\ \n";
	out1t << "\\hspace{.4cm}Black & "                     << ThetaEntry(10,0) << " & " <<ThetaEntry(10,1) << "\\\\ \n";
	out1t << "\\hspace{.4cm}Education & "                 << ThetaEntry(11,0) << " & " <<ThetaEntry(11,1) << "\\\\ \n";
	out1t << "\\hspace{.4cm}Age & "                       << ThetaEntry(12,0) << " & " <<ThetaEntry(12,1) << "\\\\ \n";
	out1t << "\\hspace{.4cm}Female & "                    << ThetaEntry(13,0) << " & " <<ThetaEntry(13,1) << "\\\\ \n";
	out1t << "\\textbf{Fixed Effects?} & No  & Yes \\\\ \n";
	out1t << "\\textbf{N} & " << Nep << " & " << Nep << "\\\\ \n";
	out1t << "\\hline \\hline \n";
	out1t << "\\end{tabular} \n";
	out1t << "\\caption{\\footnotesize{Main Estimation Results -- One star indicates statistical significance at the 5\\% level. Two stars indicates statistical significance at the 1\\% level. Three stars indicates statistical significance at the 0.1\\% level. A plus sign indicates statistical significance at the 10\\% level. Statistical significance is calculated based on the t-distribution, as suggested by \\cite{Rubin87}. The sample is restricted to NAES respondents who reside in the one of the top 100 media markets because ad exposure can only be estimated for these individuals. In column (2), 460 fixed effects are included in the model.}} \n";
	out1t << "\\label{MainResultsTable} \n";
	out1t << "\\end{footnotesize} \n";
	out1t << "\\end{singlespace} \n";
	out1t << "\\end{table} \t";

	/* ***************************
	   Table 5 -- Marginal Effects
	   *************************** */

	Print("Outputting Table 5...");
	OutputPrecision = 1;
	{
		Vector< DataPoint<double> > TurnoutTemp = DataPoint<double>(100.0) * Mean(TurnoutMarginalEffects);
		Vector< DataPoint<double> > RepShareTemp = DataPoint<double>(100.0) * Mean(RepShareMarginalEffects);
		out1t << "\n";
		out1t << "\\begin{table}[htp]\\centering \n";
		out1t << "\\begin{singlespace} \n";
		out1t << "\\begin{tabular}{ l c c c } \\hline \\hline \n";
		out1t << "\\textbf{Scenario} & \\textbf{Turnout} & \\textbf{Rep. Vote Share}\\\\ \n";
		out1t << "Baseline & " << Round(TurnoutTemp(0),1) << "\\% & " << Round(RepShareTemp(0),1) << "\\% & \\\\ \n";
		out1t << "Dem. Exposure Increased (One Sd.) & " << Round(TurnoutTemp(1),1) << "\\% & " << Round(RepShareTemp(1),1) << "\\% & \\\\ \n";
		out1t << "Rep. Exposure Increased (One Sd.) & " << Round(TurnoutTemp(2),1) << "\\% & " << Round(RepShareTemp(2),1) << "\\% & \\\\ \n";
		out1t << "\\hline \\hline \n";
		out1t << "\\end{tabular} \n";
		out1t << "\\end{singlespace} \n";
		out1t << "\\caption{\\footnotesize{Marginal Effects of Advertising Exposure -- marginal effects are calculated based on changing the advertising exposure for all individuals in the sample by one standard deviation. The standard deviation of the difference between Republican and Democratic exposure is equal to " << Round(1000.0*SdExpDiff) << " ads.}} \n";
		out1t << "\\label{MarginalEffectsTable} \n";
		out1t << "\\end{table} \n";
	}

	/* Average Over Imputations -- Opt == 2 Only */
	Matrix< DataPoint<double> > MEByShowAvg(P,2,Zero);
	Matrix< DataPoint<double> > MEByShowCostAvg(P,2,Zero);
	Vector< DataPoint<double> > ShowTurnoutAvg(P);
	Vector< DataPoint<double> > ShowRepShareAvg(P);
	for(int p=0; p<P; p++) for(int i=0; i<2; i++)
	{
		for(int r=0; r<R; r++)
		{
			MEByShowAvg(p,i)     += MEByShowAll(r)(p,i)     / (double)R;
			MEByShowCostAvg(p,i) += MEByShowCostAll(r)(p,i) / (double)R;
		}
	}
	for(int p=0; p<P; p++)
	{
		ShowTurnoutAvg(p) = Zero;
		ShowRepShareAvg(p) = Zero;
		for(int r=0; r<R; r++)
		{
			ShowTurnoutAvg(p)  += ShowTurnoutAll(p,r)  / (double)R;
			ShowRepShareAvg(p) += ShowRepShareAll(p,r) / (double)R;
		}
	}

	/* Average Marginal Effects by Party (used for sorting tables 6, 7, and 8 */
	Vector< double            > TotGRP(P);
	Vector< DataPoint<double> > DemEff(P); // Effectiveness
	Vector< DataPoint<double> > RepEff(P);
	Vector< DataPoint<double> > TotEff(P);
	Vector< DataPoint<double> > DemCostEff(P); // Cost Effectiveness
	Vector< DataPoint<double> > RepCostEff(P);
	Vector< DataPoint<double> > TotCostEff(P);
	for(int p=0; p<P; p++)
	{
		TotGRP(p) = GRPDemPresByProgram(p) + GRPRepPresByProgram(p);
		DemEff(p) = MEByShowAvg(p,0);
		RepEff(p) = MEByShowAvg(p,1);
		DemCostEff(p) = MEByShowCostAvg(p,0);
		RepCostEff(p) = MEByShowCostAvg(p,1);
		TotEff(p)     = 0.5 * (-DemEff(p)     + RepEff(p)    );
		TotCostEff(p) = 0.5 * (-DemCostEff(p) + RepCostEff(p));
	}

	/* Output Show Data for r --- Used for all figures except figure 2 */
	Print("Outputting Show Map...");
	{
		OutputPrecision = 6;

		ofstream out1("ShowMap.dat");

		out1 << "Show" << "\t";
		out1 << "Day Part" << "\t";
		out1 << "Rating" << "\t";
		out1 << "Registered" << "\t";
		out1 << "Net. Con." << "\t";
		out1 << "Turnout" << "\t";
		out1 << "Rep. Share" << "\t";
		out1 << "Dem. Ads" << "\t";
		out1 << "Rep. Ads" << "\t";
		out1 << "Tot. Ads" << "\t";
		out1 << "Dem. GRPs" << "\t";
		out1 << "Rep. GRPs" << "\t";
		out1 << "Tot. GRPs" << "\t";
		out1 << "Dem. Spending" << "\t";
		out1 << "Rep. Spending" << "\t";
		out1 << "Tot. Spending" << "\t";
		out1 << "Dem+ M.E." << "\t";
		out1 << "Rep+ M.E." << "\t";
		out1 << "Avg. M.E." << "\t";
		out1 << "Dem+ Cost M.E." << "\t";
		out1 << "Rep+ Cost M.E." << "\t";
		out1 << "Avg. Cost M.E." << "\n";

		for(int p=0; p<P; p++)
		{
			out1 << Show(p) << "\t";
			out1 << DayPart(p) << "\t";
			out1 << Rating(p) << "\t";
			out1 << RegisteredVert(p) << "\t";
			out1 << NetConVert(p) << "\t";
			out1 << ShowTurnoutAvg(p) << "\t";
			out1 << ShowRepShareAvg(p) << "\t";
			out1 << AdsDemPresByProgram(p) << "\t";
			out1 << AdsRepPresByProgram(p) << "\t";
			out1 << AdsDemPresByProgram(p) + AdsRepPresByProgram(p) << "\t";
			out1 << GRPDemPresByProgram(p) << "\t";
			out1 << GRPRepPresByProgram(p) << "\t";
			out1 << GRPDemPresByProgram(p) + GRPRepPresByProgram(p) << "\t";
			out1 << SpendDemPresByProgram(p) << "\t";
			out1 << SpendRepPresByProgram(p) << "\t";
			out1 << SpendDemPresByProgram(p) + SpendRepPresByProgram(p) << "\t";
			out1 << DemEff(p) << "\t";
			out1 << RepEff(p) << "\t";
			out1 << TotEff(p) << "\t";
			out1 << DemCostEff(p) << "\t";
			out1 << RepCostEff(p) << "\t";
			out1 << TotCostEff(p) << "\n";
		}

		out1.close();
	}

	/* Prepare for Show Targeting Tables */
	Vector<double> TotEff2(P);
	Vector<double> TotCostEff2(P);
	for(int p=0; p<P; p++)
	{
		if(!TotEff(p).IsMissing()    ) TotEff2(p) = TotEff(p).GetData();
		else                           TotEff2(p)     = -Inf; // Missing at the end

		if(!TotCostEff(p).IsMissing()) TotCostEff2(p) = TotCostEff(p).GetData();
		else                           TotCostEff2(p) = -Inf; // Missing at the end
	}

	/* Shorten Some Show Names */
	for(int p=0; p<P; p++)
	{
		     if(Show(p) == "LOCAL NEWS ON YOUR ABC STATION - AFTERNOON"    ) Show(p) = "ABC LOCAL NEWS - AFTERNOON";
		else if(Show(p) == "LOCAL NEWS ON YOUR CBS STATION - AFTERNOON"    ) Show(p) = "CBS LOCAL NEWS - AFTERNOON";
		else if(Show(p) == "LOCAL NEWS ON YOUR NBC STATION - AFTERNOON"    ) Show(p) = "NBC LOCAL NEWS - AFTERNOON";
		else if(Show(p) == "LOCAL NEWS ON YOUR ABC STATION - EARLY EVENING") Show(p) = "ABC LOCAL NEWS - EARLY EVENING";
		else if(Show(p) == "LOCAL NEWS ON YOUR CBS STATION - EARLY EVENING") Show(p) = "CBS LOCAL NEWS - EARLY EVENING";
		else if(Show(p) == "LOCAL NEWS ON YOUR NBC STATION - EARLY EVENING") Show(p) = "NBC LOCAL NEWS - EARLY EVENING";
		else if(Show(p) == "LOCAL NEWS ON YOUR ABC STATION - MORNING"      ) Show(p) = "ABC LOCAL NEWS - MORNING";
		else if(Show(p) == "LOCAL NEWS ON YOUR CBS STATION - MORNING"      ) Show(p) = "CBS LOCAL NEWS - MORNING";
		else if(Show(p) == "LOCAL NEWS ON YOUR NBC STATION - MORNING"      ) Show(p) = "NBC LOCAL NEWS - MORNING";
		else if(Show(p) == "LOCAL NEWS ON YOUR ABC STATION - LATE EVENING" ) Show(p) = "ABC LOCAL NEWS - LATE EVENING";
		else if(Show(p) == "LOCAL NEWS ON YOUR CBS STATION - LATE EVENING" ) Show(p) = "CBS LOCAL NEWS - LATE EVENING";
		else if(Show(p) == "LOCAL NEWS ON YOUR NBC STATION - LATE EVENING" ) Show(p) = "NBC LOCAL NEWS - LATE EVENING";
		else if(Show(p) == "THE TONIGHT SHOW W/ JAY LENO (NBC)"            ) Show(p) = "THE TONIGHT SHOW W/ LENO (NBC)";
		else if(Show(p) == "THIS WEEK W/ GEORGE STEPHANOPOULOS (ABC)"      ) Show(p) = "THIS WEEK W/ STEPH. (ABC)";
		else if(Show(p) == "CHAMPIONS TOUR (FORMERLY SENIOR PGA)"          ) Show(p) = "CHAMPIONS TOUR (SENIOR PGA)";
		else if(Show(p) == "NBC NIGHTLY NEWS W/ TOM BROKAW"                ) Show(p) = "NBC NIGHTLY NEWS W/ BROKAW";
		else if(Show(p) == "NEWSNIGHT W/ AARON BROWN (CNN)"                ) Show(p) = "NEWSNIGHT W/ BROWN (CNN)";
		else if(Show(p) == "CBS MENS COLLEGE BASKETBALL GAMES"           ) Show(p) = "CBS MENS COLLEGE BASKETBALL";
		else if(Show(p) == "ABC MENS COLLEGE BASKETBALL GAMES"           ) Show(p) = "ABC MENS COLLEGE BASKETBALL";
	}

	/* ************************************
	   Table 6 -- Most Cost Effective Shows
	   ************************************ */

	Print("Outputting Table 6...");
	SortBy(TotCostEff2,Show,DayPart,Rating,ShowTurnoutAvg,ShowRepShareAvg,TotGRP,DemEff,RepEff,DemCostEff,RepCostEff,TotEff2);
	{
		int Last = P - 1;
		while(TotCostEff2(Last) == -Inf && Last > 0) Last--;

		out1t << "\n";
		out1t << "\\begin{table}[htp]\\centering \n";
		out1t << "\\begin{singlespace} \n";
		out1t << "\\begin{footnotesize} \n";
		out1t << "\\begin{tabular}{ r l c c c c c c c } \\hline \\hline \n";
		out1t << " & \\textbf{Show} & \\textbf{Day} & \\textbf{Rating} & \\textbf{Turnout} & \\textbf{Rep.} & \\textbf{Total} & \\multicolumn{2}{c}{\\textbf{Cost Eff.}} \\\\ \n";
		out1t << "& & \\textbf{Part} &  &  & \\textbf{Share} & \\textbf{Ads} & \\textit{Dem.} & \\textit{Rep.} \\\\ \n";

		for(int i=Last; i>=Last-20+1; i--)
		{
			out1t << Last - i + 1                        << " & ";
			out1t << ReplaceFirst(Show(i),"&","\\&")     << " & ";
			out1t << DayPart(i)                          << " & ";
			out1t << Round(100.0 * Rating(i)     ,1)     << " & ";
			out1t << Round(100.0 * ShowTurnoutAvg(i),1)  << "\\% & ";
			out1t << Round(100.0 * ShowRepShareAvg(i),1) << "\\% & ";
			out1t << Round(TotGRP(i),1)                  << " & ";
			out1t << Round(100.0 * DemCostEff(i),2)      << "\\% & ";
			out1t << Round(100.0 * RepCostEff(i),2)      << "\\% \\\\ \n";
		}

		out1t << "\\hline \\hline \n";
		out1t << "\\end{tabular} \n";
		out1t << "\\end{footnotesize} \n";
		out1t << "\\end{singlespace} \n";
		out1t << "\\caption{\\footnotesize{Shows where Advertising is Most Cost-Effective.}} \n";
		out1t << "\\label{MostCostEffectiveTable} \n";
		out1t << "\\end{table} \n";
		out1t << "\\end{document} \n";
	}
}

int main()
{
	Print("Begin");

	/* Prepare Data Step 1: Estimate the Exposure Model */
	Prepare1();
	xTilde = Matrix<int>(0,0);  // This global variable is big, so the free memory
	qTilde = Vector<double>(0); // This global variable is big, so the free memory

	/* Prepare Data Step 2: Impute Ad Exposure in NAES */
	Prepare2();

	/* Estimate Turnout/Choice Model, Compute Marginal Effects, and Create Tables */
	Estimate();

	Print("End");
	return 0;
}